/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "About.h"

AboutDlg::AboutDlg ( QString ver, QWidget* parent, Qt::WindowFlags f )
{
	if ( parent != NULL ) {setParent ( parent );}
	if ( f != NULL ) {setWindowFlags ( f );}
	setObjectName ( QString::fromUtf8 ( "Dialog" ) );
	setFixedSize ( 480, 150 );
	QPixmap pix ( ":/backB" );
	setMask ( pix.mask() );
	setStyleSheet ( ".AboutDlg{background: url(':/backB');} QPushButton#pushButton_2, QPushButton#pushButton{border-image: url(\":/button\") 3 10 3 10;border-width: 3;} QPushButton#pushButton_2:pressed, QPushButton#pushButton:pressed {border-image: url(\":/button-pressed\") 3 10 3 10;border-width: 3;color: white;} .label{text: white;}" );

	verticalLayout = new QVBoxLayout ( this );
	verticalLayout->setObjectName ( QString::fromUtf8 ( "verticalLayout" ) );

	horizontalLayout_2 = new QHBoxLayout();
	horizontalLayout_2->setObjectName ( QString::fromUtf8 ( "horizontalLayout_2" ) );

	label_2 = new QLabel ( this );
	label_2->setObjectName ( QString::fromUtf8 ( "label_2" ) );
	label_2->setAlignment(Qt::AlignCenter);

	horizontalLayout_2->addWidget ( label_2 );

	label = new QLabel ( this );
	label->setObjectName ( QString::fromUtf8 ( "label" ) );

	horizontalLayout_2->addWidget ( label );

	verticalLayout->addLayout ( horizontalLayout_2 );

	horizontalLayout = new QHBoxLayout();
	horizontalLayout->setObjectName ( QString::fromUtf8 ( "horizontalLayout" ) );

	pushButton = new QPushButton ( this );
	pushButton->setObjectName ( QString::fromUtf8 ( "pushButton" ) );
	pushButton->setFixedSize ( 86, 29 );
	horizontalLayout->addWidget ( pushButton );

	horizontalSpacer = new QSpacerItem ( 40, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );

	horizontalLayout->addItem ( horizontalSpacer );

	pushButton_2 = new QPushButton ( this );
	pushButton_2->setObjectName ( QString::fromUtf8 ( "pushButton_2" ) );
	pushButton_2->setFixedSize ( 86, 29 );
	horizontalLayout->addWidget ( pushButton_2 );

	verticalLayout->addLayout ( horizontalLayout );

	setWindowTitle ( QApplication::translate ( "Dialog", "About PdfTk-QGUI", 0, QApplication::UnicodeUTF8 ) );
	label->setText ( "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\" \"http://www.w3.org/TR/REC-html40/strict.dtd\">\n"
	                 "<html><head><meta name=\"qrichtext\" content=\"1\" /><style type=\"text/css\">\n"
	                 "p, li { white-space: pre-wrap; }\n"
	                 "</style></head><body style=\"color: #a6ce39; font-family:'DejaVu Serif'; font-size:11pt; font-weight:400; font-style:normal;\">\n"
	                 "<p align=\"center\" style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"> " + tr ( "PdfTk-QGUI v %1" ).arg ( ver ) +"    </p>\n"
	                 "<p style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\">PdfTk-QGUI is a GUI for <a href=\"http://www.accesspdf.com/pdftk/\"><span style=\" text-decoration: underl"
	                 "ine; color:white;\">PdfTk</span></a> written in Qt.</p>"
	                 "<p style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\">"+tr ( "Author: Koptsow Dmitriy" ) +" (<a href=\"mailto:suslic-2012@rambler.ru\"><span style=\" text-decoration: underl"
	                 "ine; color:white;\">suslic-2012@rambler.ru</span></a>)</p>\n"
	                 "<p style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\">"+tr ( "You can always get latest version at " ) +"</p>\n"
	                 "<p style=\" margin-top:0px; margin-bottom:0px; margin-left:0px; margin-right:0px; -qt-block-indent:0; text-indent:0px;\"><a href=\"http://suslic-2012.narod.ru/PDFTKGUI.html\"><span style=\" text-decoration: underline; color:white;\">suslic-2012.narod.ru</span></a></p></body></html>" );
	label_2->setPixmap ( QPixmap ( ":/main" ) );
	/*label_2->setText("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0//EN\" \"http://www.w3.org/TR/REC-html40/strict.dtd\">\n"
	                 "<html><head><meta name=\"qrichtext\" content=\"1\" /><style type=\"text/css\">\n"
	                 "p, li { white-space: pre-wrap; }\n"
	                 "</style></head><body style=\"color: #a6ce39; font-family:'DejaVu Serif'; font-size:11pt; font-weight:400; font-style:normal;\">\n"
			"<a href=\"test\"><img src=\":/main\" align=center></a></body></html>");*/
	pushButton->setText ( QApplication::translate ( "Dialog", "About &Qt", 0, QApplication::UnicodeUTF8 ) );
	pushButton_2->setText ( QApplication::translate ( "Dialog", "&Close", 0, QApplication::UnicodeUTF8 ) );
	connect ( pushButton_2, SIGNAL ( clicked() ), this, SLOT ( accept() ) );
	connect ( pushButton, SIGNAL ( clicked() ), this, SLOT ( onQT() ) );
}
void AboutDlg::onQT()
{
	QMessageBox::aboutQt ( this, "About Qt" );
}
AboutDlg::~AboutDlg() {destroy();}
