/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "Attach.h"

Attach::Attach ( QWidget* parent, Qt::WindowFlags f, QString filename, int PageNUM, QString bg )
{
	if ( parent != NULL ) {setParent ( parent );}
	if ( f != NULL ) {setWindowFlags ( f );}
	apage = new int[0];apageB = new int[0];apageNUM = 0;
	homeP = QDir().homePath();
	this->setObjectName ( QString::fromUtf8 ( "Attach" ) );
	this->setFixedSize ( 411, 268 );
	FilesList = new QListWidget ( this );
	FilesList->setObjectName ( QString::fromUtf8 ( "FilesList" ) );
	FilesList->setGeometry ( QRect ( 10, 50, 181, 211 ) );
	add_button = new QPushButton ( this );
	add_button->setObjectName ( QString::fromUtf8 ( "add_button" ) );
	add_button->setGeometry ( QRect ( 10, 10, 131, 27 ) );
	remove_button = new QPushButton ( this );
	remove_button->setObjectName ( QString::fromUtf8 ( "remove_button" ) );
	remove_button->setGeometry ( QRect ( 259, 10, 121, 27 ) );
	groupBox = new QGroupBox ( this );
	groupBox->setObjectName ( QString::fromUtf8 ( "groupBox" ) );
	groupBox->setGeometry ( QRect ( 200, 110, 190, 91 ) );
	layoutWidget = new QWidget ( groupBox );
	layoutWidget->setObjectName ( QString::fromUtf8 ( "layoutWidget" ) );
	layoutWidget->setGeometry ( QRect ( 10, 20, 161, 61 ) );
	gridLayout = new QGridLayout ( layoutWidget );
	gridLayout->setObjectName ( QString::fromUtf8 ( "gridLayout" ) );
	gridLayout->setContentsMargins ( 0, 0, 0, 0 );
	label = new QLabel ( layoutWidget );
	label->setObjectName ( QString::fromUtf8 ( "label" ) );

	gridLayout->addWidget ( label, 0, 0, 1, 1 );

	nameLabel = new QLabel ( layoutWidget );
	nameLabel->setObjectName ( QString::fromUtf8 ( "nameLabel" ) );

	gridLayout->addWidget ( nameLabel, 0, 1, 1, 1 );

	label_2 = new QLabel ( layoutWidget );
	label_2->setObjectName ( QString::fromUtf8 ( "label_2" ) );

	gridLayout->addWidget ( label_2, 1, 0, 1, 1 );

	pageLabel = new QLabel ( layoutWidget );
	pageLabel->setObjectName ( QString::fromUtf8 ( "pageLabel" ) );

	gridLayout->addWidget ( pageLabel, 1, 1, 1, 1 );

	groupBox_2 = new QGroupBox ( this );
	groupBox_2->setObjectName ( QString::fromUtf8 ( "groupBox_2" ) );
	groupBox_2->setGeometry ( QRect ( 200, 40, 190, 61 ) );
	page_spin = new QSpinBox ( groupBox_2 );
	page_spin->setObjectName ( QString::fromUtf8 ( "page_spin" ) );
	page_spin->setGeometry ( QRect ( 20, 20, 141, 23 ) );
	CAB = new QPushButton ( this );
	CAB->setObjectName ( QString::fromUtf8 ( "CAB" ) );
	CAB->setGeometry ( QRect ( 210, 220, 80, 27 ) );
	OKB = new QPushButton ( this );
	OKB->setObjectName ( QString::fromUtf8 ( "OKB" ) );
	OKB->setGeometry ( QRect ( 310, 220, 80, 27 ) );
	OKB->setEnabled ( false );
/////////////////
	connect ( page_spin, SIGNAL ( valueChanged ( int ) ), this, SLOT ( SetPage ( int ) ) );
	connect ( CAB, SIGNAL ( clicked() ), this, SLOT ( onCAB() ) );
	connect ( OKB, SIGNAL ( clicked() ), this, SLOT ( on_OK() ) );
	connect ( FilesList, SIGNAL ( itemClicked ( QListWidgetItem * ) ), this , SLOT ( on_List ( QListWidgetItem * ) ) );
	connect ( add_button, SIGNAL ( clicked() ), this, SLOT ( on_Add() ) );
	connect ( remove_button, SIGNAL ( clicked() ), this, SLOT ( on_Remove() ) );
/////////////////
	this->setWindowTitle ( QApplication::translate ( "Attach", "Attach", 0, QApplication::UnicodeUTF8 ) );
	this->setWindowIcon ( QIcon ( ":/attach" ) );
	add_button->setText ( QApplication::translate ( "Attach", "Add File(s)", 0, QApplication::UnicodeUTF8 ) );
	remove_button->setText ( QApplication::translate ( "Attach", "Remove", 0, QApplication::UnicodeUTF8 ) );
	groupBox->setTitle ( QApplication::translate ( "Attach", "File info:", 0, QApplication::UnicodeUTF8 ) );
	label->setText ( QApplication::translate ( "Attach", "File name", 0, QApplication::UnicodeUTF8 ) );
	nameLabel->setText ( QApplication::translate ( "Attach", "----------", 0, QApplication::UnicodeUTF8 ) );
	label_2->setText ( QApplication::translate ( "Attach", "Pages", 0, QApplication::UnicodeUTF8 ) );
	pageLabel->setText ( QApplication::translate ( "Attach", "---------", 0, QApplication::UnicodeUTF8 ) );
	groupBox_2->setTitle ( QApplication::translate ( "Attach", "Assign to page:", 0, QApplication::UnicodeUTF8 ) );
	CAB->setText ( QApplication::translate ( "Attach", "Cancel", 0, QApplication::UnicodeUTF8 ) );
	OKB->setText ( QApplication::translate ( "Attach", "OK", 0, QApplication::UnicodeUTF8 ) );
////////////////////////////////////////////////
	page_spin->setMinimum ( 1 );
	Allpage = PageNUM;
	nameLabel->setText ( filename );
	pageLabel->setText ( tr ( "%1" ).arg ( Allpage ) );
	page_spin->setMaximum ( Allpage );
}
void Attach::on_Add()
{
	QStringList files = QFileDialog::getOpenFileNames ( this, tr ( "Select files to attach" ),homeP );
	if ( !files.isEmpty() )
	{
		int SIZE = files.size();
		qDebug() <<"initial SIZE = "<<SIZE;
		bool check;
		int rSIZE = SIZE;
		QStringList filesCP ( files );
		for ( int i = 0;i<SIZE;i++ )
		{

			filesCP[i] = checkPath ( "attach", files[i], "", this, &check, true );
			if ( filesCP[i].isEmpty() )
			{
				filesCP.removeAt ( i );files.removeAt ( i );
				rSIZE--;
			}
		}
		SIZE = rSIZE;
		if ( SIZE == 0 ) return;
		apageNUM+=SIZE;
		qDebug() <<"SIZE= "<<SIZE<<" apageNUM = "<<apageNUM;
		apageB = apage;
		apage = new int[apageNUM];
		for ( int i=0;i<apageNUM-SIZE;i++ ) {apage[i] = apageB[i];qDebug() <<"apage["<<i<<"] ="<<apage[i];}
		for ( int i=apageNUM-SIZE;i<apageNUM;i++ ) {apage[i] = 1;qDebug() <<"apage["<<i<<"] ="<<apage[i];}
		FilesList->addItems ( files );
		FilesList->setCurrentRow ( FilesList->count()-1 );
		page_spin->setValue(1);
		fileL<<filesCP;
		OKB->setEnabled ( true );
	}
}
void Attach::on_Remove()
{
	QListWidgetItem* curItem = FilesList->currentItem();
	if ( curItem != NULL )
	{
		QString  str = curItem->text();
		int A = fileL.indexOf ( str );
		if ( A != -1 )
		{
			fileL.removeAt ( A );
			delete FilesList->takeItem ( FilesList->currentRow() );
			apageNUM-=1;
			apageB = apage;
			for ( int i=0;i<A;i++ ) {apage[i] = apageB[i];qDebug() <<"apage["<<i<<"] ="<<apage[i];}
			for ( int i=A;i<apageNUM;i++ )
				{apage[i] = apageB[i+1];qDebug() <<"apage["<<i<<"] ="<<apage[i];}
		}
	}
	if ( FilesList->count() == 0 ) OKB->setEnabled ( false );
}
void Attach::on_List ( QListWidgetItem * item )
{
	QString str = item->text();
	QStringList strL = str.split ( "/" );
	nameLabel->setText ( strL.last() );
	pageLabel->setText ( tr ( "%1" ).arg ( apage[FilesList->row ( item ) ] ) );
	page_spin->setValue ( apage[FilesList->currentRow() ] );
}
void Attach::on_OK() {accept();}
void Attach::onCAB() {qDebug() <<"CAB";reject();}
void Attach::SetPage ( int i )
{
	if ( FilesList->currentRow() >=0 )
	{
		apage[FilesList->currentRow() ] = i;
		qDebug() <<"apage["<<FilesList->currentRow() <<"] = "<<i;
	}
}
Attach::~Attach() {destroy();}
