/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "suslictk.h"
void SuslicTk::onAttach ( QString ifile )
{
	if ( !tkPresent )
	{
		QMessageBox::warning ( this, tr ( "Error" ), tr ( "This action cannot be performed without pdftk binary! Please, install pdftk and specify it's location in Preferences." ) );
		return;
	}
	QString filePDF;
	if ( ifile.isEmpty() ) filePDF = QFileDialog::getOpenFileName ( this, tr ( "Select PDF file" ),lastdir, tr ( "PDF Files (*.pdf)" ) );
	else filePDF = ifile;
	QString IFILE = filePDF;
	onSetDir ( getDirFromFile ( filePDF ) );
	bool okc;
	filePDF = checkPath ( filePDF, "attach_to", &okc );
	qDebug() <<okc;
	qDebug() <<"lastdir = "<<lastdir;
	int PAGENUM;
	QString sNum;
	if ( filePDF.isEmpty() ) return;
	else
	{
		bool passcorr = true;
		QString StartString = pdftkBin+" \""+filePDF+"\" dump_data output -";
		proc = new QProcess ( this );
		proc->start ( StartString );
		addTextPEc ( StartString );
		if ( !proc->waitForStarted() ) {qDebug() <<"Could not start";}
		if ( !proc->waitForFinished() ) {qDebug() <<"Could not finish";}
		proc->closeWriteChannel();
		QString sErr = proc->readAllStandardError();
		sNum = proc->readAllStandardOutput();
		addTextPE ( sNum+"<br>"+sErr );
		if ( !sErr.isEmpty() )
		{
			if ( sErr.contains ( "OWNER PASSWORD" ) )
			{
				bool cont = false;
				while ( !cont )
				{
					QMessageBox::warning ( this, tr ( "Attention" ), tr ( "Owner password required!<br>No/incorrect password given" ) );
					if ( QMessageBox::question ( this, tr ( "Input password" ), tr ( "Do you want to input password?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes )
					{
						QString paStr = QInputDialog::getText ( this, tr ( "Password" ), tr ( "Input password" ), QLineEdit::Password, "" );
						if ( paStr.isEmpty() ) {cont = true;passcorr = false;}
						else
						{
							StartString = pdftkBin+" \""+filePDF+"\" input_pw \""+paStr+"\" dump_data output -";
							proc = new QProcess ( this );
							proc->start ( StartString );
							addTextPEc ( StartString );
							if ( !proc->waitForStarted() ) {qDebug() <<"Could not start";}
							if ( !proc->waitForFinished() ) {qDebug() <<"Could not finish";}
							proc->closeWriteChannel();
							sErr = proc->readAllStandardError();
							sNum = proc->readAllStandardOutput();
							addTextPE ( sNum+"<br>"+sErr );
							if ( !sErr.isEmpty() && sErr.contains ( "OWNER PASSWORD" ) ) {}
							if ( !sErr.isEmpty() && !sErr.contains ( "OWNER PASSWORD" ) ) {cont = true;passcorr = false;}
							if ( sErr.isEmpty() )
							{
								cont = true;passcorr = true;
								QString tt  = QTime::currentTime().toString ( "hh_mm_ss" );
								proc = new QProcess ( this );
								QString procS = pdftkBin+" \""+filePDF+"\" input_pw \""+paStr+"\" output "+homePDF->absolutePath() +"/tmp_att_"+QFileInfo ( filePDF ).baseName() +tt+"_decrypted.pdf";
								proc->start ( procS );
								addTextPEc ( procS );
								proc->waitForStarted();
								proc->waitForFinished();
								if ( proc->exitCode() == 0 ) {filePDF = homePDF->absolutePath() +"/tmp_att_"+QFileInfo ( filePDF ).baseName() +tt +"_decrypted.pdf";}
								else{passcorr = false;}
							}
						}
					}
					else{cont = true;passcorr = false;}
				}
			}
			else{passcorr = false;}
		}
		else
		{
			filePDF = homePDF->absolutePath() +"/tmp_att_"+QFileInfo ( filePDF ).baseName() +QTime::currentTime().toString ( "hh_mm_ss" ) +".pdf";
			if ( !QFile().copy ( IFILE, filePDF ) )
			{
				qDebug() <<"cannot copy file";
				TE->setText ( TE->toHtml() +tr ( "<br>Failed to copy input pdf. Aborting..." ) );
				return;
			}
		}
		if ( passcorr )
		{
			qDebug() <<sNum;
			QStringList qsl = sNum.split ( "\n" ).filter ( "NumberOfPages" );
			int ii = qsl.count();
			QString Num;
			if ( ii==1 ) {Num = qsl.last().split ( " " ).last();}
			else{TE->setText ( TE->toHtml() +tr ( "<br>Can not get number of pages." ) );return;}
			bool ok;
			PAGENUM = Num.toInt ( &ok, 10 );
			if ( !ok ) {TE->setText ( TE->toHtml() +tr ( "<br>Can not get number of pages." ) );return;}
		}
		if ( !passcorr ) {TE->setText ( TE->toHtml() +tr ( "<br>Error: " ) +sErr );return;}
	}
/////////////////////////////
	qDebug() <<"PAGENUM = "<<PAGENUM;
	if ( index[2] >= 0 && index[2] < imgDB.count() ) {att = new Attach ( this, Qt::Dialog , QFileInfo ( filePDF ).fileName(), PAGENUM, imgDB[index[2]] );}
	else{att = new Attach ( this, Qt::Dialog , QFileInfo ( filePDF ).fileName(), PAGENUM, "" );}
	int res = att->exec();
	if ( res != 1 )
	{
		if ( !QFile().remove ( filePDF ) )
		{
			QMessageBox::warning ( this, tr ( "Attention" ), tr ( "Failed to remove temporary file! Check rights!" ) );
		}
		return;
	}
	QString *ss;
	ss = new QString[att->apageNUM];
	ss[0] = filePDF;
	if ( att->apageNUM > 2 )
	{
		prog_com = new QProgressDialog ( tr ( "Attaching files" ), tr ( "Cancel" ), 0, att->apageNUM - 1 , this );
		prog_com->show();
		prog_com->setWindowModality ( Qt::WindowModal );
		for ( int i=0;i< ( att->apageNUM - 1 );i++ )
		{
			prog_com->setValue ( i );
			if ( prog_com->wasCanceled() ) break;
			//QTime time = QTime::currentTime();
			ss[i+1] = homePDF->absolutePath() +"/tmp_att_tmp"+tr ( "%1" ).arg ( i ) +".pdf";
			QString RUN = pdftkBin+" \""+ss[i]+"\" attach_files \""+att->fileL[i]+"\" to_page "+tr ( "%1" ).arg ( att->apage[i] ) +" output \""+ss[i+1]+"\"";
			proc = new QProcess();
			proc->start ( RUN );
			addTextPEc ( RUN );
			if ( !proc->waitForStarted() ) {qDebug() <<"Couldn't start";prog_com->setValue ( att->apageNUM - 1 );return;}
			if ( !proc->waitForFinished ( 60000 ) ) {qDebug() <<"Not finished!";prog_com->setValue ( att->apageNUM - 1 );return;}
			addTextPE ( proc->readAllStandardOutput() +"<br>"+proc->readAllStandardError() );
			//sleep ( 0.1 );
		}
		if ( !prog_com->wasCanceled() )
		{
			prog_com->setLabelText ( tr ( "Creating document" ) );
			QString EFILE, EFILE_1;
			if ( !okc )
			{
				if ( QMessageBox::question ( this, "", tr ( "Create new document with attached files?\nIf you select 'No', input file will be overwritten!" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::No )
				{
					EFILE = IFILE;
					if ( !QFile().remove ( IFILE ) )
					{
						qDebug() <<"old file not deleted";
						QMessageBox::warning ( this, "", "Failed to replace input file!" );
						EFILE = QFileDialog::getSaveFileName ( this, tr ( "Save result as:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
						if ( !EFILE.isEmpty() && !EFILE.endsWith ( ".pdf", Qt::CaseInsensitive ) ) EFILE+=".pdf";
						EFILE_1 = checkSaveFile ( EFILE );
					}
				}
				else
				{
					EFILE = QFileDialog::getSaveFileName ( this, tr ( "Save result as:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
					if ( !EFILE.isEmpty() && !EFILE.endsWith ( ".pdf", Qt::CaseInsensitive ) ) EFILE+=".pdf";
					EFILE_1 = checkSaveFile ( EFILE );
				}
			}
			else
			{
				EFILE = QFileDialog::getSaveFileName ( this, tr ( "Save result as:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
				if ( !EFILE.isEmpty() && !EFILE.endsWith ( ".pdf", Qt::CaseInsensitive ) ) EFILE+=".pdf";
				EFILE_1 = checkSaveFile ( EFILE );
			}
			if ( EFILE.isEmpty() )
			{
				prog_com->setValue ( att->apageNUM - 1 );
				return;
			}
			onSetDir ( getDirFromFile ( EFILE ) );
			qDebug() <<"lastdir = "<<lastdir ;
			int aaa = att->apageNUM-1;
			QString RUN = pdftkBin+" \""+ss[aaa]+"\" attach_files \""+att->fileL[aaa]+"\" to_page "+tr ( "%1" ).arg ( att->apage[aaa] ) +" output \""+EFILE_1+"\"";
			qDebug() <<RUN ;
			proc = new QProcess();
			proc->start ( RUN );
			addTextPEc ( RUN );
			if ( !proc->waitForStarted() )
			{
				qDebug() <<"Couldn't start";
				prog_com->setValue ( att->apageNUM - 1 );
				return;
			}
			if ( !proc->waitForFinished ( 60000 ) )
			{
				qDebug() <<"Not finished!";
				prog_com->setValue ( att->apageNUM - 1 );
				return;
			}
			QString sErr = proc->readAllStandardError();
			addTextPE ( proc->readAllStandardOutput() +"<br>"+sErr );
			if ( sErr.isEmpty() )
			{
				if ( EFILE_1 != EFILE )
				{
					if ( copyEFILE ( EFILE_1, EFILE ) )	TE->setText ( TE->toHtml() +tr ( "<br>&raquo;Done!<br>&raquo;Output successfully saved to<br>&nbsp;&nbsp;" ) +EFILE );
				}
				else	TE->setText ( TE->toHtml() +tr ( "<br>&raquo;Done!<br>&raquo;Output successfully saved to<br>&nbsp;&nbsp;" ) +EFILE );
			}
			else
			{
				TE->setText ( TE->toHtml() +tr ( "<br><font color=red><b>Error!</b></font><br>" ) +sErr );
				QMessageBox::critical ( this, tr ( "Error!" ), tr ( "Unknown error occurred!<br>Output of the process:<br>%1" ).arg ( sErr ) );
			}
			prog_com->setValue ( att->apageNUM - 1 );

		}
	}
	else
	{
		for ( int i=0;i< ( att->apageNUM - 1 );i++ )
		{
			ss[i+1] = homePDF->absolutePath() +"/tmp_att_tmp"+tr ( "%1" ).arg ( i ) +".pdf";
			QString RUN = pdftkBin+" \""+ss[i]+"\" attach_files \""+att->fileL[i]+"\" to_page "+tr ( "%1" ).arg ( att->apage[i] ) +" output \""+ss[i+1]+"\"";
			proc = new QProcess();
			proc->start ( RUN );
			addTextPEc ( RUN );
			if ( !proc->waitForStarted() ) {qDebug() <<"Couldn't start";return;}
			if ( !proc->waitForFinished ( 60000 ) ) {qDebug() <<"Not finished!";return;}
			addTextPE ( proc->readAllStandardOutput() +"<br>"+proc->readAllStandardError() );
		}
		QString EFILE, EFILE_1;
		if ( !okc )
		{
			if ( QMessageBox::question ( this, "", tr ( "Create new document with attached files?\nIf you select 'No', input file will be overwritten!" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::No )
			{
				EFILE = IFILE;
				if ( !QFile().remove ( IFILE ) )
				{
					qDebug() <<"old file not deleted";
					QMessageBox::warning ( this, "", "Failed to replace input file!" );
					EFILE = QFileDialog::getSaveFileName ( this, tr ( "Save result as:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
					if ( !EFILE.isEmpty() && !EFILE.endsWith ( ".pdf", Qt::CaseInsensitive ) ) EFILE+=".pdf";
					EFILE_1 = checkSaveFile ( EFILE );
				}
			}
			else
			{
				EFILE = QFileDialog::getSaveFileName ( this, tr ( "Save result as:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
				if ( !EFILE.isEmpty() && !EFILE.endsWith ( ".pdf", Qt::CaseInsensitive ) ) EFILE+=".pdf";
				EFILE_1 = checkSaveFile ( EFILE );
			}
		}
		else
		{
			EFILE = QFileDialog::getSaveFileName ( this, tr ( "Save result as:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
			if ( !EFILE.isEmpty() && !EFILE.endsWith ( ".pdf", Qt::CaseInsensitive ) ) EFILE+=".pdf";
			EFILE_1 = checkSaveFile ( EFILE );
		}
		if ( EFILE.isEmpty() ) return;
		onSetDir ( getDirFromFile ( EFILE ) );
		qDebug() <<"lastdir = "<<lastdir ;
		int aaa = att->apageNUM-1;
		QString RUN = pdftkBin+" \""+ss[aaa]+"\" attach_files \""+att->fileL[aaa]+"\" to_page "+tr ( "%1" ).arg ( att->apage[aaa] ) +" output \""+EFILE_1+"\"";
		qDebug() <<RUN ;
		proc = new QProcess();
		proc->start ( RUN );
		addTextPEc ( RUN );
		if ( !proc->waitForStarted() )
		{
			qDebug() <<"Couldn't start";

			return;
		}
		if ( !proc->waitForFinished ( 60000 ) )
		{
			qDebug() <<"Not finished!";

			return;
		}
		QString sErr = proc->readAllStandardError();
		addTextPE ( proc->readAllStandardOutput() +"<br>"+sErr );
		if ( sErr.isEmpty() )
		{
			if ( EFILE_1 != EFILE )
			{
				if ( copyEFILE ( EFILE_1, EFILE ) )	TE->setText ( TE->toHtml() +tr ( "<br>&raquo;Done!<br>&raquo;Output successfully saved to<br>&nbsp;&nbsp;" ) +EFILE );
			}
			else	TE->setText ( TE->toHtml() +tr ( "<br>&raquo;Done!<br>&raquo;Output successfully saved to<br>&nbsp;&nbsp;" ) +EFILE );
		}
		else
		{
			TE->setText ( TE->toHtml() +tr ( "<br><font color=red><b>Error!</b></font><br>" ) +sErr );
			QMessageBox::critical ( this, tr ( "Error!" ), tr ( "Unknown error occurred!<br>Output of the process:<br>%1" ).arg ( sErr ) );
		}
	}
	QStringList cleanListA = homePDF->entryList();
	QStringList cleanList  =cleanListA.filter ( "tmp_att" );
	if ( !cleanList.isEmpty() )
	{
		//QString cleanStr = cleanList.join ( "<br>" );
		//if ( QMessageBox::question ( this, tr ( "Clean" ), tr ( "Do you want to delete temporary files?<br><b> Files to delete:<br>%2</b><br>from %1" ).arg ( homePDF->absolutePath() ).arg ( cleanStr ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes )
		//{
		for ( int j=0;j<cleanList.count();j++ )
		{

			//QMessageBox::information ( this, tr ( "To Clear" ), cleanList[j] );
			QFile file ( homePDF->absolutePath() +"/"+cleanList[j] );
			if ( !file.remove() ) {QMessageBox::critical ( this, tr ( "Cleaner" ), tr ( "Unable to remove " ) +file.fileName() );}

		}
		//}
	}
	delete att;
}
