/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "AutoF.h"

AutoF::AutoF ( QWidget* parent, Qt::WindowFlags f )
{
	if ( parent != NULL ) {setParent ( parent );}
	if ( f != NULL ) {setWindowFlags ( f );}

	setObjectName ( QString::fromUtf8 ( "AutoF" ) );
	verticalLayout = new QVBoxLayout ( this );
	verticalLayout->setObjectName ( QString::fromUtf8 ( "verticalLayout" ) );
	label = new QLabel ( this );
	label->setObjectName ( QString::fromUtf8 ( "label" ) );
	label->setAlignment ( Qt::AlignCenter );

	verticalLayout->addWidget ( label );

	textBrowser = new QTextBrowser(this);
	textBrowser->setObjectName ( QString::fromUtf8 ( "textBrowser" ) );
	textBrowser->setStyleSheet("QTextBrowser{background:black;color:white}");

	verticalLayout->addWidget ( textBrowser );

	horizontalLayout = new QHBoxLayout();
	horizontalLayout->setObjectName ( QString::fromUtf8 ( "horizontalLayout" ) );
	horizontalSpacer = new QSpacerItem ( 40, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );

	horizontalLayout->addItem ( horizontalSpacer );

	pushButton = new QPushButton ( this );
	pushButton->setObjectName ( QString::fromUtf8 ( "pushButton" ) );
	connect ( pushButton, SIGNAL ( clicked() ), this, SLOT ( onStop() ) );

	horizontalLayout->addWidget ( pushButton );

	horizontalSpacer_2 = new QSpacerItem ( 40, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );

	horizontalLayout->addItem ( horizontalSpacer_2 );


	verticalLayout->addLayout ( horizontalLayout );


	retranslateUi();
};
void AutoF::retranslateUi()
{
	setWindowTitle(QApplication::translate("AutoF", "Auto Find Dialog", 0, QApplication::UnicodeUTF8));
        label->setText(QApplication::translate("AutoF", "<b>Searching...</b>", 0, QApplication::UnicodeUTF8));
        pushButton->setText(QApplication::translate("AutoF", "&Stop", 0, QApplication::UnicodeUTF8));
}
void AutoF::writeOut(QString text)
{
textBrowser->setText(textBrowser->toPlainText()+"\n"+text);
}
void AutoF::onStop()
{
	emit stop();
	qDebug()<<"stop emitted";
	accept();
}
AutoF::~AutoF()
{
	destroy();
}
