/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "BackSel.h"

BackSel::BackSel ( QWidget* parent, Qt::WindowFlags f, QStringList* files , int *index )
{
	if ( parent != NULL ) {setParent ( parent );}
	if ( f != NULL ) {setWindowFlags ( f );}
	this->setObjectName ( QString::fromUtf8 ( "BackSel" ) );
	this->setFixedSize ( 400, 258 );
	layoutWidget = new QWidget ( this );
	layoutWidget->setObjectName ( QString::fromUtf8 ( "layoutWidget" ) );
	layoutWidget->setGeometry ( QRect ( 230, 220, 162, 31 ) );
	horizontalLayout = new QHBoxLayout ( layoutWidget );
	horizontalLayout->setObjectName ( QString::fromUtf8 ( "horizontalLayout" ) );
	horizontalLayout->setContentsMargins ( 0, 0, 0, 0 );
	CAB = new QPushButton ( layoutWidget );
	CAB->setObjectName ( QString::fromUtf8 ( "CAB" ) );

	horizontalLayout->addWidget ( CAB );

	OKB = new QPushButton ( layoutWidget );
	OKB->setObjectName ( QString::fromUtf8 ( "OKB" ) );

	horizontalLayout->addWidget ( OKB );

	groupBox = new QGroupBox ( this );
	groupBox->setObjectName ( QString::fromUtf8 ( "groupBox" ) );
	groupBox->setGeometry ( QRect ( 10, 10, 381, 201 ) );
	widget = new QWidget ( groupBox );
	widget->setObjectName ( QString::fromUtf8 ( "widget" ) );
	widget->setGeometry ( QRect ( 20, 22, 351, 161 ) );
	gridLayout = new QGridLayout ( widget );
	gridLayout->setObjectName ( QString::fromUtf8 ( "gridLayout" ) );
	gridLayout->setContentsMargins ( 0, 0, 0, 0 );
	label = new QLabel ( widget );
	label->setObjectName ( QString::fromUtf8 ( "label" ) );

	gridLayout->addWidget ( label, 0, 0, 1, 1 );

	catCombo = new QComboBox ( widget );
	catCombo->setObjectName ( QString::fromUtf8 ( "catCombo" ) );

	gridLayout->addWidget ( catCombo, 0, 1, 1, 1 );

	label_2 = new QLabel ( widget );
	label_2->setObjectName ( QString::fromUtf8 ( "label_2" ) );

	gridLayout->addWidget ( label_2, 1, 0, 1, 1 );

	burCombo = new QComboBox ( widget );
	burCombo->setObjectName ( QString::fromUtf8 ( "burCombo" ) );

	gridLayout->addWidget ( burCombo, 1, 1, 1, 1 );

	label_3 = new QLabel ( widget );
	label_3->setObjectName ( QString::fromUtf8 ( "label_3" ) );

	gridLayout->addWidget ( label_3, 2, 0, 1, 1 );

	attCombo = new QComboBox ( widget );
	attCombo->setObjectName ( QString::fromUtf8 ( "attCombo" ) );

	gridLayout->addWidget ( attCombo, 2, 1, 1, 1 );

	label_4 = new QLabel ( widget );
	label_4->setObjectName ( QString::fromUtf8 ( "label_4" ) );

	gridLayout->addWidget ( label_4, 3, 0, 1, 1 );

	encrCombo = new QComboBox ( widget );
	encrCombo->setObjectName ( QString::fromUtf8 ( "encrCombo" ) );

	gridLayout->addWidget ( encrCombo, 3, 1, 1, 1 );

	label_5 = new QLabel ( widget );
	label_5->setObjectName ( QString::fromUtf8 ( "label_5" ) );

	gridLayout->addWidget ( label_5, 4, 0, 1, 1 );

	reportCombo = new QComboBox ( widget );
	reportCombo->setObjectName ( QString::fromUtf8 ( "reportCombo" ) );

	gridLayout->addWidget ( reportCombo, 4, 1, 1, 1 );

#ifndef QT_NO_SHORTCUT
	label->setBuddy ( catCombo );
	label_2->setBuddy ( burCombo );
	label_3->setBuddy ( attCombo );
	label_4->setBuddy ( encrCombo );
	label_5->setBuddy ( reportCombo );
#endif // QT_NO_SHORTCUT
	this->setWindowTitle ( QApplication::translate ( "BackSel", "Background", 0, QApplication::UnicodeUTF8 ) );
	CAB->setText ( QApplication::translate ( "BackSel", "Cancel", 0, QApplication::UnicodeUTF8 ) );
	OKB->setText ( QApplication::translate ( "BackSel", "OK", 0, QApplication::UnicodeUTF8 ) );
	groupBox->setTitle ( QApplication::translate ( "BackSel", "Backgrounds for dialogs:", 0, QApplication::UnicodeUTF8 ) );
	label->setText ( QApplication::translate ( "BackSel", "\"&Catenate\" dialog:", 0, QApplication::UnicodeUTF8 ) );
	label_2->setText ( QApplication::translate ( "BackSel", "\"&Burst\" dialog:", 0, QApplication::UnicodeUTF8 ) );
	label_3->setText ( QApplication::translate ( "BackSel", "\"&Attach\" dialog:", 0, QApplication::UnicodeUTF8 ) );
	label_4->setText ( QApplication::translate ( "BackSel", "\"&Encrypt\" dialog:", 0, QApplication::UnicodeUTF8 ) );
	label_5->setText ( QApplication::translate ( "BackSel", "\"&Report\" field:", 0, QApplication::UnicodeUTF8 ) );
////////////////////////////////////////////////////
	dispList = files;
	QStringList tmp = *files;
	for ( int i=0;i<dispList->count();i++ )
	{
		tmp[i] = tmp[i].split ( "/", QString::SkipEmptyParts ).last();
	}
	connect ( CAB, SIGNAL ( clicked() ), this, SLOT ( reject() ) );
	connect ( OKB, SIGNAL ( clicked() ), this, SLOT ( onOK() ) );
	tmp<<"none";
	catCombo->insertItems ( 0, tmp );
	burCombo->insertItems ( 0, tmp );
	attCombo->insertItems ( 0, tmp );
	encrCombo->insertItems ( 0, tmp );
	reportCombo->insertItems ( 0, tmp );
	if ( index != NULL )
	{
		if ( index[0]>=0 && index[0] < tmp.count() ) catCombo->setCurrentIndex ( index[0] );
		else catCombo->setCurrentIndex ( tmp.count()-1 );
		if ( index[1]>=0 && index[1] < tmp.count() ) burCombo->setCurrentIndex ( index[1] );
		else burCombo->setCurrentIndex ( tmp.count()-1 );
		if ( index[2]>=0 && index[2] < tmp.count() ) attCombo->setCurrentIndex ( index[2] );
		else attCombo->setCurrentIndex ( tmp.count()-1 );
		if ( index[3]>=0 && index[3] < tmp.count() ) encrCombo->setCurrentIndex ( index[3] );
		else encrCombo->setCurrentIndex ( tmp.count()-1 );
		if ( index[4]>=0 && index[4] < tmp.count() ) reportCombo->setCurrentIndex ( index[4] );
		else reportCombo->setCurrentIndex ( tmp.count()-1 );
	}
}
void BackSel::onOK()
{
	dispList->clear();
	if ( catCombo->currentText() != "none" ) *dispList<<tr ( "%1" ).arg ( catCombo->currentIndex() );
	else *dispList<<"-1";
	if ( burCombo->currentText() != "none" ) *dispList<<tr ( "%1" ).arg ( burCombo->currentIndex() );
	else *dispList<<"-1";
	if ( attCombo->currentText() != "none" ) *dispList<<tr ( "%1" ).arg ( attCombo->currentIndex() );
	else *dispList<<"-1";
	if ( encrCombo->currentText() != "none" ) *dispList<<tr ( "%1" ).arg ( encrCombo->currentIndex() );
	else *dispList<<"-1";
	if ( reportCombo->currentText() != "none" ) *dispList<<tr ( "%1" ).arg ( reportCombo->currentIndex() );
	else *dispList<<"-1";
	accept();
}
BackSel::~BackSel() {destroy();}
