/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "Burst.h"

Burst::Burst ( QWidget* parent, Qt::WindowFlags f, QString bg )
{
	if ( parent != NULL ) {setParent ( parent );}
	if ( f != NULL ) {setWindowFlags ( f );}

	zero = 1;pref = "filename";
	this->setObjectName ( QString::fromUtf8 ( "Burst" ) );
	//this->setFixedSize(360, 155);
	this->setWindowIcon ( QIcon ( ":/burst" ) );
	groupBox = new QGroupBox ( this );
	groupBox->setObjectName ( QString::fromUtf8 ( "groupBox" ) );
	//groupBox->setGeometry(QRect(10, 10, 221, 131));
	//widget = new QWidget(groupBox);
	//widget->setObjectName(QString::fromUtf8("widget"));
	//widget->setGeometry(QRect(10, 20, 191, 91));
	gridLayout = new QGridLayout ( groupBox );
	gridLayout->setObjectName ( QString::fromUtf8 ( "gridLayout" ) );
	gridLayout->setContentsMargins ( 0, 0, 0, 0 );
	label = new QLabel ( groupBox );
	label->setObjectName ( QString::fromUtf8 ( "label" ) );

	gridLayout->addWidget ( label, 0, 0, 1, 1 );

	pushButton = new QPushButton ( groupBox );
	pushButton->setObjectName ( QString::fromUtf8 ( "pushButton" ) );
	gridLayout->addWidget ( pushButton, 0, 1, 1, 1 );

	label_2 = new QLabel ( groupBox );
	label_2->setObjectName ( QString::fromUtf8 ( "label_2" ) );

	gridLayout->addWidget ( label_2, 1, 0, 1, 1 );

	spinBox = new QSpinBox ( groupBox );
	spinBox->setObjectName ( QString::fromUtf8 ( "spinBox" ) );
	spinBox->setRange ( 1, 8 );
	connect ( spinBox, SIGNAL ( valueChanged ( int ) ), this, SLOT ( on_Zero ( int ) ) );
	gridLayout->addWidget ( spinBox, 1, 1, 1, 1 );

	passCheck = new QCheckBox ( groupBox);
	passCheck->setObjectName ( QString::fromUtf8 ( "passCheck" ) );
	gridLayout->addWidget ( passCheck, 2, 0, 1, 1 );

	passEdit = new QLineEdit ( groupBox);
	passEdit->setObjectName ( QString::fromUtf8 ( "passEdit" ) );
	passEdit->setEnabled(false);
	passEdit->setValidator(new QRegExpValidator(QRegExp("([\\S])+"), passEdit));
	gridLayout->addWidget ( passEdit, 2, 1, 1, 1 );

	connect(passCheck, SIGNAL(clicked(bool)), passEdit, SLOT(setEnabled(bool)));

	widget1 = new QWidget ( this );
	widget1->setObjectName ( QString::fromUtf8 ( "widget1" ) );
	//widget1->setGeometry(QRect(250, 20, 91, 121));
	verticalLayout = new QVBoxLayout ( widget1 );
	verticalLayout->setObjectName ( QString::fromUtf8 ( "verticalLayout" ) );
	verticalLayout->setContentsMargins ( 0, 0, 0, 0 );

	CAB = new QPushButton ( widget1 );
	CAB->setObjectName ( QString::fromUtf8 ( "CAB" ) );
	verticalLayout->addWidget ( CAB );

	HELPB = new QPushButton ( widget1 );
	HELPB->setObjectName ( QString::fromUtf8 ( "HELPB" ) );
	HELPB->setIcon ( QIcon ( qApp->style()->standardIcon(QStyle::SP_DialogHelpButton) ) );
	connect ( HELPB, SIGNAL ( clicked() ), this, SLOT ( on_Help() ) );
	verticalLayout->addWidget ( HELPB );

	OKB = new QPushButton ( widget1 );
	OKB->setObjectName ( QString::fromUtf8 ( "OKB" ) );
	OKB->setIcon ( QIcon ( ":/ok" ) );
	connect ( OKB, SIGNAL ( clicked() ), this, SLOT ( onOKB() ) );
	verticalLayout->addWidget ( OKB );

	horizontalLayout = new QHBoxLayout ( this );
	horizontalLayout->setObjectName ( QString::fromUtf8 ( "horizontalLayout" ) );
	horizontalLayout->setContentsMargins ( 0, 0, 0, 0 );
	horizontalLayout->addWidget ( groupBox );
	horizontalLayout->addWidget ( widget1 );
	adjustSize();
	connect ( CAB, SIGNAL ( clicked() ), this, SLOT ( reject() ) );
	this->setWindowTitle ( QApplication::translate ( "Burst", "Burst", 0, QApplication::UnicodeUTF8 ) );
	groupBox->setTitle ( QApplication::translate ( "Burst", "Output options:", 0, QApplication::UnicodeUTF8 ) );
	label->setText ( QApplication::translate ( "Burst", "Specify prefix:", 0, QApplication::UnicodeUTF8 ) );
	pushButton->setText ( QApplication::translate ( "Burst", "filename", 0, QApplication::UnicodeUTF8 ) );
	label_2->setText ( QApplication::translate ( "Burst", "Number of zeros:", 0, QApplication::UnicodeUTF8 ) );
	OKB->setText ( QApplication::translate ( "Burst", "OK", 0, QApplication::UnicodeUTF8 ) );
	HELPB->setText ( QApplication::translate ( "Burst", "Help", 0, QApplication::UnicodeUTF8 ) );
	CAB->setText ( QApplication::translate ( "Burst", "Cancel", 0, QApplication::UnicodeUTF8 ) );
	passCheck->setText(QApplication::translate ( "Burst", "Owner password:", 0, QApplication::UnicodeUTF8 ));
	connect ( pushButton, SIGNAL ( clicked() ), this, SLOT ( on_Prefix() ) );
	if ( !bg.isEmpty() ) {setStyleSheet ( tr ( "QDialog{background: url(%1);}" ).arg ( bg ) );}
}
void Burst::on_Zero ( int i ) {zero = i;}
void Burst::on_Help()
{
	QMessageBox::information ( this, tr ( "Help" ), tr ( "By clicking OK you will split selected pdf file into separate pages.<br>They will be placed in the same directory named like *prefix*_0..0n.pdf, where n is page number<br>Also a report named 'doc_data.txt' will be created<br><b>N.B.</b>Type 'filename' as prefix to name files as source file with page number" ) );
}
void Burst::onOKB()
{
	if(!passCheck->isChecked()) pass = "";
	else pass = passEdit->text();
	accept();
}
void Burst::on_Prefix()
{
	QString s = QInputDialog::getText ( this, tr ( "Prefix:" ), tr ( "Input prefix:" ), QLineEdit::Normal, pref );
	if ( !s.isEmpty() ) {pref = s;pushButton->setText ( s );}
}
Burst::~Burst() {}
