/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "suslictk.h"

void SuslicTk::onBurst(QString ifile)
{
	if(!tkPresent)
	{
		QMessageBox::warning(this, tr("Error"), tr("This action cannot be performed without pdftk binary! Please, install pdftk and specify it's location in Preferences."));
		return;
	}
	QString filePDF;
	if(ifile.isEmpty()) filePDF = QFileDialog::getOpenFileName ( this, tr ( "Select PDF file" ),lastdir, tr ( "PDF Files (*.pdf)" ) );
	else filePDF = ifile;
	if ( filePDF.isEmpty() ) return;
	onSetDir(getDirFromFile ( filePDF ));
	if ( index[1] >=0 && index[1] < imgDB.count() )
	{
		bur = new Burst ( this, Qt::Dialog, imgDB[index[1]] );
	}
	else
	{
		bur = new Burst ( this, Qt::Dialog, "" );
	}
	int res = bur->exec();
	if ( res != 1 ) return;
	onBurstCore(filePDF, bur->pref, bur->zero, bur->pass);
	delete bur;
}

void SuslicTk::onBurstCore(QString filePDF, QString prefix, int zeros, QString pass)
{
	if(!tkPresent)
	{
		QMessageBox::warning(this, tr("Error"), tr("This action cannot be performed without pdftk binary! Please, install pdftk and specify it's location in Preferences."));
		return;
	}
	bool changed;
	QRegExp rx ( "(\\.|\\_|\\-|\\+|\\s|[A-Z]|[a-z]|[0-9])+" );
	if ( filePDF == NULL ) return;
	QString IFILE = filePDF;
	IFILE = checkPath ( IFILE, "burst", &changed );
	passcorr = true;
	proc = new QProcess();
	QFileInfo inf(filePDF);
	proc->setWorkingDirectory ( inf.absolutePath() );
	QString fileN = inf.fileName();
	QString tmpb = inf.baseName();
	QString PP;
	if(!rx.exactMatch(prefix))
	{
		prefix = "filename";
		if(!rx.exactMatch(tmpb)) prefix = "burst";
	}
	if ( prefix != "filename" )
		{PP = pdftkBin+" \""+IFILE+"\" burst output \""+prefix+"_%0"+tr ( "%1" ).arg ( zeros ) +"d.pdf\"";}
	else
	{
		if ( rx.exactMatch ( fileN ) )
			PP = pdftkBin+" \""+IFILE +"\" burst output \""+tmpb +"_%0"+tr ( "%1" ).arg ( zeros ) +"d.pdf\"";
		else
		{
			bool www = true;
			while ( www )
			{
				QMessageBox::warning ( this, "", tr ( "Output file name should not contain symbols other than english characters, digits and \"_\" symbol. Please select another name" ) );
				//QInputDialog, check, PP
				tmpb = QInputDialog::getText ( this, "", tr ( "File name:" ), QLineEdit::Normal, tmpb );
				if ( tmpb.isEmpty() || rx.exactMatch ( tmpb ) ) www = false;
			}
			if ( tmpb.isEmpty() ) return;
			PP = pdftkBin+" \""+IFILE +"\" burst output \""+tmpb+"_%0"+tr ( "%1" ).arg ( zeros ) +"d.pdf\"";
		}
	}
	if(!pass.isEmpty())
	{
		//pass.replace(" ", "");
		PP += " owner_pw \""+pass+"\"";
	}
	qDebug()<<PP;
	proc->start ( PP );
	addTextPEc(PP);
	if ( !proc->waitForStarted() ) {qDebug() <<"Couldn't start";return;}
	if ( !proc->waitForFinished ( 60000 ) ) {qDebug() <<"Not finished!";return;}
	QString sErr = proc->readAllStandardError();
	addTextPE(proc->readAllStandardOutput()+"<br>"+sErr);
	if ( sErr.isEmpty() )
	{
		addTextTE(tr("File <b>%1</b><br>is successfully split into pages. Output files prefix  - <b>%2</b>").arg(filePDF).arg(prefix));
	}
	else
	{
		if ( sErr.contains ( "OWNER PASSWORD" ) )
		{
			passcorr = false;
			bool cont = false;
			while ( !cont )
			{
				QMessageBox::warning ( this, tr ( "Attention" ), tr ( "Owner password required for<br>%1<br>No/incorrect password given" ).arg(IFILE) );
				if ( QMessageBox::question ( this, tr ( "Input password" ), tr ( "Do you want to input password?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes )
				{
					QString paStr = QInputDialog::getText ( this, tr ( "Password" ), tr ( "Input password" ), QLineEdit::Password, "" );
					if ( paStr.isEmpty() ) {cont = true;passcorr = false;}
					else
					{
						if ( prefix != "filename" )
							{PP = pdftkBin+" \""+IFILE +"\" input_pw \""+paStr+"\" burst output \""+prefix+"_%0"+tr ( "%1" ).arg ( zeros ) +"d.pdf\"";}
						else{PP = pdftkBin+" \""+IFILE +"\" input_pw \""+paStr+"\" burst output \""+tmpb +"_%0"+tr ( "%1" ).arg ( zeros ) +"d.pdf\"";}
						proc = new QProcess ( this );
						proc->setWorkingDirectory ( lastdir );
						proc->start ( PP );
						addTextPEc(PP);
						if ( !proc->waitForStarted() ) {qDebug() <<"Could not start";return;}
						if ( !proc->waitForFinished() ) {qDebug() <<"Could not finish";return;}
						sErr = proc->readAllStandardError();
						addTextPE(proc->readAllStandardOutput()+"<br>"+sErr);
						if ( !sErr.isEmpty() && sErr.contains ( "OWNER PASSWORD" ) ) {}
						if ( !sErr.isEmpty() && !sErr.contains ( "OWNER PASSWORD" ) ) {cont = true;passcorr = false;}
						if ( sErr.isEmpty() )
						{
							cont = true;passcorr = true;
							addTextTE(tr("File <b>%1</b><br>is successfully split into pages. Output files prefix  - <b>%2</b>").arg(filePDF).arg(prefix));
						}
						else{passcorr = false;}
					}
				}
				else{cont = true;passcorr = false;}
			}
		}
		else
			{QMessageBox::critical ( this, tr ( "Error!" ), tr ( "Unknown error occurred!<br>Output of the process:<br>%1" ).arg ( sErr ) );}
	}
	if ( !passcorr )
	{
		QMessageBox::critical ( this, tr ( "Error!" ), tr ( "Unknown error occurred!<br>Output of the process:<br>%1" ).arg ( sErr ) );
	}
}
