/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

QString SuslicTk::checkPath(QString filePath, QString id, bool* change)
{
	onRemTemp(true, id);
	qDebug()<<"checkPath: "<<filePath;
	QString name = QFileInfo(filePath).fileName();
	QString ret;
	QRegExp rx("(\\.|\\_|\\-|\\+|\\/|\\s|[A-Z]|[a-z]|[0-9])+");
	if(!rx.exactMatch(filePath))
	{
		QMessageBox::warning(this, name, QApplication::translate("SuslicTk","pdftk cannot handle this file.<br>PdfTk-QGUI will copy it and rename, so that<br>pdftk can handle it."));
		if(!id.isEmpty()) ret = QDir::homePath()+"/.suslictk/temp/tmp_cp_"+id+".pdf";
		else
		{
			bool ww = true;
			QString ss;
			while(ww)
			{
				ss = QInputDialog::getText(this, name, QApplication::translate("SuslicTk","New name"), QLineEdit::Normal, "", &ww);
				if(ww && rx.exactMatch(ss)) ww = false;
				if(ww) QMessageBox::warning(this, name, QApplication::translate("SuslicTk","Name should contain <b>only</b> english characters and digits."));
			}
			if(ss.isEmpty()) return QString();
			QString suffix;
			if(name.startsWith(".") && name.split(".", QString::SkipEmptyParts).count() == 1) suffix = "";
			else suffix = QFileInfo(filePath).suffix();
			ret = QDir::homePath()+"/.suslictk/temp/"+ss+"."+suffix;
		}
		qDebug()<<"ret = "<<ret;
		if(QFile(filePath).copy(ret))
		{
			if(change != NULL) *change = true;
			return ret;
		}
		else
		{
			QMessageBox::critical(this, name, QApplication::translate("SuslicTk","Failed to make a copy of %1.<br>Please run Edit->Delete tmp").arg(filePath));
			return QString();
		}
	}
	else {if(change != NULL) *change = false; return filePath;}
}
