/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef CAT_H
#define CAT_H

#include <QtGui/QCheckBox>
#include <QtGui/QGridLayout>
#include <QtGui/QGroupBox>
#include <QtGui/QLineEdit>
#include <QtGui/QListWidget>
#include <QtGui/QPushButton>
#include <QtGui/QRadioButton>
#include <QtGui/QSpacerItem>
#include <QtGui/QVBoxLayout>
#include <QtGui/QWidget>
#include <QListWidgetItem>
#include <QDir>
#include <QProcess>
#include <QCursor>
#include <QKeyEvent>
#include <QProgressDialog>
#include "Check_impl.h"
#include "SelRange.h"
class Cat: public QDialog
{
		Q_OBJECT
	public:
		Cat ( QWidget *parent = 0, Qt::WindowFlags f = Qt::Dialog, QStringList ifiles = QStringList(), QString pdftkb = "pdftk" , QString bg = "", QString LastDir = QDir::homePath() );
		~Cat();
		QString getPE();
		QString encr, lastCatDir;
		QStringList PDFFiles, PDFParams;
		void retranslateUi();
	signals:
		void _addPE(QString text);
		void _addPEc(QString text);
	private slots:
		void onList ( int i );
		void onAllR ( bool check );
		void onRangeR ( bool check );
		void onSelectR ( bool check );
		void onRotC ( int index );
		void onHelp();
		void onOdd ( bool check );
		void onEven ( bool check );
		void onUp();
		void onUpUp();
		void onDown();
		void onDownDown();
		void onAdd ( bool ask = true );
		void onAllCat();
		void onUserEncrypt ( bool check );
		void onOwnerEncrypt ( bool check );
		void onRemove();
		//void onPass ( QString str );
		void onRangeE();
		void onSelectE ();
		void onOK();
	protected:
		void keyPressEvent ( QKeyEvent *event );
	private:
		QProgressDialog *progd;
		bool alertR, alertS;
		void onCheck();
		int curRow;
		QString homeP, pdftkBinC, backg;
		QStringList tmpList, PageIFRange, PageRange, PageSelect, PageNum, PageRotation, PageQualifier;
		/*QListWidget *FileList;
		QGroupBox *groupBox;
		//QWidget *layoutWidget;
		QGridLayout *gridLayout;
		QLabel *label;
		QLabel *nameLabel;
		QLabel *label_2;
		QLabel *pageLabel;
		QGroupBox *groupBox_2;
		QVBoxLayout *verticalLayout_5;
		QGroupBox *groupBox_4;
		//QWidget *layoutWidget1;
		QGridLayout *gridLayout_2;
		QRadioButton *all_radio;
		QSpacerItem *horizontalSpacer;
		QRadioButton *range_radio;
		QPushButton *rangeEdit;
		QRadioButton *select_radio;
		QPushButton *selectEdit;
		QGroupBox *groupBox_5;
		//QWidget *layoutWidget2;
		QHBoxLayout *horizontalLayout_3;
		QComboBox *all_combo;
		QPushButton *help_button;
		QGroupBox *groupBox_6;
		//QWidget *layoutWidget3;
		QHBoxLayout *horizontalLayout_5;
		QCheckBox *odd_check;
		QCheckBox *even_check;
		QGroupBox *groupBox_3;
		//QWidget *widget;
		QHBoxLayout *horizontalLayout_4;
		QPushButton *Up_button;
		QPushButton *Down_button;
		QPushButton *UpUp_button;
		QPushButton *DownDown_button;
		//QWidget *layoutWidget4;
		//QVBoxLayout *verticalLayout_2;
		//QWidget *layoutWidget5;
		//QVBoxLayout *verticalLayout_3;
		QGroupBox *groupBox_7;
		//QWidget *layoutWidget6;
		QGridLayout *gridLayout_4;
		//QCheckBox *encrypt_check;
		QCheckBox *label_3;
		QLineEdit *ownerEdit;
		QCheckBox *label_4;
		QLineEdit *userEdit;
		QWidget *layoutWidget7;
		QHBoxLayout *horizontalLayout_2;
		QPushButton *OKB;
		QPushButton *CAB;
		QGroupBox *groupBox_8;
		QHBoxLayout *horizontalLayout;
		QPushButton *add_button;
		QPushButton *all_button;
		QPushButton *remove_button;

		QWidget *newWidget_1, *newWidget_2, *newWidget_3;
		QVBoxLayout *verticalLayout_6;
		QVBoxLayout *verticalLayout_7;
		QHBoxLayout *horizontalLayout_6;
		QHBoxLayout *horizontalLayout_7;
		QSpacerItem *horizontalSpacer_1;
		QSpacerItem *horizontalSpacer_2;
		QSpacerItem *horizontalSpacer_3;
		QSpacerItem *horizontalSpacer_4;*/
		
		    QVBoxLayout *verticalLayout;
    QHBoxLayout *horizontalLayout_7;
    QGroupBox *groupBox_8;
    QHBoxLayout *horizontalLayout;
    QPushButton *add_button;
    QPushButton *all_button;
    QPushButton *remove_button;
    QSpacerItem *horizontalSpacer_2;
    QGroupBox *groupBox_3;
    QHBoxLayout *horizontalLayout_4;
    QPushButton *UpUp_button;
    QPushButton *Up_button;
    QPushButton *Down_button;
    QPushButton *DownDown_button;
    QListWidget *FileList;
    QGroupBox *groupBox_2;
    QHBoxLayout *horizontalLayout_2;
    QGroupBox *groupBox_4;
    QGridLayout *gridLayout_2;
    QRadioButton *all_radio;
    QSpacerItem *horizontalSpacer;
    QRadioButton *range_radio;
    QRadioButton *select_radio;
    QPushButton *rangeEdit;
    QPushButton *selectEdit;
    QGroupBox *groupBox_6;
    QGridLayout *gridLayout_4;
    QLabel *label_5;
    QCheckBox *odd_check;
    QCheckBox *even_check;
    QLabel *label_6;
    QComboBox *all_combo;
    QPushButton *help_button;
    QHBoxLayout *horizontalLayout_3;
    QGroupBox *groupBox_7;
    QGridLayout *gridLayout_3;
    QCheckBox *label_3;
    QLineEdit *userEdit;
    QCheckBox *label_4;
    QLineEdit *ownerEdit;
    QGroupBox *groupBox;
    QGridLayout *gridLayout;
    QLabel *label;
    QLabel *nameLabel;
    QLabel *label_2;
    QLabel *pageLabel;
    QHBoxLayout *horizontalLayout_5;
    QSpacerItem *horizontalSpacer_3;
    QSpacerItem *horizontalSpacer_4;
    QPushButton *CAB;
    QPushButton *OKB;

};
#endif
