/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "suslictk.h"

void SuslicTk::onCat ( QStringList ifiles )
{
	if ( !tkPresent )
	{
		QMessageBox::warning ( this, tr ( "Error" ), tr ( "This action cannot be performed without pdftk binary! Please, install pdftk and specify it's location in Preferences." ) );
		return;
	}
	qDebug() <<"CAT: index[0] = "<<index[0];
	if ( index[0] >= 0 && index[0] < imgDB.count() ) {catt = new Cat ( this, Qt::Dialog , ifiles , pdftkBin, imgDB[index[0]], lastdir );qDebug() <<"CAT: with background";}
	else{catt = new Cat ( this, Qt::Dialog , ifiles, pdftkBin, "", lastdir );}
	connect ( catt, SIGNAL ( _addPE ( QString ) ), this, SLOT ( addTextPE ( QString ) ) );
	connect ( catt, SIGNAL ( _addPEc ( QString ) ), this, SLOT ( addTextPEc ( QString ) ) );
	int res = catt->exec();
	onSetDir ( catt->lastCatDir );
	QString EFILE, EFILE_1;
	if ( res != 1 ) return;
	EFILE = QFileDialog::getSaveFileName ( this, tr ( "Save result as:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
	if ( !EFILE.isEmpty() && !EFILE.endsWith ( ".pdf", Qt::CaseInsensitive ) ) EFILE+=".pdf";
	EFILE_1 = checkSaveFile ( EFILE );
	if ( EFILE.isEmpty() ) return;
	onSetDir ( getDirFromFile ( EFILE ) );
	qDebug() <<"lastdir = "<<lastdir;
	int num = catt->PDFFiles.count();
	prog_com = new QProgressDialog ( tr ( "Processing files" ), tr ( "Cancel" ), 0, num, this );
	prog_com->show();
	prog_com->setWindowModality ( Qt::WindowModal );
	QString sErrC;
	for ( int i=0;i<num;i++ )
	{
		prog_com->setValue ( i );
		//qDebug()<<"PDFFiles["<<i<<"] = "<<catt->PDFFiles[i]<<"\tPDFParams[i]="<<catt->PDFParams[i];
		if ( prog_com->wasCanceled() ) break;
		else
		{
			if ( catt->PDFParams[i] != " cat 1-end" )
			{
				QString makePDF = pdftkBin+" "+catt->PDFFiles[i]+catt->PDFParams[i]+" output \""+homePDF->absolutePath() +"/tmp_cat_"+tr ( "%1" ).arg ( i ) +".pdf\"";
				catt->PDFFiles[i] = "\""+homePDF->absolutePath() +"/tmp_cat_"+tr ( "%1" ).arg ( i ) +".pdf\"";
				qDebug() <<makePDF;
				proc = new QProcess();
				proc->start ( makePDF );
				addTextPEc ( makePDF );
				if ( !proc->waitForStarted() ) {qDebug() <<"Couldn't start";prog_com->setValue ( num );return;}
				if ( !proc->waitForFinished ( -1 ) ) {qDebug() <<"Not finished!";prog_com->setValue ( num );return;}
				qDebug() <<"Exit  Code: "<<proc->exitCode() ;
				qDebug() <<"Exit Status "<<proc->exitStatus() ;
				sErrC = proc->readAllStandardError();
				addTextPE ( proc->readAllStandardOutput() +"<br>"+sErrC );
				if ( !sErrC.isEmpty() )
					QMessageBox::warning ( this, "", tr ( "Failed to create temporary file. File %1 will not be added.<br>Process output:%2" ).arg ( catt->PDFFiles[i] ).arg ( sErrC ) );
			}
			else
			{
				qDebug() <<"No processing needed for "<<catt->PDFFiles[i];
			}
		}
	}
	if ( !prog_com->wasCanceled() )
	{
		prog_com->setLabelText ( tr ( "Catenating files" ) );
		QString CatAll = pdftkBin+" ";
		for ( int i=0;i<num;i++ )
		{
			CatAll+= catt->PDFFiles[i]+" ";//( "\""+homePDF->absolutePath() +"/tmp_cat_"+tr ( "%1" ).arg ( i ) +".pdf\" " );
		}
		CatAll+= " cat output \""+EFILE_1+"\""+catt->encr;
		//if ( catt->encr == "encrypt" ) {CatAll+=" owner_pw "+catt->getPE();}
		proc = new QProcess();
		proc->start ( CatAll );
		addTextPEc ( CatAll );
		if ( !proc->waitForStarted() ) {qDebug() <<"Couldn't start";prog_com->setValue ( num );return;}
		if ( !proc->waitForFinished ( -1 ) ) {qDebug() <<"Not finished!";prog_com->setValue ( num );return;}
		qDebug() <<"Catenate process: 1.Exit Code = "<<proc->exitCode() <<"\t2. Exit Status = "<<proc->exitStatus() ;
		sErrC = proc->readAllStandardError();
		addTextPE ( proc->readAllStandardOutput() +"<br>"+sErrC );
		if ( !sErrC.isEmpty() )
		{
			TE->setText ( TE->toHtml() +tr ( "<font color=red>%1</font>" ).arg ( sErrC ) );
			delete catt;
			prog_com->setValue ( num );
			return;
		}
	}
	QStringList cleanList =  homePDF->entryList().filter ( "tmp_cat" ) <<homePDF->entryList().filter ( "tmp_1cp" );
	if ( !cleanList.isEmpty() )
	{
		Rem *rr = new Rem ( this, Qt::Tool );
		rr->remStrL = cleanList;
		rr->INIT();
		if ( rr->exec() == 1 )
		{
			for ( int j=0;j<cleanList.count();j++ )
			{
				QFile file ( homePDF->absolutePath() +"/"+cleanList[j] );
				if ( !file.remove() ) {QMessageBox::critical ( this, tr ( "Cleaner" ), tr ( "Unable to remove all trash!" ) );}
			}
		}
		delete rr;
	}
	prog_com->setValue ( num );
	if ( !prog_com->wasCanceled() )
	{
		if ( copyEFILE ( EFILE_1, EFILE ) )
		{
			addTextTE ( tr ( "<br>&raquo;Done!<br>&raquo;Output successfully saved to<br>&nbsp;&nbsp;%1" ).arg ( EFILE ) );
			if ( catt->encr == "encrypt" )
			{
				addTextTE ( tr ( "<br>&raquo;Output encrypted with password <i>%1</i>" ).arg ( catt->getPE() ) );
			}
			onView ( EFILE, true );
		}
	}
	disconnect ( catt, SIGNAL ( _addPE ( QString ) ), this, SLOT ( addTextPE ( QString ) ) );
	disconnect ( catt, SIGNAL ( _addPEc ( QString ) ), this, SLOT ( addTextPEc ( QString ) ) );
	delete catt;
}
