/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "Check_impl.h"

QString checkPath ( QString from, QString filePath, QString id, QWidget *parent, bool* change, bool display )
{
	if(filePath.isEmpty()) return QString();
	qDebug() <<"checkPath: "<<filePath;
	QString name = QFileInfo ( filePath ).fileName();
	QString suffix = QFileInfo ( filePath ).suffix();
	QString ret;
	QRegExp rx ( "(\\.|\\_|\\-|\\+|\\/|\\s|\\~|[A-Z]|[a-z]|[0-9])+" );
	if ( !rx.exactMatch ( filePath ) )
	{
		if(display) QMessageBox::warning ( parent, name, QApplication::translate ( "SuslicTk","pdftk cannot handle this file.<br>PdfTk-QGUI will copy and rename it, so that<br>pdftk can handle it." ) );
		if ( !id.isEmpty() )
		{
			int i=0;
			while(QFile(QDir::homePath() +"/.suslictk/temp/tmp_1cp_"+id+QString().setNum(i)+"."+suffix).exists())	i++;
			ret = QDir::homePath() +"/.suslictk/temp/tmp_1cp_"+id+QString().setNum(i)+"."+suffix;
		}
		else
		{
			bool ww = true;
			QString ss;
			while ( ww )
			{
				ss = QInputDialog::getText ( parent, name, QApplication::translate ( "SuslicTk","New name" ), QLineEdit::Normal, "", &ww );
				if(ss.contains("."))
				{
					ss = ss.split(".").first();
					suffix = ss.split(".").last();
				}
				if ( ww && rx.exactMatch ( ss ) )
				{
					if(!QFile(QDir::homePath() +"/.suslictk/temp/"+ss+"."+suffix).exists())	ww = false;
					else	QMessageBox::warning ( parent, name, QApplication::translate ( "SuslicTk","File with the same name already exists! Please, choose another name" ) );
				}
				if ( ww && !rx.exactMatch ( ss ) ) QMessageBox::warning ( parent, name, QApplication::translate ( "SuslicTk","Name should contain <b>only</b> english characters and digits." ) );
			}
			if ( ss.isEmpty() ) return QString();
			ret = QDir::homePath() +"/.suslictk/temp/"+ss+"."+suffix;
		}
		qDebug() <<"ret = "<<ret;
		if ( QFile ( filePath ).copy ( ret ) )
		{
			*change = true;
			if(display) QMessageBox::information ( parent, name, QApplication::translate ( "SuslicTk","<b>New filename</b><br>%1" ).arg ( ret ) );
			return ret;
		}
		else
		{
			QMessageBox::critical ( parent, name, QApplication::translate ( "SuslicTk","Failed to make a copy of %1.<br>Please run Edit->Delete tmp" ).arg ( filePath ) );
			return QString();
		}
	}
	else
	{
		*change = false; return filePath;
	}
	return QString();
}
