/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "suslictk.h"

void SuslicTk::onHTML2PDF()
{
	if ( hprint )
	{
		QMessageBox::warning ( this, "HTML2PDF", tr ( "HTML document is being printed at the moment<br>Please wait until printing is finished." ) );
		return;
	}
	if ( QMessageBox::question ( this, "HTML2PDF", tr ( "Do you want to convert online document?<br>Select \"No\" if you want to convert local file" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes )
	{
		htmlloc = false;
		QString tmpClip = urlclip->text();
		if ( QUrl ( tmpClip ).isValid() && ( tmpClip.contains ( "http:" ) || tmpClip.contains ( "ftp:" ) ) ) tmp1 = QInputDialog::getText ( this, "HTML2PDF", tr ( "URL:" ), QLineEdit::Normal, urlclip->text() );
		else tmp1 = QInputDialog::getText ( this, "HTML2PDF", tr ( "URL:" ), QLineEdit::Normal, "http://" );
		if ( !QUrl ( tmp1 ).isValid() )
		{
			QMessageBox::critical ( this, tr ( "Error" ), tr ( "Invalid url!" ) );
			return;
		}
		qDebug() <<"url = "<<tmp1;
		tmphtm = QFileDialog::getSaveFileName ( this, tr ( "Save as: " ), lastdir, tr ( "(*.pdf)" ) );
	}
	else
	{
		htmlloc = true;
		tmp1 = QFileDialog::getOpenFileName ( this, tr ( "Select HTML document" ), lastdir, tr ( "HTML files (*.html *.htm)" ) );
		if ( tmp1.isEmpty() ) return;
		onSetDir ( getDirFromFile ( tmp1 ) );
		tmphtm = QFileDialog::getSaveFileName ( this, tr ( "Save as: " ), QFileInfo ( tmp1 ).canonicalFilePath() +".pdf", tr ( "(*.pdf)" ) );
	}
	if ( tmphtm.isEmpty() ) return;
	hprint = true;
	//html_prog->setValue(0);
	//html_prog->show();
	qDebug() <<"tmp1 "<<tmp1 ;
	onSetDir ( getDirFromFile ( tmphtm ) );
	if ( tmphtm.split ( "/" ).last().split ( "." ).count() == 1 ) {tmphtm+=".pdf";}
	//qDebug()<<"tmp "<<tmp;
	HTMLprinter->setOutputFileName ( tmphtm );
	//wp->mainFrame()->load ( QUrl(tmp1) );
	//wv->setUrl(QUrl(tmp1));
	ifupdate = 0;
	if ( !htmlloc ) onSendRequest ( tmp1 );
	else
	{
		QFile file ( tmp1 );
		if ( !file.open ( QFile::ReadOnly | QFile::Text ) )
		{
			QMessageBox::warning ( this, tr ( "PdfTk-QGUI" ),tr ( "Cannot open file %1:\n%2." ).arg ( file.fileName() ).arg ( file.errorString() ) );
			HTMLloadFinished ( false );
		}
		else
		{
			QTextStream in ( &file );
			httpDataStr = in.readAll();
			HTMLloadFinished ( true );
		}
	}
}
void SuslicTk::HTMLloadFinished ( bool ok )
{
	if ( ok )
	{
		if ( !htmlloc )
		{
			if ( !tmphtmlfile->open ( QFile::ReadOnly|QFile::Text ) )
			{
				QMessageBox::warning ( this, tr ( "PdfTk-QGUI" ),tr ( "Cannot open file %1:\n%2." ).arg ( tmphtmlfile->fileName() ).arg ( tmphtmlfile->errorString() ) );
				hprint = false;
				return;
			}
			else
			{
				QTextStream in ( tmphtmlfile );
				httpDataStr = in.readAll();
				tmphtmlfile->close();
			}
		}
		else{httpDataStr = "";}
		qDebug() <<"printing: ";//<<httpDataStr<<"end data";
		Q_CHECK_PTR(HTMLprinter);
		HTMLpreview *hp = new HTMLpreview ( httpDataStr, tmp1, htmlloc, HTMLprinter, this, Qt::Dialog );
		int res = hp->exec();
		if ( res == 1 )
		{
			TE->setText ( TE->toHtml() +tr ( "<br>%1 successfully created" ).arg ( tmphtm ) );
			onView ( tmphtm, true );
		}
		else{TE->setText ( TE->toHtml() +tr ( "<br>Conversion canceled by user " ) );}
	}
	else
	{
		QMessageBox::critical ( this, "HTML2PDF", tr ( "Failed to load html document<br>If you have selected online document, check url." ) );
		TE->setText ( TE->toHtml() +tr ( "<br>Failed to load html document" ) );
	}
	//http->abort();
	//prDlg->hide();
	hprint = false;
}
void SuslicTk::onTXT2PDF ()
{
	if ( printing )
	{
		QMessageBox::warning ( this, "", tr ( "A document is being converted at the moment\nPlease wait until it's finished..." ) );
	}
	else
	{
		QString tmp = QFileDialog::getOpenFileName ( this, tr ( "Select text document" ), lastdir );
		if ( tmp.isEmpty() ) return;
		onSetDir ( getDirFromFile ( tmp ) );
		qDebug() <<"lastdir = "<<lastdir ;
		print->IFILE = tmp;
		tmp = QFileDialog::getSaveFileName ( this, tr ( "Save as: " ), lastdir+"/"+QFileInfo ( tmp ).baseName() +".pdf", tr ( "(*.pdf)" ) );
		if ( tmp.isEmpty() ) return;
		onSetDir ( getDirFromFile ( tmp ) );
		if ( tmp.split ( "/" ).last().split ( "." ).count() == 1 ) {tmp+=".pdf";}
		print->EFILE = tmp;
		print->res = resol;print->ord = order;print->ori = orient;print->colM = colorM;
		printing = true;
		print->start();
	}
}

void SuslicTk::onTxt2PdfCore ( QString ifile, QString ofile, QString utf )
{
	if(ofile.isEmpty())
	{
		ofile = QFileDialog::getSaveFileName ( this, tr ( "Save result as:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
		if(ofile.isEmpty())	return;
		if ( !ofile.endsWith ( ".pdf", Qt::CaseInsensitive ) ) ofile+=".pdf";
	}
	bool ifutf;
	if(utf == "1") ifutf = true;
	else if (utf == "0") ifutf = false;
	else
	{
		QMessageBox *message = makeMessage ( "Txt2Pdf Script", tr ( "File being processed:%1" ).arg ( ifile ), tr ( "Is the encoding of this file the default one for your system?" ), tr ( "On Windows, encoding selection will be based on a system locale. On Unix systems, starting with Qt 4.2, iconv library will be used to select encoding. If you are not sure, select \"No\" and you will be able to check if the encoding has been determined correctly and select encoding manually." ), QMessageBox::Question, QMessageBox::No|QMessageBox::Yes, QMessageBox::Yes );
		int ret = message->exec();
		switch ( ret )
		{
		case QMessageBox::Yes:	ifutf = true;break;
		case QMessageBox::No:	ifutf = false;break;
		default:	break;
		}
	}
	QString arr;
	if ( !ifutf )
	{
		Encoding* enc = new Encoding(this, Qt::Dialog, ifile, false);
		if(enc->exec() != 1)
		{
			QMessageBox::warning(this, "Txt2Pdf", tr("File %1 won't be converted").arg(ifile));
			return;
		}
		arr = enc->data;
		
	}
	else
	{
		QFile txtfile ( ifile );
		if ( !txtfile.open ( QFile::ReadOnly|QFile::Text ) )
		{
			qDebug() <<"Failed to open file";
			return;
		}
		QTextStream txtstr ( &txtfile );
		arr = txtstr.readAll();
		txtfile.close();
	}
	QPrinter PDFprinter;
	if ( orient == 1 ) PDFprinter.setOrientation ( QPrinter::Landscape );
	if ( colorM == 1 ) PDFprinter.setColorMode ( QPrinter::GrayScale );
	if ( order == 1 ) PDFprinter.setPageOrder ( QPrinter::LastPageFirst );
	PDFprinter.setResolution ( resol );
	PDFprinter.setOutputFormat ( QPrinter::PdfFormat );
	PDFprinter.setOutputFileName ( ofile );
	//PDFprinter.setPaperSize(QPrinter::A4);
	QTextEdit tmpEdit;
	tmpEdit.setText ( arr );
	tmpEdit.print ( &PDFprinter );
	addTextTE(tr("Finished converting<br><b>%1</b><br>to<br><b>%2</b><br>").arg(ifile).arg(ofile));
}
void SuslicTk::onTXTConvert(QString ifile)
{
	QString IFILE;
	if(ifile.isEmpty() && !ifile.endsWith("pdf", Qt::CaseInsensitive)) IFILE = QFileDialog::getOpenFileName ( this, tr ( "Select text file " ), lastdir, tr ( "All files (*.*)" ) );
	else IFILE = ifile;
	if ( IFILE.isEmpty()) return;
	onSetDir(getDirFromFile ( IFILE ));
	Encoding* enc = new Encoding(this, Qt::Dialog, IFILE, true);
	qDebug()<<"enc->exec() = "<<enc->exec();
}
