/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "suslictk.h"

void SuslicTk::onStamp ( QString ifile )
{
	if ( !tkPresent )
	{
		QMessageBox::warning ( this, tr ( "Error" ), tr ( "This action cannot be performed without pdftk binary! Please, install pdftk and specify it's location in Preferences." ) );
		return;
	}
	QString IFILE;
	if ( ifile.isEmpty() ) IFILE = QFileDialog::getOpenFileName ( this, tr ( "Select PDF file to apply a stamp to:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
	else IFILE = ifile;
	if ( IFILE.isEmpty() ) return;
	onSetDir ( getDirFromFile ( IFILE ) );
	bool change;
	IFILE = checkPath ( IFILE, "stamp_i", &change );
	if ( IFILE.isEmpty() ) {QMessageBox::critical ( this, tr ( "ERROR" ), tr ( "Failed to create temporary file!" ) );return;}
	qDebug() <<"lastdir = "<<lastdir;
	QString IFILE1 = QFileDialog::getOpenFileName ( this, tr ( "Select PDF file to be a stamp:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
	if ( IFILE1 == NULL ) return;
	onSetDir ( getDirFromFile ( IFILE1 ) );
	IFILE1 = checkPath ( IFILE1, "stamp_s", &change );
	if ( IFILE1.isEmpty() ) {QMessageBox::critical ( this, tr ( "ERROR" ), tr ( "Failed to create temporary file!" ) );return;}
	qDebug() <<"lastdir = "<<lastdir;
	QString EFILE, EFILE_1;
	EFILE = QFileDialog::getSaveFileName ( this, tr ( "Save result as:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
if ( !EFILE.isEmpty() && !EFILE.endsWith ( ".pdf", Qt::CaseInsensitive ) ) EFILE+=".pdf";
	EFILE_1 = checkSaveFile ( EFILE );
	if ( EFILE.isEmpty() ) return;
	onSetDir ( getDirFromFile ( EFILE ) );
	qDebug() <<"lastdir = "<<lastdir;
	QString procSTR = pdftkBin+" \""+IFILE+"\" stamp \""+IFILE1+"\" output \""+EFILE_1+"\"";
	proc = new QProcess ( this );
	proc->start ( procSTR );
	addTextPEc ( procSTR );
	if ( !proc->waitForStarted() ) {qDebug() <<"Couldn't start";return;}
	if ( !proc->waitForFinished () ) {qDebug() <<"Not finished!";return;}
	qDebug() <<"Exit  Code: "<<proc->exitCode() ;
	qDebug() <<"Exit Status "<<proc->exitStatus() ;
	QString sErr = proc->readAllStandardError();
	addTextPE ( proc->readAllStandardOutput() +"<br>"+sErr );
	if ( sErr.isEmpty() )
	{
		addTextTE ( tr ( "<br>&raquo;Done!<br>&raquo;Stamp from file %1<br>&nbsp;&nbsp;has been applied to %2" ).arg ( IFILE1 ).arg ( IFILE ) );
		if ( copyEFILE ( EFILE_1, EFILE ) )
		{
			addTextTE ( tr ( "Output file successfully generated and saved to<br> <b> %3</b>" ).arg ( EFILE ) );
			onView ( EFILE, true );
		}
	}
	else
	{
		if ( !sErr.contains ( "OWNER PASSWORD" ) ) TE->setText ( TE->toHtml() +tr ( "<br><font color=red><b>Error!</b></font><br>" ) +sErr );
		if ( sErr.contains ( "OWNER PASSWORD" ) )
		{
			bool cont = false;
			QString paStr;
			while ( !cont )
			{
				QMessageBox::warning ( this, tr ( "Attention" ), tr ( "Owner password required !<br>No/incorrect password given" ) );
				if ( QMessageBox::question ( this, tr ( "Input password" ), tr ( "Do you want to input password?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes )
				{
					paStr = QInputDialog::getText ( this, tr ( "Password" ), tr ( "Input password" ), QLineEdit::Password, "" );
					if ( paStr.isEmpty() ) {cont = true;passcorr = false;}
					else
					{
						procSTR = pdftkBin+" \""+IFILE+"\" input_pw \""+paStr+"\" stamp \""+IFILE1+"\" output \""+EFILE_1+"\"";
						qDebug() <<"procSTR= "<<procSTR;
						proc = new QProcess ( this );
						proc->start ( procSTR );
						addTextPEc ( procSTR );
						if ( !proc->waitForStarted() ) {qDebug() <<"Could not start";return;}
						if ( !proc->waitForFinished() ) {qDebug() <<"Could not finish";return;}
						sErr = proc->readAllStandardError();
						addTextPE ( proc->readAllStandardOutput() +"<br>"+sErr );
						//qDebug()<<"sErr= "<<sErr;
						if ( !sErr.isEmpty() && sErr.contains ( "OWNER PASSWORD" ) ) {}
						if ( !sErr.isEmpty() && !sErr.contains ( "OWNER PASSWORD" ) ) {cont = true;passcorr = false;}
						if ( sErr.isEmpty() )
						{
							cont = true;passcorr = true;
							addTextTE ( tr ( "<br>&raquo;Done!<br>&raquo;Stamp from file %1<br>&nbsp;&nbsp;has been applied to %2" ).arg ( IFILE1 ).arg ( IFILE ) );
							if ( copyEFILE ( EFILE_1, EFILE ) )
							{
								addTextTE ( tr ( "Output file successfully generated and saved to<br> <b> %3</b>" ).arg ( EFILE ) );
								onView ( EFILE, true );
							}
						}
					}
				}
				else{cont = true;passcorr = false;}
			}
		}
	}
}
void SuslicTk::onBack ( QString ifile )
{
	QString IFILE;
	if ( ifile.isEmpty() ) IFILE = QFileDialog::getOpenFileName ( this, tr ( "Select PDF file to apply a background to:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
	else IFILE = ifile;
	if ( IFILE.isEmpty() ) return;
	onSetDir ( getDirFromFile ( IFILE ) );
	bool change;
	IFILE = checkPath ( IFILE, "back_i", &change );
	if ( IFILE.isEmpty() ) {QMessageBox::critical ( this, tr ( "ERROR" ), tr ( "Failed to create temporary file!" ) );return;}
	QString IFILE1 = QFileDialog::getOpenFileName ( this, tr ( "Select PDF file to be a background:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
	if ( IFILE1 == NULL ) return;
	onSetDir ( getDirFromFile ( IFILE1 ) );
	IFILE1 = checkPath ( IFILE1, "back_b", &change );
	if ( IFILE1.isEmpty() ) {QMessageBox::critical ( this, tr ( "ERROR" ), tr ( "Failed to create temporary file!" ) );return;}
	QString EFILE, EFILE_1;
	EFILE = QFileDialog::getSaveFileName ( this, tr ( "Save result as:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
if ( !EFILE.isEmpty() && !EFILE.endsWith ( ".pdf", Qt::CaseInsensitive ) ) EFILE+=".pdf";
	EFILE_1 = checkSaveFile ( EFILE );
	if ( EFILE.isEmpty() ) return;
	onSetDir ( getDirFromFile ( EFILE ) );
	QString procSTR = pdftkBin+" \""+IFILE+"\" background \""+IFILE1+"\" output \""+EFILE_1+"\"";
	proc = new QProcess ( this );
	proc->start ( procSTR );
	addTextPEc ( procSTR );
	if ( !proc->waitForStarted() ) {qDebug() <<"Couldn't start";return;}
	if ( !proc->waitForFinished () ) {qDebug() <<"Not finished!";return;}
	qDebug() <<"Exit  Code: "<<proc->exitCode() ;
	qDebug() <<"Exit Status "<<proc->exitStatus() ;
	QString sErr = proc->readAllStandardError();
	addTextPE ( proc->readAllStandardOutput() +"<br>"+sErr );
	if ( sErr.isEmpty() )
	{
		addTextTE ( tr ( "<br>&raquo;Done!<br>&raquo;Background from file %1<br>&nbsp;&nbsp;has been applied to %2" ).arg ( IFILE1 ).arg ( IFILE ) );
		if ( copyEFILE ( EFILE_1, EFILE ) )
		{
			addTextTE ( tr ( "Output file successfully generated and saved to<br> <b> %3</b>" ).arg ( EFILE ) );
			onView ( EFILE, true );
		}
	}
	else
	{
		if ( !sErr.contains ( "OWNER PASSWORD" ) ) TE->setText ( TE->toHtml() +tr ( "<br><font color=red><b>Error!</b></font><br>" ) +sErr );
		if ( sErr.contains ( "OWNER PASSWORD" ) )
		{
			bool cont = false;
			QString paStr;
			while ( !cont )
			{
				QMessageBox::warning ( this, tr ( "Attention" ), tr ( "Owner password required !<br>No/incorrect password given" ) );
				if ( QMessageBox::question ( this, tr ( "Input password" ), tr ( "Do you want to input password?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes )
				{
					paStr = QInputDialog::getText ( this, tr ( "Password" ), tr ( "Input password" ), QLineEdit::Password, "" );
					if ( paStr.isEmpty() ) {cont = true;passcorr = false;}
					else
					{
						procSTR = pdftkBin+" \""+IFILE+"\" input_pw \""+paStr+"\" background \""+IFILE1+"\" output \""+EFILE_1+"\"";
						qDebug() <<"procSTR= "<<procSTR;
						proc = new QProcess ( this );
						proc->start ( procSTR );
						addTextPEc ( procSTR );
						if ( !proc->waitForStarted() ) {qDebug() <<"Could not start";return;}
						if ( !proc->waitForFinished() ) {qDebug() <<"Could not finish";return;}
						sErr = proc->readAllStandardError();
						addTextPE ( proc->readAllStandardOutput() +"<br>"+sErr );
						if ( !sErr.isEmpty() && sErr.contains ( "OWNER PASSWORD" ) ) {}
						if ( !sErr.isEmpty() && !sErr.contains ( "OWNER PASSWORD" ) ) {cont = true;passcorr = false;}
						if ( sErr.isEmpty() )
						{
							cont = true;passcorr = true;
							addTextTE ( tr ( "<br>&raquo;Done!<br>&raquo;Background from file %1<br>&nbsp;&nbsp;has been applied to %2" ).arg ( IFILE1 ).arg ( IFILE ) );
							if ( copyEFILE ( EFILE_1, EFILE ) )
							{
								addTextTE ( tr ( "Output file successfully generated and saved to<br> <b> %3</b>" ).arg ( EFILE ) );
								onView ( EFILE, true );
							}
						}
					}
				}
				else{cont = true;passcorr = false;}
			}
		}
	}
}
