/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "suslictk.h"

void SuslicTk::onDecrypt ( QString ifile )
{
	if ( !tkPresent )
	{
		QMessageBox::warning ( this, tr ( "Error" ), tr ( "This action cannot be performed without pdftk binary! Please, install pdftk and specify it's location in Preferences." ) );
		return;
	}
	QString IFILE;
	if ( ifile.isEmpty() ) IFILE = QFileDialog::getOpenFileName ( this, tr ( "Select PDF file to decrypt:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
	else IFILE = ifile;
	if ( IFILE.isEmpty() ) return;
	QString IFILE_C;bool change;
	IFILE_C = checkPath ( IFILE, "decr", &change );
	onSetDir ( getDirFromFile ( IFILE ) );
	proc = new QProcess ( this );
	proc->start ( pdftkBin+" \""+IFILE_C+"\" dump_data output -" );
	addTextPEc ( pdftkBin+" \""+IFILE_C+"\" dump_data output -" );
	if ( !proc->waitForStarted() || !proc->waitForFinished() ) {return;}
	QString sErr = proc->readAllStandardError();
	addTextPE ( proc->readAllStandardOutput() + "<br>" + sErr );
	if ( sErr.isEmpty() )
	{
		QMessageBox::information ( this, "", "File is not encrypted!" );
		return;
	}
	if ( !sErr.contains ( "OWNER PASSWORD" ) )
	{
		QMessageBox::warning ( this, "", "Unknown error occurred!<br>Aborting!" );
		TE->setText ( TE->toHtml() +"<br>Error:<br>"+sErr );
		return;
	}
	QString EFILE, EFILE_1;
	bool replace = false;
	if ( QMessageBox::question ( this, "", "Replace input file with decrypted one?", QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes ) replace = true;
decr_rep:
	bool ok;
	QString text = QInputDialog::getText ( this, tr ( "Decrypt tool" ), tr ( "Owner Password:" ), QLineEdit::Password,"", &ok );
	if ( ok && !text.isEmpty() )
	{
		if ( !replace )
		{
			EFILE = QFileDialog::getSaveFileName ( this, tr ( "Save result as:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
			if ( !EFILE.isEmpty() && !EFILE.endsWith ( ".pdf", Qt::CaseInsensitive ) ) EFILE+=".pdf";
			EFILE_1 = checkSaveFile ( EFILE );
			if ( EFILE.isEmpty() ) return;
			onSetDir ( getDirFromFile ( EFILE ) );
			if ( EFILE == IFILE ) replace = true;
		}
		else
		{
			EFILE = IFILE;
			EFILE_1 = checkSaveFile ( EFILE );
			replace = true;
		}
		if ( !replace )
		{
			QString decr = pdftkBin+" \""+IFILE_C+"\" input_pw \""+text+"\" output \""+EFILE_1+"\"";
			proc = new QProcess();
			proc->start ( decr );
			addTextPEc ( decr );
			if ( !proc->waitForStarted() ) {qDebug() <<"Couldn't start";return;}
			if ( !proc->waitForFinished () ) {qDebug() <<"Not finished!";return;}
			qDebug() <<"Exit  Code: "<<proc->exitCode() ;
			qDebug() <<"Exit Status "<<proc->exitStatus() ;
			//QString sNum = getpage.readAllStandardOutput();
			sErr = proc->readAllStandardError();
			addTextPE ( proc->readAllStandardOutput() + "<br>" + sErr );
			if ( sErr.contains ( "OWNER PASSWORD" ) )
			{
				QMessageBox::information ( this, "Error", tr ( "Incorrect password!<br>Command line output:<br>%1" ).arg ( sErr ) );
				if ( QMessageBox::question ( this, tr ( "Save" ), tr ( "Do you want to try once more?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes ) {goto decr_rep;}
			}
			if ( sErr.isEmpty() )
			{
				if ( copyEFILE ( EFILE_1, EFILE ) )
				{
					addTextTE ( tr ( "<br>&raquo;Done!<br>&raquo;Output successfully saved to<br>&nbsp;&nbsp;%1" ).arg ( EFILE ) );
					onView ( EFILE, true );
				}
			}
			if ( !sErr.isEmpty() && !sErr.contains ( "OWNER PASSWORD" ) )
				{TE->setText ( TE->toHtml() +"<br><font color=red><b>Error!</b></font><br>"+sErr );}
		}
		else
		{
			QString tmp = homePDF->absolutePath() +"/decrypt_"+QTime::currentTime().toString ( "hh_mm_ss" ) +".pdf";
			QString decr = pdftkBin+" \""+IFILE_C+"\" input_pw \""+text+"\" output \""+tmp+"\"";
			proc = new QProcess();
			proc->start ( decr );
			addTextPEc ( decr );
			if ( !proc->waitForStarted() ) {qDebug() <<"Couldn't start";return;}
			if ( !proc->waitForFinished () ) {qDebug() <<"Not finished!";return;}
			qDebug() <<"Exit  Code: "<<proc->exitCode() ;
			qDebug() <<"Exit Status "<<proc->exitStatus() ;
			//QString sNum = getpage.readAllStandardOutput();
			sErr = proc->readAllStandardError();
			addTextPE ( proc->readAllStandardOutput() + "<br>" + sErr );
			if ( sErr.contains ( "OWNER PASSWORD" ) )
			{
				QMessageBox::information ( this, "Error", tr ( "Incorrect password!<br>Command line output:<br>%1" ).arg ( sErr ) );
				if ( QMessageBox::question ( this, tr ( "Save" ), tr ( "Do you want to try once more?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes ) {goto decr_rep;}
			}
			if ( sErr.isEmpty() )
			{
				if ( !QFile ( EFILE ).remove() || !QFile().copy ( tmp, EFILE ) )
				{
					TE->setText ( TE->toHtml() +"<br>Failed to replace input file." );
				}
				else
				{
					TE->setText ( TE->toHtml() +"<br>&raquo;Done!<br>&raquo;Output successfully saved to<br>&nbsp;&nbsp;"+EFILE );
					onView ( EFILE, true );
				}
				if ( !QFile ( tmp ).remove() ) {TE->setText ( TE->toHtml() +"<br>Failed to delete temporary file!" );}
			}
			if ( !sErr.isEmpty() && !sErr.contains ( "OWNER PASSWORD" ) )
				{TE->setText ( TE->toHtml() +"<br><font color=red><b>Error!</b></font><br>"+sErr );}
		}
	}
}
