/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "suslictk.h"

void SuslicTk::onDump(QString ifile)
{
	if(!tkPresent)
	{
		QMessageBox::warning(this, tr("Error"), tr("This action cannot be performed without pdftk binary! Please, install pdftk and specify it's location in Preferences."));
		return;
	}
	passcorr = true;
	bool change;

	prog_com = new QProgressDialog ( tr ( "Processing file" ), tr ( "Cancel" ), 0, 4, this );
	prog_com->show();
	prog_com->setWindowModality ( Qt::WindowModal );
	prog_com->setValue ( 0 );

	QString paStr = "";
	QString IFILE;
	if(ifile.isEmpty()) IFILE = QFileDialog::getOpenFileName ( this, tr ( "Select PDF file:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
	else IFILE = ifile;
	if ( IFILE.isEmpty())
	{
		prog_com->setValue ( 4 );
		return;
	}
	QString OIFILE = IFILE;
	IFILE = checkPath ( IFILE, "dump", &change );
	if ( IFILE.isEmpty() )
	{
		prog_com->setValue ( 4 );
		return;
	}
	onSetDir(getDirFromFile ( OIFILE ));

	QString dump = pdftkBin+" \""+IFILE+"\" dump_data output -";
	prog_com->setValue ( 1 );
	proc = new QProcess();
	proc->setWorkingDirectory ( getDirFromFile ( IFILE ) );
	proc->start ( dump );
	addTextPEc(dump);
	if ( !proc->waitForStarted() )
	{
		qDebug() <<"Couldn't start";
		prog_com->setValue ( 4 );
		return;
	}
	if ( !proc->waitForFinished ( 120000 ) )
	{
		qDebug() <<"Not finished!";
		TE->setText ( TE->toHtml() +"<br>"+"Process forced to finished (timeout)" );
		prog_com->setValue ( 4 );
		return;
	}
	qDebug() <<"Exit  Code: "<<proc->exitCode() ;
	qDebug() <<"Exit Status "<<proc->exitStatus() ;
	QString dump_data = proc->readAllStandardOutput();
	qDebug()<<"dump_data:\n"<<dump_data;
	QString sErr = proc->readAllStandardError();
	addTextPE(dump_data + "<br>" + sErr);
	if ( !sErr.isEmpty() )
	{
		bool cont = false;
		passcorr = false;
		if ( sErr.contains ( "OWNER PASSWORD" ) )
		{
			while ( !cont )
			{
				QMessageBox::warning ( this, tr ( "Attention" ), tr ( "Owner password required!<br>No/incorrect password given" ) );
				if ( QMessageBox::question ( this, tr ( "Input password" ), tr ( "Do you want to input password?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes )
				{
					paStr = QInputDialog::getText ( this, tr ( "Password" ), tr ( "Input password" ), QLineEdit::Password, "" );
					if ( paStr.isEmpty() ) {cont = true;passcorr = false;}
					else
					{
						dump = pdftkBin+" \""+QFileInfo ( IFILE ).fileName() +"\" input_pw \""+paStr+"\" dump_data output -";
						qDebug() <<"dump= "<<dump ;
						proc = new QProcess ( this );
						proc->setWorkingDirectory ( getDirFromFile ( IFILE ) );
						proc->start ( dump );
						addTextPEc(dump);
						if ( !proc->waitForStarted() )
						{
							qDebug() <<"Could not start";
							prog_com->setValue ( 4 );
							return;
						}
						if ( !proc->waitForFinished ( 120000 ) )
						{
							qDebug() <<"Not finished!";
							prog_com->setValue ( 4 );
							TE->setText ( TE->toHtml() +"<br>"+"Process forced to finished (timeout)" );
							return;
						}
						sErr = proc->readAllStandardError();
						//qDebug()<<"sErr= "<<sErr;
						if ( !sErr.isEmpty() && sErr.contains ( "OWNER PASSWORD" ) ) {}
						if ( !sErr.isEmpty() && !sErr.contains ( "OWNER PASSWORD" ) ) {cont = true;passcorr = false;}
						if ( sErr.isEmpty() )
						{
							cont = true;passcorr = true;
							dump_data = proc->readAllStandardOutput();
							//qDebug()<<"dump_data:\n"<<dump_data;
						}
						addTextPE(dump_data + "<br>" + sErr);
					}
				}
				else{cont = true;passcorr = false;}
			}
		}
		else
		{
			QMessageBox::critical ( this, tr ( "Error!" ), tr ( "An error occurred! Process output:<br>" ) +sErr );
			TE->setText ( TE->toHtml() +"<br>"+sErr );
			prog_com->setValue ( 4 );
			return;
		}
	}
	if ( passcorr && !prog_com->wasCanceled() )
	{
		QString dump_fields;
		if ( paStr.isEmpty() ) {dump_fields = pdftkBin+" \""+QFileInfo ( IFILE ).fileName() +"\" dump_data_fields output -";}
		else{dump_fields = pdftkBin+" \""+QFileInfo ( IFILE ).fileName() +"\" input_pw \""+paStr+"\" dump_data_fields output -";}
		prog_com->setValue ( 2 );
		proc = new QProcess();
		proc->setWorkingDirectory ( getDirFromFile ( IFILE ) );
		proc->start ( dump_fields );
		addTextPEc(dump_fields);
		if ( !proc->waitForStarted() )
		{
			qDebug() <<"Couldn't start";
			prog_com->setValue ( 4 );
			return;
		}
		if ( !proc->waitForFinished ( 120000 ) )
		{
			qDebug() <<"Not finished!";
			prog_com->setValue ( 4 );
			TE->setText ( TE->toHtml() +"<br>"+"Process forced to finished (timeout)" );
			return;
		}
		qDebug() <<"Exit  Code: "<<proc->exitCode() ;
		qDebug() <<"Exit Status "<<proc->exitStatus() ;
		QString dump_data_fields = proc->readAllStandardOutput();
		addTextPE(dump_data_fields + "<br>" + proc->readAllStandardError());
		prog_com->setValue ( 3 );
		QFileInfo fileInfo ( OIFILE );
		QString file_info = tr ( "<li>Path: %1<br>Size: %2 kB<li>Created (or inode information set/written): %3<li>Modified: %4<li>Hidden:" ).arg ( OIFILE ).arg ( fileInfo.size() /1024. ).arg ( fileInfo.created().toString ( "hh:mm:ss dd MMM yyyy" ) ).arg ( fileInfo.lastModified().toString ( "hh:mm:ss dd MMM yyyy" ) );
		if ( fileInfo.isHidden() ) file_info+=tr ( "Yes" );
		else file_info+=tr ( "No" );
		if ( fileInfo.isSymLink() ) {file_info+=tr ( "<li>Symlink: Yes<li>Symlink target: %1\n" ).arg ( fileInfo.symLinkTarget() );}
		else{file_info+=tr ( "<li>Symlink: No\n" );}
		file_info+="<li>";file_info+=tr ( "Owner: %1" ).arg ( fileInfo.owner() );
		QString disp_dump_data = dump_data;
		disp_dump_data.replace ( QString ( "InfoKey:" ), QString ( "" ) );
		disp_dump_data.replace ( QString ( "\nInfoValue" ), QString ( "" ) );
		disp_dump_data.replace ( QString ( "\n " ), QString ( "\n" ) );
		disp_dump_data.replace ( QRegExp("(\\n)$"), "");
		disp_dump_data = "<li>"+disp_dump_data.replace ( "\n", "<li>" );
		//qDebug()<<"disp_dump_data:\n"<<disp_dump_data;
		if ( dump_data_fields.isEmpty() )
		{
			dump_data_fields = "Empty";
		}
		else
		{
			dump_data_fields = "<li>"+dump_data_fields.replace ( "\n", "<li>" );
		}
		prog_com->setValue ( 4 );
		Dump dump ( this, Qt::Tool );
		dump.fileDump = file_info;
		dump.pdfDump = disp_dump_data;
		dump.formDump = dump_data_fields;
		dump.fName = OIFILE;
		dump.INIT();
		dump.exec();
		qDebug() <<"dump show";
	}
	else
	{
		qDebug() <<"canceled";
		prog_com->setValue ( 4 );
	}
	if ( change ) onRemTemp ( true );
}
