/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "Encoding.h"
Encoding::Encoding ( QWidget *parent, Qt::WindowFlags f, QString file, bool ifsave )
{
	if ( parent != NULL ) {setParent ( parent );}
	if ( f != NULL ) {setWindowFlags ( f );}

	ifilename  = file;
	ifile = new QFile ( file );
	if ( !ifile->exists() ) reject();

	savedir = QFileInfo ( file ).absolutePath();

	setObjectName ( QString::fromUtf8 ( "Encoding" ) );
	this->resize ( 544, 454 );
	verticalLayout_2 = new QVBoxLayout ( this );
	verticalLayout_2->setObjectName ( QString::fromUtf8 ( "verticalLayout_2" ) );

	groupBox_3 = new QGroupBox ( this );
	groupBox_3->setObjectName ( QString::fromUtf8 ( "groupBox_3" ) );
	gridLayout = new QGridLayout ( groupBox_3 );
	gridLayout->setObjectName ( QString::fromUtf8 ( "gridLayout" ) );
	label = new QLabel ( groupBox_3 );
	label->setObjectName ( QString::fromUtf8 ( "label" ) );

	gridLayout->addWidget ( label, 0, 0, 1, 1 );

	inputCombo = new QComboBox ( groupBox_3 );
	inputCombo->setObjectName ( QString::fromUtf8 ( "inputCombo" ) );

	gridLayout->addWidget ( inputCombo, 0, 1, 1, 1 );

	searchButton = new QPushButton ( groupBox_3 );
	searchButton->setObjectName ( QString::fromUtf8 ( "searchButton" ) );

	gridLayout->addWidget ( searchButton, 0, 2, 1, 1 );

	label_2 = new QLabel ( groupBox_3 );
	label_2->setObjectName ( QString::fromUtf8 ( "label_2" ) );

	gridLayout->addWidget ( label_2, 1, 0, 1, 1 );

	spinBox = new QSpinBox ( groupBox_3 );
	spinBox->setObjectName ( QString::fromUtf8 ( "spinBox" ) );
	spinBox->setRange ( 1, 100 );
	gridLayout->addWidget ( spinBox, 1, 1, 1, 1 );


	verticalLayout_2->addWidget ( groupBox_3 );

	groupBox = new QGroupBox ( this );
	groupBox->setObjectName ( QString::fromUtf8 ( "groupBox" ) );
	verticalLayout = new QVBoxLayout ( groupBox );
	verticalLayout->setObjectName ( QString::fromUtf8 ( "verticalLayout" ) );
	textBrowser = new QTextBrowser ( groupBox );
	textBrowser->setObjectName ( QString::fromUtf8 ( "textBrowser" ) );

	verticalLayout->addWidget ( textBrowser );


	verticalLayout_2->addWidget ( groupBox );

	groupBox_2 = new QGroupBox ( this );
	groupBox_2->setObjectName ( QString::fromUtf8 ( "groupBox_2" ) );
	gridLayout_2 = new QGridLayout ( groupBox_2 );
	gridLayout_2->setObjectName ( QString::fromUtf8 ( "gridLayout_2" ) );
	label_3 = new QLabel ( groupBox_2 );
	label_3->setObjectName ( QString::fromUtf8 ( "label_3" ) );

	gridLayout_2->addWidget ( label_3, 0, 0, 1, 1 );

	outputCombo = new QComboBox ( groupBox_2 );
	outputCombo->setObjectName ( QString::fromUtf8 ( "outputCombo" ) );

	gridLayout_2->addWidget ( outputCombo, 0, 1, 1, 1 );

	searchButton2 = new QPushButton ( groupBox_2 );
	searchButton2->setObjectName ( QString::fromUtf8 ( "searchButton2" ) );

	gridLayout_2->addWidget ( searchButton2, 0, 2, 1, 1 );

	saveButton = new QPushButton ( groupBox_2 );
	saveButton->setObjectName ( QString::fromUtf8 ( "saveButton" ) );

	gridLayout_2->addWidget ( saveButton, 1, 1, 1, 1 );


	verticalLayout_2->addWidget ( groupBox_2 );

	horizontalLayout_2 = new QHBoxLayout();
	horizontalLayout_2->setObjectName ( QString::fromUtf8 ( "horizontalLayout_2" ) );
	horizontalSpacer_2 = new QSpacerItem ( 40, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );

	horizontalLayout_2->addItem ( horizontalSpacer_2 );

	CAB = new QPushButton ( this );
	CAB->setObjectName ( QString::fromUtf8 ( "CAB" ) );

	horizontalLayout_2->addWidget ( CAB );

	OKB = new QPushButton ( this );
	OKB->setObjectName ( QString::fromUtf8 ( "OKB" ) );

	horizontalLayout_2->addWidget ( OKB );


	verticalLayout_2->addLayout ( horizontalLayout_2 );


	save = ifsave;

	///////////////////
	if ( !ifile->exists() ) //should never happen
	{
		QMessageBox::critical ( this, "", tr ( "File %1 does not exist!" ).arg ( ifile->fileName() ) );
		reject();
	}
	if ( !ifile->open ( QFile::ReadOnly|QFile::Text ) )
	{
		QMessageBox::warning ( this, "", tr ( "Cannot read file or not a text file!" ) );
		reject();
	}
	///////////////////

	retranslateUi();

	connect ( inputCombo, SIGNAL ( currentIndexChanged ( int ) ), this, SLOT ( onInputEnc ( int ) ) );
	connect ( saveButton, SIGNAL ( clicked() ), this, SLOT ( onSave() ) );
	connect ( CAB, SIGNAL ( clicked() ), this, SLOT ( reject() ) );
	connect ( OKB, SIGNAL ( clicked() ), this, SLOT ( readAllFile() ) );
	connect ( searchButton, SIGNAL ( clicked() ), this, SLOT ( onSearchInput() ) );
	connect ( searchButton2, SIGNAL ( clicked() ), this, SLOT ( onSearchOutput() ) );
	connect ( spinBox, SIGNAL ( valueChanged ( int ) ), this, SLOT ( onLines ( int ) ) );

	readFile ();
}
void Encoding::readAllFile()
{
	QTextStream in ( ifile );
	in.seek ( 0 );
	in.setCodec ( QTextCodec::codecForName ( codecList[inputCombo->currentIndex() ] ) );
	data = in.readAll();
	ifile->close();
	accept();
}
void Encoding::readFile ( QByteArray codecName )
{
	//textCodec = new QTextCodec(codecName);
	QTextStream in ( ifile );
	in.seek ( 0 );
	in.setCodec ( !codecName.isEmpty() ? QTextCodec::codecForName ( codecName ) : QTextCodec::codecForLocale() );
	textBrowser->clear();
	for ( int j=0;j<spinBox->value();j++ )
	{
		textBrowser->setText ( textBrowser->toPlainText() +"\n"+in.readLine() );
		if ( in.atEnd() ) break;
	}
}
void Encoding::onSearchInput()
{
	QString search = QInputDialog::getText ( this, "Encoding search", tr ( "Search encoding:<br>(reg. exp. , wildcard, case insensitive)" ) );
	if ( search.isEmpty() ) return;
	qDebug() <<"searching for "<<search;
	QStringList searchList;
	QRegExp rx ( search, Qt::CaseInsensitive, QRegExp::Wildcard );
	if ( !rx.isValid() )
	{
		qDebug() <<"invalid regexp";
		if ( search.contains ( "*" ) )	search = search.split ( "*", QString::SkipEmptyParts ).first();
		if ( search.contains ( "?" ) ) search = search.split ( "?", QString::SkipEmptyParts ).first();
		if ( search.contains ( "[" ) ) search = search.split ( "[", QString::SkipEmptyParts ).first();
		searchList = codecStringList.filter ( search, Qt::CaseInsensitive );
	}
	else searchList = codecStringList.filter ( rx );
	if ( searchList.isEmpty() ) QMessageBox::information ( this, "Encoding search", tr ( "Encoding %1 not found!" ).arg ( search ) );
	else if ( searchList.count() == 1 ) inputCombo->setCurrentIndex ( codecStringList.indexOf ( searchList[0] ) );
	else
	{
		bool ok;
		search = QInputDialog::getItem ( this, "Encoding search", tr ( "Encodings matching %1:" ).arg ( search ), searchList, 0, false, &ok );
		if ( ok ) inputCombo->setCurrentIndex ( codecStringList.indexOf ( search ) );
	}
}
void Encoding::onSearchOutput()
{
	QString search = QInputDialog::getText ( this, "Encoding search", tr ( "Search encoding:<br>(reg. exp. , wildcard, case insensitive)" ) );
	if ( search.isEmpty() ) return;
	qDebug() <<"searching for "<<search;
	QStringList searchList;
	QRegExp rx ( search, Qt::CaseInsensitive, QRegExp::Wildcard );
	if ( !rx.isValid() )
	{
		qDebug() <<"invalid regexp";
		if ( search.contains ( "*" ) )	search = search.split ( "*", QString::SkipEmptyParts ).first();
		if ( search.contains ( "?" ) ) search = search.split ( "?", QString::SkipEmptyParts ).first();
		if ( search.contains ( "[" ) ) search = search.split ( "[", QString::SkipEmptyParts ).first();
		searchList = codecStringList.filter ( search, Qt::CaseInsensitive );
	}
	else searchList = codecStringList.filter ( rx );
	if ( searchList.isEmpty() ) QMessageBox::information ( this, "Encoding search", tr ( "Encoding %1 not found!" ).arg ( search ) );
	else if ( searchList.count() == 1 ) outputCombo->setCurrentIndex ( codecStringList.indexOf ( searchList[0] ) );
	else
	{
		bool ok;
		search = QInputDialog::getItem ( this, "Encoding search", tr ( "Encodings matching %1:" ).arg ( search ), searchList, 0, false, &ok );
		if ( ok ) outputCombo->setCurrentIndex ( codecStringList.indexOf ( search ) );
	}
}
void Encoding::retranslateUi()
{
	setWindowTitle ( QApplication::translate ( "Encoding", "Encoding", 0, QApplication::UnicodeUTF8 ) );
	label->setText ( QApplication::translate ( "Encoding", "Encoding:", 0, QApplication::UnicodeUTF8 ) );
	label_2->setText ( QApplication::translate ( "Encoding", "Number of lines to read:", 0, QApplication::UnicodeUTF8 ) );
	groupBox->setTitle ( QApplication::translate ( "Encoding", "Preview:", 0, QApplication::UnicodeUTF8 ) );
	groupBox_2->setTitle ( QApplication::translate ( "Encoding", "Output:", 0, QApplication::UnicodeUTF8 ) );
	groupBox_3->setTitle ( QApplication::translate ( "Encoding", "Input:", 0, QApplication::UnicodeUTF8 ) );
	label_3->setText ( QApplication::translate ( "Encoding", "Encoding:", 0, QApplication::UnicodeUTF8 ) );
	saveButton->setText ( QApplication::translate ( "Encoding", "&Save in selected encoding", 0, QApplication::UnicodeUTF8 ) );
	searchButton->setText ( QApplication::translate ( "Encoding", "&Search", 0, QApplication::UnicodeUTF8 ) );
	searchButton2->setText ( QApplication::translate ( "Encoding", "&Search", 0, QApplication::UnicodeUTF8 ) );

	///////////////////////////////////////////////////////////////
	codecList = QTextCodec::availableCodecs ();
	for ( int i=0;i<codecList.count();i++ )
	{
		codecStringList<<QString ( codecList[i] );
	}
	inputCombo->addItems ( codecStringList );
	outputCombo->addItems ( codecStringList );
	///////////////////////////////////////////////////////////////

	if ( !save )
	{
		groupBox_2->setEnabled ( false );
		CAB->setText ( QApplication::translate ( "Encoding", "Ca&ncel", 0, QApplication::UnicodeUTF8 ) );
		OKB->setText ( QApplication::translate ( "Encoding", "&OK", 0, QApplication::UnicodeUTF8 ) );
	}
	else
	{
		CAB->setText ( QApplication::translate ( "Encoding", "&Close", 0, QApplication::UnicodeUTF8 ) );
		OKB->setVisible ( false );
	}
}
void Encoding::onSave()
{
	QTextStream in ( ifile );
	in.seek ( 0 );
	in.setCodec ( QTextCodec::codecForName ( codecList[inputCombo->currentIndex() ] ) );
	QString text = in.readAll();
	QString filename = QFileDialog::getSaveFileName ( this, tr ( "Save as" ), savedir );
	if ( !filename.isEmpty() )
	{
		if ( filename != ifilename )
		{
			QFile file1 ( filename );
			if ( !file1.open ( QFile::WriteOnly|QFile::Text ) )
			{
				QMessageBox::warning ( this, "", tr ( "Cannot write to file %1" ).arg ( filename ) );
			}
			else
			{
				QTextStream out ( &file1 );
				out.setCodec ( QTextCodec::codecForName ( codecList[outputCombo->currentIndex() ] ) );
				qDebug() <<codecList[outputCombo->currentIndex() ];
				out<<text;
				file1.close();
			}
		}
		else
		{
			ifile->close();
			if ( !ifile->open ( QFile::WriteOnly|QFile::Text ) )
			{
				QMessageBox::warning ( this, "", tr ( "Cannot write to file %1" ).arg ( filename ) );
			}
			else
			{
				QTextStream out ( ifile );
				out.setCodec ( QTextCodec::codecForName ( codecList[outputCombo->currentIndex() ] ) );
				qDebug() <<codecList[outputCombo->currentIndex() ];
				out<<text;
				ifile->close();
				if ( !ifile->open ( QFile::ReadOnly|QFile::Text ) )
				{
					QMessageBox::warning ( this, "", tr ( "Cannot open file %1" ).arg ( filename ) );
					reject();
				}
				inputCombo->setCurrentIndex(outputCombo->currentIndex());
				readFile(codecList[outputCombo->currentIndex() ]);
			}
		}
	}
}
void Encoding::onInputEnc ( int i )
{
	readFile ( codecList[i] );
}
void Encoding::onLines ( int i )
{
	readFile ( codecList[inputCombo->currentIndex() ] );
}

Encoding::~Encoding()
{
	destroy();
}

