/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef ENCODING_H
#define ENCODING_H

#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QComboBox>
#include <QtGui/QDialog>
#include <QtGui/QGridLayout>
#include <QtGui/QGroupBox>
#include <QtGui/QHBoxLayout>
#include <QtGui/QHeaderView>
#include <QtGui/QLabel>
#include <QtGui/QPushButton>
#include <QtGui/QSpacerItem>
#include <QtGui/QSpinBox>
#include <QtGui/QTextBrowser>
#include <QtGui/QVBoxLayout>

#include <QTextCodec>
#include <QByteArray>
#include <QFile>
#include <QFileInfo>
#include <QFileDialog>
#include <QTextStream>
#include <QMessageBox>
#include <QDebug>
#include <QInputDialog>

class Encoding: public QDialog
{
		Q_OBJECT
	public:
		Encoding ( QWidget *parent = 0, Qt::WindowFlags f = Qt::Dialog, QString file = "", bool ifsave = true );
		~Encoding();
		void retranslateUi();
		QString data;
	private slots:
		void onSave();
		void onInputEnc ( int i );
		void onLines ( int i );
		void readAllFile();
		void onSearchInput();
		void onSearchOutput();
	private:

		void readFile ( QByteArray codec = "" );

		bool save;
		QFile *ifile;
		QString savedir, ifilename;
		//QTextStream *textStream;
		QList<QByteArray> codecList;
		QStringList codecStringList;
		QVBoxLayout *verticalLayout_2;
		QGridLayout *gridLayout;
		QLabel *label;
		QComboBox *inputCombo;
		QLabel *label_2;
		QSpinBox *spinBox;
		QGroupBox *groupBox, *groupBox_3;
		QVBoxLayout *verticalLayout;
		QTextBrowser *textBrowser;
		QGroupBox *groupBox_2;
		QGridLayout *gridLayout_2;
		QLabel *label_3;
		QComboBox *outputCombo;
		QPushButton *saveButton;
		QPushButton *searchButton, *searchButton2;
		QHBoxLayout *horizontalLayout_2;
		QSpacerItem *horizontalSpacer_2;
		QPushButton *CAB;
		QPushButton *OKB;
};

#endif
