/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ENCRYPT_H
#define ENCRYPT_H

#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QCheckBox>
#include <QtGui/QDialog>
#include <QtGui/QGridLayout>
#include <QtGui/QGroupBox>
#include <QtGui/QHBoxLayout>
#include <QtGui/QVBoxLayout>
#include <QtGui/QHeaderView>
#include <QtGui/QLineEdit>
#include <QtGui/QPushButton>
#include <QtGui/QRadioButton>
#include <QtGui/QWidget>
#include <QtGui/QSpacerItem>
#include <QKeyEvent>
#include <QToolTip>
#include <QMessageBox>
#include <QDebug>
#include <QRegExpValidator>

class Encrypt: public QDialog
{
		Q_OBJECT
	public:
		Encrypt ( QWidget* parent = 0, Qt::WindowFlags f = Qt::Dialog, QString bg = "" );
		~Encrypt();
		QString result;
	protected:
		void keyPressEvent ( QKeyEvent *event );
	private slots:
		void onUser ( bool check );
		void onOwner ( bool check );
		void onAllRadio ( bool check );
		void onSelRadio ( bool check );
		void on40 ( bool check );
		void on128 ( bool check );
		void onUserEdit ( QString str );
		void onOwnerEdit ( QString str );
		void onOK();
	private:
		QGroupBox *groupBox;
		QWidget *widget;
		QGridLayout *gridLayout;
		QCheckBox *userCheck;
		QLineEdit *userEdit;
		QCheckBox *ownerCheck;
		QLineEdit *ownerEdit;
		QGroupBox *groupBox_2;
		QWidget *widget1;
		QHBoxLayout *horizontalLayout;
		QRadioButton *radio40;
		QRadioButton *radio128;
		QGroupBox *groupBox_3;
		QGroupBox *featureGroupbox;
		QWidget *widget2;
		QGridLayout *gridLayout_2;
		QCheckBox *Printing;
		QCheckBox *CopyContents;
		QCheckBox *DegradedPrinting;
		QCheckBox *ScreenReaders;
		QCheckBox *ModifyContents;
		QCheckBox *ModifyAnnotations;
		QCheckBox *Assembly;
		QCheckBox *FillIn;
		QSpacerItem *horizontalSpacer;

		QString opa, upa, encrt;
		QWidget *widget3;
		QHBoxLayout *horizontalLayout_2;
		QRadioButton *allRadio;
		QRadioButton *selRadio;
		QWidget *widget4;
		QHBoxLayout *horizontalLayout_3;
		QVBoxLayout *verticalLayout;
		QPushButton *CAB;
		QPushButton *OKB;
		QVBoxLayout *allLayout;
};

#endif
