/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "suslictk.h"

void SuslicTk::onEncrypt ( QString ifile )
{
	if ( !tkPresent )
	{
		QMessageBox::warning ( this, tr ( "Error" ), tr ( "This action cannot be performed without pdftk binary! Please, install pdftk and specify it's location in Preferences." ) );
		return;
	}

	QString IFILE;
	if ( ifile.isEmpty() ) IFILE = QFileDialog::getOpenFileName ( this, tr ( "Select PDF file to encrypt:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
	else	IFILE = ifile;
	if ( IFILE.isEmpty() ) return;
	bool chan;
	QString OIFILE = checkPath ( IFILE, "encr", &chan );
	onSetDir ( getDirFromFile ( IFILE ) );
	QString dump = pdftkBin+" \""+OIFILE+"\" dump_data output -";
	proc = new QProcess();
	proc->start ( dump );
	addTextPEc ( dump );
	if ( !proc->waitForStarted() ) {qDebug() <<"Couldn't start";return;return;}
	if ( !proc->waitForFinished () ) {qDebug() <<"Not finished!";return;return;}
	qDebug() <<"Exit  Code: "<<proc->exitCode() ;
	qDebug() <<"Exit Status "<<proc->exitStatus() ;
	QString sErr = proc->readAllStandardError();
	addTextPE ( proc->readAllStandardOutput() + "<br>" + sErr );
	if ( sErr.isEmpty() )
	{
		if ( index[3] >=0 && index[3]<imgDB.count() ) encr = new Encrypt ( this, Qt::Dialog , imgDB[index[3]] );
		else	encr = new Encrypt ( this, Qt::Dialog , "" );
		if ( encr->exec() == 1 )
		{
			QString EFILE, EFILE_1;
			if ( QMessageBox::question ( this, "", tr ( "Do you want to save encrypted document as a new file?\nIf you select 'No', input file will be overwritten!" ), QMessageBox::Yes | QMessageBox::No ) == QMessageBox::No )
			{
				EFILE = IFILE;
				EFILE_1 = checkSaveFile ( EFILE );
				if ( !QFile().copy ( IFILE, homePDF->absolutePath() +"/tmp_encr_"+QFileInfo ( IFILE ).fileName() ) )
				{
					QMessageBox::warning ( this, "", tr ( "Failed to create temporary file\nYou will have to save encrypted file under a new name\nSorry..." ) );
					EFILE = QFileDialog::getSaveFileName ( this, tr ( "Save result as:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
					if ( !EFILE.isEmpty() && !EFILE.endsWith ( ".pdf", Qt::CaseInsensitive ) ) EFILE+=".pdf";
					if ( EFILE.isEmpty() )	return;
					EFILE_1 = checkSaveFile ( EFILE );
				}
				else
				{
					OIFILE = homePDF->absolutePath() +"/tmp_encr_"+QFileInfo ( IFILE ).fileName();
					qDebug() <<"IFILE="<<OIFILE<<"\nEFILE = "<<EFILE;
				}
			}
			else
			{
				EFILE = QFileDialog::getSaveFileName ( this, tr ( "Save result as:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
				if ( !EFILE.isEmpty() && !EFILE.endsWith ( ".pdf", Qt::CaseInsensitive ) ) EFILE+=".pdf";
				if ( EFILE.isEmpty() )	return;
				EFILE_1 = checkSaveFile ( EFILE );
			}
			onSetDir ( getDirFromFile ( EFILE ) );
			if ( onEncryptCore ( OIFILE, EFILE_1, encr->result ) && EFILE_1 != EFILE )
			{
				qDebug() <<"encr copy "<<copyEFILE ( EFILE_1, EFILE );
			}
			QStringList deltmp = homePDF->entryList ( QStringList() <<"tmp_encr*" );
			if ( !deltmp.isEmpty() )
			{
				for ( int i=0;i<deltmp.count();i++ )
				{
					if ( !QFile().remove ( homePDF->absolutePath() +"/"+deltmp[i] ) )
						qDebug() <<"Failed to delete temp file";
				}
			}
		}
		else qDebug() <<"encr canceled";
		delete encr;
	}
	else
	{
		TE->setText ( TE->toHtml() +tr ( "<br><font color=red><b>Error!</b></font><br>%1" ).arg ( sErr ) );
		QMessageBox::critical ( this, tr ( "Error" ), tr ( "An error occurred!<br>Click OK to see the output" ) );
		if ( sErr.contains ( "OWNER PASSWORD" ) )
		{
			QMessageBox::information ( this, tr ( "Password required" ), tr ( "Already Encrypted!" ) );
		}
		else
		{
			QMessageBox::critical ( this, tr ( "Error!" ), tr ( "Unknown error occurred!<br>Output of the process:<br>%1" ).arg ( sErr ) );
		}
	}
}

bool SuslicTk::onEncryptCore ( QString ifile, QString ofile, QString encrStr )
{
	QString encry = pdftkBin+" \""+ifile+"\" output \""+ofile+"\" "+encrStr;
	//QMessageBox::information ( this, tr ( "TODO" ), encry );
	proc = new QProcess();
	proc->start ( encry );
	if ( !proc->waitForStarted() ) {qDebug() <<"Couldn't start";return false;}
	if ( !proc->waitForFinished () ) {qDebug() <<"Not finished!";return false;}
	qDebug() <<"Exit  Code: "<<proc->exitCode() ;
	qDebug() <<"Exit Status "<<proc->exitStatus() ;
	QString sErr1 = proc->readAllStandardError();
	if ( sErr1.isEmpty() )
	{
		TE->setText ( TE->toHtml() +tr ( "<br>&raquo;Done!<br>&raquo;File <b>%1</b><br>is encrypted and successfully saved as<br><b>%2</b>" ).arg ( ifile ).arg ( ofile ) );
		return true;
	}
	else
	{
		TE->setText ( TE->toHtml() +tr ( "<br><font color=red><b>Error!</b></font><br>%1" ).arg ( sErr1 ) );
		QMessageBox::critical ( this, tr ( "Error!" ), tr ( "Unknown error occurred!<br>Output of the process:<br>%1" ).arg ( sErr1 ) );
		return false;
	}
	return false;
}
