/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "HTMLpreview.h"

HTMLpreview::HTMLpreview ( QString str, QString url, bool ifloc, QPrinter *printer, QWidget *parent, Qt::WindowFlags f )
{
	hprinter = printer;
	if ( parent != NULL ) setParent ( parent );
	if ( f != NULL ) setWindowFlags ( f );
	setObjectName ( QString::fromUtf8 ( "HTMLpreview" ) );
	setBaseSize ( 717, 587 );
	webView = new QWebView ( this );
	webView->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Preferred);
	webView->setObjectName ( QString::fromUtf8 ( "webView" ) );
	webPage = new QWebPage ( this );
	if ( ifloc ) webPage->mainFrame()->setUrl ( QUrl ( url ) );
	else webPage->mainFrame()->setHtml ( str, QUrl ( url ) );
	webView->setPage ( webPage );
	QHBoxLayout *hL = new QHBoxLayout ( this );
	hL->addWidget ( webView );
	QWidget *lW = new QWidget ( this );
	QVBoxLayout *vL = new QVBoxLayout ( lW );
	OKB = new QPushButton ( this );
	OKB->setObjectName ( QString::fromUtf8 ( "OKB" ) );
	//OKB->setGeometry ( QRect ( 620, 550, 80, 29 ) );
	CAB = new QPushButton ( this );
	CAB->setObjectName ( QString::fromUtf8 ( "CAB" ) );
	//CAB->setGeometry ( QRect ( 530, 550, 80, 29 ) );
	ILabel = new QLabel ( this );
	ILabel->setObjectName ( QString::fromUtf8 ( "ILabel" ) );
	ILabel->setText ( tr ( "<font color=red>Loading</font>" ) );
	//ILabel->setGeometry ( QRect ( 530, 550, 80, 29 ) );
	vL->addWidget ( OKB );
	vL->addWidget ( CAB );
	vL->addWidget ( ILabel );
	hL->addWidget ( lW );
	setWindowTitle ( QApplication::translate ( "HTMLpreview", "HTMLpreview", 0, QApplication::UnicodeUTF8 ) );
	OKB->setText ( QApplication::translate ( "HTMLpreview", "Convert", 0, QApplication::UnicodeUTF8 ) );
	CAB->setText ( QApplication::translate ( "HTMLpreview", "Cancel", 0, QApplication::UnicodeUTF8 ) );

	connect ( OKB, SIGNAL ( clicked() ), this, SLOT ( PRINT() ) );
	connect ( CAB, SIGNAL ( clicked() ), this, SLOT ( reject() ) );
	connect ( webPage, SIGNAL ( loadStarted() ), this, SLOT ( onLoad() ) );
	connect ( webPage, SIGNAL ( loadFinished ( bool ) ), this, SLOT ( onFinish ( bool ) ) );

}
void HTMLpreview::onLoad()
{
	ILabel->setText ( tr ( "<font color=red>Loading</font>" ) );
}
void HTMLpreview::onFinish ( bool ok )
{
	if ( ok ) ILabel->setText ( tr ( "<font color=blue>Ready</font>" ) );
	else ILabel->setText ( tr ( "<font color=red>Error</font>" ) );
}
void HTMLpreview::PRINT()
{
	webPage->mainFrame()->print ( hprinter );
	accept();
}
HTMLpreview::~HTMLpreview() {destroy();}
