/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "Help.h"

//#include <iostream>
//using namespace std;

Help::Help ( QWidget *parent, Qt::WindowFlags f, QString help_prefix )
{
	if ( parent != NULL ) {setParent ( parent );}
	if ( f != NULL ) {setWindowFlags ( f );}

	if ( help_prefix == "qrc" ) {prefix = "qrc:/docs/";}
	else prefix = "http://suslic-2012.narod.ru/docs/";

	setObjectName ( QString::fromUtf8 ( "Help" ) );
	resize ( 911, 625 );
	//tabWidget = new QTabWidget ( this );
	//tabWidget->setObjectName ( QString::fromUtf8 ( "tabWidget" ) );
	//tabWidget->setGeometry ( QRect ( 0, 0, 161, 621 ) );
	//contents = new QWidget();
	//contents->setObjectName ( QString::fromUtf8 ( "contents" ) );
	
	treeWidget = new QTreeWidget ( this );
	treeWidget->setObjectName ( QString::fromUtf8 ( "treeWidget" ) );
	treeWidget->setSizePolicy(QSizePolicy::Minimum,QSizePolicy::Expanding);

	//tabWidget->addTab ( treeWidget, QString() );

	/*search = new QWidget();
	search->setObjectName ( QString::fromUtf8 ( "search" ) );
	searchEdit = new QLineEdit ( search );
	searchEdit->setObjectName ( QString::fromUtf8 ( "searchEdit" ) );
	searchEdit->setGeometry ( QRect ( 10, 10, 131, 25 ) );
	groupBox = new QGroupBox ( search );
	groupBox->setObjectName ( QString::fromUtf8 ( "groupBox" ) );
	groupBox->setGeometry ( QRect ( 10, 40, 131, 121 ) );
	layoutWidget = new QWidget ( groupBox );
	layoutWidget->setObjectName ( QString::fromUtf8 ( "layoutWidget" ) );
	layoutWidget->setGeometry ( QRect ( 10, 20, 111, 91 ) );
	verticalLayout = new QVBoxLayout ( layoutWidget );
	verticalLayout->setObjectName ( QString::fromUtf8 ( "verticalLayout" ) );
	verticalLayout->setContentsMargins ( 0, 0, 0, 0 );
	textRButton = new QRadioButton ( layoutWidget );
	textRButton->setObjectName ( QString::fromUtf8 ( "textRButton" ) );

	verticalLayout->addWidget ( textRButton );

	regexpRButton = new QRadioButton ( layoutWidget );
	regexpRButton->setObjectName ( QString::fromUtf8 ( "regexpRButton" ) );

	verticalLayout->addWidget ( regexpRButton );

	wildRButton = new QRadioButton ( layoutWidget );
	wildRButton->setObjectName ( QString::fromUtf8 ( "wildRButton" ) );

	verticalLayout->addWidget ( wildRButton );

	groupBox_2 = new QGroupBox ( search );
	groupBox_2->setObjectName ( QString::fromUtf8 ( "groupBox_2" ) );
	groupBox_2->setGeometry ( QRect ( 10, 160, 131, 111 ) );
	layoutWidget1 = new QWidget ( groupBox_2 );
	layoutWidget1->setObjectName ( QString::fromUtf8 ( "layoutWidget1" ) );
	layoutWidget1->setGeometry ( QRect ( 10, 20, 118, 81 ) );
	verticalLayout_2 = new QVBoxLayout ( layoutWidget1 );
	verticalLayout_2->setObjectName ( QString::fromUtf8 ( "verticalLayout_2" ) );
	verticalLayout_2->setContentsMargins ( 0, 0, 0, 0 );
	curdocRButton = new QRadioButton ( layoutWidget1 );
	curdocRButton->setObjectName ( QString::fromUtf8 ( "curdocRButton" ) );

	verticalLayout_2->addWidget ( curdocRButton );

	alldocsRButton = new QRadioButton ( layoutWidget1 );
	alldocsRButton->setObjectName ( QString::fromUtf8 ( "alldocsRButton" ) );

	verticalLayout_2->addWidget ( alldocsRButton );

	findButton = new QPushButton ( search );
	findButton->setObjectName ( QString::fromUtf8 ( "findButton" ) );
	findButton->setGeometry ( QRect ( 60, 280, 86, 29 ) );
	tabWidget->addTab ( search, QString() );*/

	webBrowser = new QWebPage ( this );
	webBrowser->setObjectName ( QString::fromUtf8 ( "webBrowser" ) );
	webwidget = new QWebView ( this );
	webwidget->setSizePolicy(QSizePolicy::Expanding,QSizePolicy::Expanding);
	//webwidget->setGeometry ( QRect ( 170, 40, 731, 581 ) );
	layoutWidget2 = new QWidget ( this );
	layoutWidget2->setObjectName ( QString::fromUtf8 ( "layoutWidget2" ) );
	//layoutWidget2->setGeometry ( QRect ( 170, 0, 346, 31 ) );
	horizontalLayout = new QHBoxLayout ( layoutWidget2 );
	horizontalLayout->setObjectName ( QString::fromUtf8 ( "horizontalLayout" ) );
	//horizontalLayout->setContentsMargins ( 0, 0, 0, 0 );
	backButton = new QToolButton ( layoutWidget2 );
	backButton->setObjectName ( QString::fromUtf8 ( "backButton" ) );
	backButton->setArrowType ( Qt::NoArrow );
	backButton->setIcon ( QIcon ( qApp->style()->standardIcon(QStyle::SP_ArrowBack) ) );
	backButton->setToolTip ( "Back" );
	horizontalLayout->addWidget ( backButton );

	forwardButton = new QToolButton ( layoutWidget2 );
	forwardButton->setObjectName ( QString::fromUtf8 ( "forwardButton" ) );
	forwardButton->setIcon ( QIcon ( qApp->style()->standardIcon(QStyle::SP_ArrowForward) ) );
	forwardButton->setToolTip ( "Forward" );
	horizontalLayout->addWidget ( forwardButton );

	reloadButton = new QToolButton ( layoutWidget2 );
	reloadButton->setObjectName ( QString::fromUtf8 ( "reloadButton" ) );
	reloadButton->setIcon ( QIcon ( qApp->style()->standardIcon(QStyle::SP_BrowserReload) ) );
	reloadButton->setToolTip ( "Reload" );
	horizontalLayout->addWidget ( reloadButton );

	qsearchEdit = new QLineEdit ( layoutWidget2 );
	qsearchEdit->setObjectName ( QString::fromUtf8 ( "qsearchEdit" ) );

	horizontalLayout->addWidget ( qsearchEdit );

	searchButton = new QPushButton ( layoutWidget2 );
	searchButton->setObjectName ( QString::fromUtf8 ( "searchButton" ) );

	horizontalLayout->addWidget ( searchButton );

	stopButton = new QToolButton ( layoutWidget2 );
	stopButton->setObjectName ( QString::fromUtf8 ( "stopButton" ) );
	stopButton->setIcon ( QIcon ( qApp->style()->standardIcon(QStyle::SP_BrowserStop) ) );
	stopButton->setToolTip ( "Stop" );
	horizontalLayout->addWidget ( stopButton );

	status = new QProgressBar ( layoutWidget2 );
	status->setObjectName ( QString::fromUtf8 ( "status" ) );
	//status->setGeometry ( 520, 0, 382, 30 );
	horizontalLayout->addWidget(status);

	setWindowTitle ( QApplication::translate ( "Help", "Help", 0, QApplication::UnicodeUTF8 ) );

	treeWidget->setSortingEnabled ( false );
	/*///////////////////////////////////////////////*/
	QTreeWidgetItem *item = new QTreeWidgetItem ( treeWidget );
	treeWidget->setHeaderItem ( item );
	QTreeWidgetItem *item1 = new QTreeWidgetItem ( treeWidget );
	treeWidget->insertTopLevelItem ( 0, item1 );
	QTreeWidgetItem *item7 = new QTreeWidgetItem ( treeWidget );
	treeWidget->insertTopLevelItem ( 1, item7 );
	QTreeWidgetItem *item2 = new QTreeWidgetItem ( item1 );
	item1->insertChild ( 0, item2 );
	QTreeWidgetItem *item3 = new QTreeWidgetItem ( item1 );
	item1->insertChild ( 1, item3 );
	QTreeWidgetItem *item4 = new QTreeWidgetItem ( item3 );
	item3->insertChild ( 0, item4 );
	QTreeWidgetItem *item5 = new QTreeWidgetItem ( item1 );
	item1->insertChild ( 2, item5 );
	QTreeWidgetItem *item23 = new QTreeWidgetItem ( item1 );
	item1->insertChild ( 3, item23 );
	QTreeWidgetItem *item6 = new QTreeWidgetItem ( item1 );
	item1->insertChild ( 4, item6 );

	QTreeWidgetItem *item8 = new QTreeWidgetItem ( item7 ); item7->insertChild ( 0, item8 );
	QTreeWidgetItem *item9 = new QTreeWidgetItem ( item7 ); item7->insertChild ( 1, item9 );
	QTreeWidgetItem *item10 = new QTreeWidgetItem ( item7 ); item7->insertChild ( 2 , item10 );
	QTreeWidgetItem *item11 = new QTreeWidgetItem ( item7 ); item7->insertChild ( 3 , item11 );
	QTreeWidgetItem *item12 = new QTreeWidgetItem ( item7 ); item7->insertChild ( 4 , item12 );
	QTreeWidgetItem *item13 = new QTreeWidgetItem ( item7 ); item7->insertChild ( 5 , item13 );
	QTreeWidgetItem *item14 = new QTreeWidgetItem ( item7 ); item7->insertChild ( 6 , item14 );
	QTreeWidgetItem *item15 = new QTreeWidgetItem ( item7 ); item7->insertChild ( 7 , item15 );
	QTreeWidgetItem *item16 = new QTreeWidgetItem ( item7 ); item7->insertChild ( 8 , item16 );
	QTreeWidgetItem *item17 = new QTreeWidgetItem ( item7 ); item7->insertChild ( 9 , item17 );
	QTreeWidgetItem *item18 = new QTreeWidgetItem ( item7 ); item7->insertChild ( 10 , item18 );
	QTreeWidgetItem *item19 = new QTreeWidgetItem ( item7 ); item7->insertChild ( 11 , item19 );
	QTreeWidgetItem *item20 = new QTreeWidgetItem ( item7 ); item7->insertChild ( 12 , item20 );
	QTreeWidgetItem *item21 = new QTreeWidgetItem ( item7 ); item7->insertChild ( 13 , item21 );
	QTreeWidgetItem *item22 = new QTreeWidgetItem ( item7 ); item7->insertChild ( 14 , item22 );
	QTreeWidgetItem *item24 = new QTreeWidgetItem ( item7 ); item7->insertChild ( 15 , item24 );

	item->setText ( 0, QApplication::translate ( "Dialog", "PdfTk-QGUI Help", 0, QApplication::UnicodeUTF8 ) );
	item->setWhatsThis ( 0, "index.html" );
	item1->setText ( 0, QApplication::translate ( "Help", "Main Window", 0, QApplication::UnicodeUTF8 ) );
	item1->setWhatsThis ( 0, "MainWindow/index.html" );
	item2->setText ( 0, QApplication::translate ( "Help", "File Menu", 0, QApplication::UnicodeUTF8 ) );
	item2->setWhatsThis ( 0, "MainWindow/filemenu.html" );
	item3->setText ( 0, QApplication::translate ( "Help", "Edit Menu", 0, QApplication::UnicodeUTF8 ) );
	item3->setWhatsThis ( 0, "MainWindow/editmenu.html" );
	item4->setText ( 0, QApplication::translate ( "Help", "Preferences", 0, QApplication::UnicodeUTF8 ) );
	item4->setWhatsThis ( 0, "MainWindow/editmenu-prefs.html" );
	item5->setText ( 0, QApplication::translate ( "Help", "Tools Menu", 0, QApplication::UnicodeUTF8 ) );
	item5->setWhatsThis ( 0, "Tools/index.html" );
	item23->setText ( 0, QApplication::translate ( "Help", "Scripts Menu", 0, QApplication::UnicodeUTF8 ) );
	item23->setWhatsThis ( 0, "MainWindow/scriptsmenu.html" );
	item6->setText ( 0, QApplication::translate ( "Help", "Help Menu", 0, QApplication::UnicodeUTF8 ) );
	item6->setWhatsThis ( 0, "MainWindow/helpmenu.html" );
	item7->setText ( 0, QApplication::translate ( "Help", "Tools", 0, QApplication::UnicodeUTF8 ) );
	item7->setWhatsThis ( 0, "Tools/index.html" );
	item8->setText ( 0, QApplication::translate ( "Help", "Catenate", 0, QApplication::UnicodeUTF8 ) );
	item8->setWhatsThis ( 0, "Tools/cat.html" );
	item9->setText ( 0, QApplication::translate ( "Help", "Split", 0, QApplication::UnicodeUTF8 ) );
	item9->setWhatsThis ( 0, "Tools/split.html" );
	item10->setText ( 0, QApplication::translate ( "Help", "Rebuild", 0, QApplication::UnicodeUTF8 ) );
	item10->setWhatsThis ( 0, "Tools/rebuild.html" );
	item11->setText ( 0, QApplication::translate ( "Help", "Attach", 0, QApplication::UnicodeUTF8 ) );
	item11->setWhatsThis ( 0, "Tools/attach.html" );
	item12->setText ( 0, QApplication::translate ( "Help", "Unpack", 0, QApplication::UnicodeUTF8 ) );
	item12->setWhatsThis ( 0, "Tools/unpack.html" );
	item13->setText ( 0, QApplication::translate ( "Help", "Get info", 0, QApplication::UnicodeUTF8 ) );
	item13->setWhatsThis ( 0, "Tools/getinfo.html" );
	item14->setText ( 0, QApplication::translate ( "Help", "Update info", 0, QApplication::UnicodeUTF8 ) );
	item14->setWhatsThis ( 0, "Tools/updateinfo.html" );
	item15->setText ( 0, QApplication::translate ( "Help", "Generate FDF", 0, QApplication::UnicodeUTF8 ) );
	item15->setWhatsThis ( 0, "Tools/genfdf.html" );
	item16->setText ( 0, QApplication::translate ( "Help", "Background", 0, QApplication::UnicodeUTF8 ) );
	item16->setWhatsThis ( 0, "Tools/back.html" );
	item17->setText ( 0, QApplication::translate ( "Help", "Stamp", 0, QApplication::UnicodeUTF8 ) );
	item17->setWhatsThis ( 0, "Tools/stamp.html" );
	item18->setText ( 0, QApplication::translate ( "Help", "Encrypt", 0, QApplication::UnicodeUTF8 ) );
	item18->setWhatsThis ( 0, "Tools/encrypt.html" );
	item19->setText ( 0, QApplication::translate ( "Help", "Decrypt", 0, QApplication::UnicodeUTF8 ) );
	item19->setWhatsThis ( 0, "Tools/decrypt.html" );
	item20->setText ( 0, QApplication::translate ( "Help", "View PDF", 0, QApplication::UnicodeUTF8 ) );
	item20->setWhatsThis ( 0, "Tools/view.html" );
	item21->setText ( 0, QApplication::translate ( "Help", "Repair PDF", 0, QApplication::UnicodeUTF8 ) );
	item21->setWhatsThis ( 0, "Tools/repair.html" );
	item21->setText ( 0, QApplication::translate ( "Help", "TXT to PDF", 0, QApplication::UnicodeUTF8 ) );
	item21->setWhatsThis ( 0, "Tools/txt2pdf.html" );
	item22->setText ( 0, QApplication::translate ( "Help", "HTML to PDF", 0, QApplication::UnicodeUTF8 ) );
	item22->setWhatsThis ( 0, "Tools/html2pdf.html" );
	item24->setText ( 0, QApplication::translate ( "Help", "Encoding", 0, QApplication::UnicodeUTF8 ) );
	item24->setWhatsThis ( 0, "Tools/encoding.html" );

	/////////////////////////////////////////////////////////////
	layoutWidget3 = new QWidget(this);
	layoutWidget3->setObjectName ( QString::fromUtf8 ( "layoutWidget3" ) );
	verticalLayout3 = new QVBoxLayout ( layoutWidget3 );
	verticalLayout3->setObjectName ( QString::fromUtf8 ( "verticalLayout3" ) );

	verticalLayout3->addWidget(layoutWidget2);
	verticalLayout3->addWidget(webwidget);

	horizontalLayout2 = new QHBoxLayout ( this );
	horizontalLayout2->setObjectName ( QString::fromUtf8 ( "horizontalLayout2" ) );

	horizontalLayout2->addWidget(treeWidget);
	horizontalLayout2->addWidget(layoutWidget3);
	/////////////////////////////////////////////////////////////


	/*/////////////////////////////////////////////////////////*/
	//tabWidget->setTabText ( tabWidget->indexOf ( treeWidget ), QApplication::translate ( "Help", "Contents", 0, QApplication::UnicodeUTF8 ) );
	/*groupBox->setTitle ( QApplication::translate ( "Help", "Search:", 0, QApplication::UnicodeUTF8 ) );
	textRButton->setText ( QApplication::translate ( "Help", "Text", 0, QApplication::UnicodeUTF8 ) );
	regexpRButton->setText ( QApplication::translate ( "Help", "Reg. Exp.", 0, QApplication::UnicodeUTF8 ) );
	wildRButton->setText ( QApplication::translate ( "Help", "WildCard", 0, QApplication::UnicodeUTF8 ) );
	groupBox_2->setTitle ( QApplication::translate ( "Help", "Places:", 0, QApplication::UnicodeUTF8 ) );
	curdocRButton->setText ( QApplication::translate ( "Help", "Current doc.", 0, QApplication::UnicodeUTF8 ) );
	alldocsRButton->setText ( QApplication::translate ( "Help", "All documents", 0, QApplication::UnicodeUTF8 ) );
	findButton->setText ( QApplication::translate ( "Help", "&Find", 0, QApplication::UnicodeUTF8 ) );
	tabWidget->setTabText ( tabWidget->indexOf ( search ), QApplication::translate ( "Help", "Search", 0, QApplication::UnicodeUTF8 ) );*/
	//backButton->setText ( QApplication::translate ( "Help", "...", 0, QApplication::UnicodeUTF8 ) );
	//forwardButton->setText ( QApplication::translate ( "Help", "...", 0, QApplication::UnicodeUTF8 ) );
	//reloadButton->setText ( QApplication::translate ( "Help", "...", 0, QApplication::UnicodeUTF8 ) );
	searchButton->setText ( QApplication::translate ( "Help", "&Quick Search", 0, QApplication::UnicodeUTF8 ) );
	//stopButton->setText ( QApplication::translate ( "Help", "...", 0, QApplication::UnicodeUTF8 ) );

	/////////////////////////////////////
	//search->setVisible ( false );
	//curdocRButton->setChecked ( true );
	//connect ( findButton, SIGNAL ( clicked() ), this, SLOT ( onGlobalSearch() ) );

	connect ( backButton, SIGNAL ( clicked() ), this, SLOT ( back() ) );
	connect ( forwardButton, SIGNAL ( clicked() ), this, SLOT ( forward() ) );
	connect ( reloadButton, SIGNAL ( clicked() ), this, SLOT ( reload() ) );
	connect ( stopButton, SIGNAL ( clicked() ), this, SLOT ( stop() ) );
	connect ( searchButton, SIGNAL ( clicked() ), this, SLOT ( onQSearch() ) );
	connect ( webBrowser, SIGNAL ( loadStarted() ), this, SLOT ( onLoadStarted() ) );
	connect ( webBrowser, SIGNAL ( loadProgress ( int ) ), status, SLOT ( setValue ( int ) ) );
	connect ( webBrowser, SIGNAL ( linkHovered ( QString, QString, QString ) ), this, SLOT ( onLinkHovered ( QString, QString, QString ) ) );
	connect ( webBrowser, SIGNAL ( loadFinished ( bool ) ), this, SLOT ( setPage ( bool ) ) );
	connect ( treeWidget, SIGNAL ( itemPressed ( QTreeWidgetItem*, int ) ), this, SLOT ( TWitemPressed ( QTreeWidgetItem*, int ) ) );
	webBrowser->mainFrame()->load ( QUrl ( prefix+"index.html" ) );
	webwidget->setPage ( webBrowser );
}
void Help::stop() {webBrowser->triggerAction ( QWebPage::Stop );}
void Help::onQSearch()
{
	QString find = qsearchEdit->text();
	if ( find.isEmpty() ) return;
	webBrowser->findText ( find, QWebPage::FindWrapsAroundDocument );
}
void Help::onLinkHovered ( QString link, QString title, QString textContent )
{
	status->setFormat ( link );
}
void Help::back() {webBrowser->triggerAction ( QWebPage::Back );}
void Help::forward() {webBrowser->triggerAction ( QWebPage::Forward );}
void Help::reload() {webBrowser->triggerAction ( QWebPage::Reload );}
void Help::TWitemPressed ( QTreeWidgetItem* item, int col )
{
	webBrowser->mainFrame()->load ( QUrl ( prefix+item->whatsThis ( col ) ) );

}
void Help::onLoadStarted() {QApplication::setOverrideCursor ( Qt::WaitCursor );}
void Help::setPage ( bool ok )
{
	QApplication::restoreOverrideCursor();
	status->setValue ( 0 );
	status->setFormat ( "" );
	if ( ok ) webwidget->setPage ( webBrowser );
	else webwidget->setHtml ( tr ( "<font color=red>Failed to load page!</font>" ) );
}
void Help::onGlobalSearch()
{
	/*QString text = searchEdit->text();
	if ( text.isEmpty() ) return;
	if ( alldocsRButton->isChecked() )
	{
	}
	else
	{
	}*/
}
Help::~Help() {destroy();}
