/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef HELP_H
#define HELP_H

#include <QtGui/QApplication>
#include <QtGui/QDialog>
#include <QtGui/QGroupBox>
#include <QtGui/QHBoxLayout>
#include <QtGui/QLineEdit>
#include <QtGui/QPushButton>
#include <QtGui/QRadioButton>
#include <QtGui/QTabWidget>
//#include <QtGui/QTextBrowser>
#include <QtGui/QToolButton>
#include <QtGui/QTreeWidget>
#include <QtGui/QVBoxLayout>
#include <QtWebKit>
#include <QProgressBar>
#include <QDebug>
class Help: public QDialog
{
		Q_OBJECT
	public:
		Help ( QWidget *parent = 0, Qt::WindowFlags f = Qt::Dialog, QString prefix = "http" );
		~Help();
	private slots:
		void TWitemPressed ( QTreeWidgetItem* item, int col );
		void back();
		void forward();
		void reload();
		void setPage ( bool ok );
		void onQSearch();
		void stop();
		void onLoadStarted();
		void onLinkHovered ( QString link, QString title, QString textContent );
		void onGlobalSearch();
	private:
		QProgressBar *status;
		QString prefix;
		//QTabWidget *tabWidget;
		//QWidget *contents;
		QTreeWidget *treeWidget;
		QWebView *webwidget;
		/*QWidget *search;
		QLineEdit *searchEdit;
		QGroupBox *groupBox;
		QWidget *layoutWidget;
		QVBoxLayout *verticalLayout;
		QRadioButton *textRButton;
		QRadioButton *regexpRButton;
		QRadioButton *wildRButton;
		QGroupBox *groupBox_2;
		QWidget *layoutWidget1;
		QVBoxLayout *verticalLayout_2;
		QRadioButton *curdocRButton;
		QRadioButton *alldocsRButton;
		QPushButton *findButton;*/
		QWebPage *webBrowser;
		QWidget *layoutWidget2;
		QHBoxLayout *horizontalLayout;
		QToolButton *backButton;
		QToolButton *forwardButton;
		QToolButton *reloadButton;
		QLineEdit *qsearchEdit;
		QPushButton *searchButton;
		QToolButton *stopButton;
		QWidget *layoutWidget3;
		QVBoxLayout *verticalLayout3;
		QHBoxLayout *horizontalLayout2;
};

#endif
