/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "HelpTk.h"

//#include <iostream>
//using namespace std;

HelpTk::HelpTk ( QWidget* parent, Qt::WindowFlags f,QString str, QString focusAt )
{
	if ( parent != NULL ) {setParent ( parent );}
	if ( f != NULL ) {setWindowFlags ( f );}

	setObjectName ( QString::fromUtf8 ( "HelpTk" ) );
	setBaseSize ( 881, 300 );

        horizontalLayout = new QHBoxLayout(this);
        horizontalLayout->setObjectName(QString::fromUtf8("horizontalLayout"));

	textEdit = new QTextBrowser ( this );
	textEdit->setObjectName ( QString::fromUtf8 ( "textEdit" ) );
	textEdit->setText ( str );

	doc = textEdit->document();
	if ( !focusAt.isEmpty() ) onFind ( focusAt );

	horizontalLayout->addWidget(textEdit);

	verticalLayout = new QVBoxLayout();
	verticalLayout->setObjectName(QString::fromUtf8("verticalLayout"));

	findButton = new QPushButton ( this );
	findButton->setObjectName ( QString::fromUtf8 ( "findButton" ) );
	findButton->setGeometry ( QRect ( 800, 10, 80, 27 ) );

	verticalLayout->addWidget(findButton);

        verticalSpacer = new QSpacerItem(20, 40, QSizePolicy::Minimum, QSizePolicy::Expanding);

        verticalLayout->addItem(verticalSpacer);

	pushButton = new QPushButton ( this );
	pushButton->setObjectName ( QString::fromUtf8 ( "pushButton" ) );
	pushButton->setGeometry ( QRect ( 800, 264, 80, 27 ) );

	verticalLayout->addWidget(pushButton);

        horizontalLayout->addLayout(verticalLayout);

	retranslateUi();

	connect ( pushButton, SIGNAL ( clicked() ), this ,SLOT ( onClose() ) );
	connect ( findButton, SIGNAL ( clicked() ), this ,SLOT ( onFind() ) );

	resize ( 881, 300 );
}
void HelpTk::retranslateUi()
{
	setWindowTitle ( QApplication::translate ( "HelpTk", "HelpTk", 0, QApplication::UnicodeUTF8 ) );
	pushButton->setText ( QApplication::translate ( "HelpTk", "Close", 0, QApplication::UnicodeUTF8 ) );
	findButton->setText ( QApplication::translate ( "HelpTk", "&Find text", 0, QApplication::UnicodeUTF8 ) );
}
void HelpTk::onFind ( QString findS )
{
	cur = textEdit->textCursor();
	cur.movePosition ( QTextCursor::Start );
	if ( findS.isEmpty() ) findStr = QInputDialog::getText ( this, tr ( "Search" ), tr ( "Text to find:" ), QLineEdit::Normal, textEdit->textCursor().selectedText() );
	else findStr = findS;
	if ( findStr.isEmpty() ) return;
	QTextCursor findCur = doc->find ( findStr, cur );
	if ( findCur.isNull() ) {QMessageBox::warning ( this, tr ( "Search" ), tr ( "Text not found!" ) );return;}
	textEdit->setTextCursor ( findCur );
}
void HelpTk::keyPressEvent ( QKeyEvent *event )
{
	if ( event->key() == Qt::Key_F3 && QApplication::keyboardModifiers() != Qt::ShiftModifier )
	{
		cur = textEdit->textCursor();
		if ( findStr.isEmpty() ) return;
		QTextCursor findCur = doc->find ( findStr, cur );
		if ( findCur.isNull() ) {QMessageBox::warning ( this, tr ( "Search" ), tr ( "End of the document reached" ) );return;}
		textEdit->setTextCursor ( findCur );
		textEdit->setFocus();
	}
	if ( event->key() == Qt::Key_F3 && QApplication::keyboardModifiers() == Qt::ShiftModifier )
	{
		cur = textEdit->textCursor();
		if ( findStr.isEmpty() ) return;
		QTextCursor findCur = doc->find ( findStr, cur, QTextDocument::FindBackward );
		if ( findCur.isNull() ) {QMessageBox::warning ( this, tr ( "Search" ), tr ( "Beginning of the document reached" ) );return;}
		textEdit->setTextCursor ( findCur );
		textEdit->setFocus();
	}
	if ( event->key() == Qt::Key_F && QApplication::keyboardModifiers() == Qt::ControlModifier ) {onFind();}
}
void HelpTk::onClose() {close();}
HelpTk::~HelpTk()
{
	destroy();
}
