/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "Page.h"

Page::Page ( QWidget *parent, Qt::WindowFlags f, int pages, QString bg, int _from, int _to )
{
	if ( parent != NULL ) {setParent ( parent );}
	if ( f != NULL ) {setWindowFlags ( f );}
	this->setObjectName ( QString::fromUtf8 ( "Page" ) );
	//this->setFixedSize ( 219, 200 );
	layoutWidget = new QWidget ( this );
	layoutWidget->setObjectName ( QString::fromUtf8 ( "layoutWidget" ) );
	//layoutWidget->setGeometry ( QRect ( 50, 160, 162, 31 ) );
	horizontalLayout = new QHBoxLayout ( layoutWidget );
	horizontalLayout->setObjectName ( QString::fromUtf8 ( "horizontalLayout" ) );
	horizontalLayout->setContentsMargins ( 0, 0, 0, 0 );

	horizontalSpacer_3 = new QSpacerItem ( 40, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
	horizontalLayout->addItem ( horizontalSpacer_3 );

	CAB = new QPushButton ( layoutWidget );
	CAB->setObjectName ( QString::fromUtf8 ( "CAB" ) );

	horizontalLayout->addWidget ( CAB );

	OKB = new QPushButton ( layoutWidget );
	OKB->setDefault(true);
	OKB->setObjectName ( QString::fromUtf8 ( "OKB" ) );

	horizontalLayout->addWidget ( OKB );

	widget = new QWidget ( this );
	widget->setObjectName ( QString::fromUtf8 ( "widget" ) );
	//widget->setGeometry ( QRect ( 10, 10, 201, 141 ) );
	gridLayout = new QGridLayout ( widget );
	gridLayout->setObjectName ( QString::fromUtf8 ( "gridLayout" ) );
	gridLayout->setContentsMargins ( 0, 0, 0, 0 );
	label = new QLabel ( widget );
	label->setObjectName ( QString::fromUtf8 ( "label" ) );

	gridLayout->addWidget ( label, 0, 0, 1, 1 );

	fSpin = new QSpinBox ( widget );
	fSpin->setObjectName ( QString::fromUtf8 ( "fSpin" ) );
	fSpin->setFocus();

	gridLayout->addWidget(fSpin, 0, 1, 1, 1);

	upfTool = new QToolButton(widget);
	upfTool->setObjectName ( QString::fromUtf8 ( "upfTool" ) );

	gridLayout->addWidget ( upfTool, 0, 2, 1, 1 );

	downfTool = new QToolButton(widget);
	downfTool->setObjectName ( QString::fromUtf8 ( "downfTool" ) );

	gridLayout->addWidget ( downfTool, 0, 3, 1, 1 );

	label_2 = new QLabel ( widget );
	label_2->setObjectName ( QString::fromUtf8 ( "label_2" ) );

	gridLayout->addWidget ( label_2, 1, 0, 1, 1 );

	tSpin = new QSpinBox ( widget );
	tSpin->setObjectName ( QString::fromUtf8 ( "tSpin" ) );

	gridLayout->addWidget(tSpin, 1, 1, 1, 1);

	uptTool = new QToolButton(widget);
	uptTool->setObjectName ( QString::fromUtf8 ( "uptTool" ) );

	gridLayout->addWidget ( uptTool, 1, 2, 1, 1 );

	downtTool = new QToolButton(widget);
	downtTool->setObjectName ( QString::fromUtf8 ( "downtTool" ) );

	gridLayout->addWidget ( downtTool, 1, 3, 1, 1 );

	widget1 = new QWidget ( this );
	widget1->setObjectName ( QString::fromUtf8 ( "widget1" ) );
	//widget->setGeometry ( QRect ( 10, 10, 201, 141 ) );
	gridLayout_2= new QGridLayout ( widget1 );
	gridLayout_2->setObjectName ( QString::fromUtf8 ( "gridLayout_2" ) );
	gridLayout_2->setContentsMargins ( 0, 0, 0, 0 );
	
	label_3 = new QLabel ( widget1 );
	label_3->setObjectName ( QString::fromUtf8 ( "label_3" ) );

	gridLayout_2->addWidget (label_3, 0, 0, 1, 1);

	all_combo = new QComboBox ( widget1 );
	all_combo->setObjectName ( QString::fromUtf8 ( "all_combo" ) );

	gridLayout_2->addWidget ( all_combo, 0, 1, 1, 1);

	label_4 = new QLabel ( widget1 );
	label_4->setObjectName ( QString::fromUtf8 ( "label_4" ) );

	gridLayout_2->addWidget ( label_4, 1, 0, 1, 1 );

	horizontalLayout_4 = new QHBoxLayout();
	horizontalLayout_4->setObjectName ( QString::fromUtf8 ( "horizontalLayout_4" ) );
	oddCheck = new QCheckBox ( widget1 );
	oddCheck->setObjectName ( QString::fromUtf8 ( "oddCheck" ) );

	horizontalLayout_4->addWidget ( oddCheck );

	evenCheck = new QCheckBox ( widget1 );
	evenCheck->setObjectName ( QString::fromUtf8 ( "evenCheck" ) );

	horizontalLayout_4->addWidget ( evenCheck );


	gridLayout_2->addLayout ( horizontalLayout_4, 1, 1, 1, 1 );

	vboxLayout = new QVBoxLayout ( this );
	vboxLayout->addWidget ( widget );
	vboxLayout->addWidget ( widget1 );
	vboxLayout->addWidget ( layoutWidget );
	adjustSize();
#ifndef QT_NO_SHORTCUT
	label->setBuddy ( fSpin );
	label_2->setBuddy ( tSpin );
	label_3->setBuddy ( all_combo );
#endif // QT_NO_SHORTCUT
	this->setWindowTitle ( QApplication::translate ( "Page", "Page", 0, QApplication::UnicodeUTF8 ) );
	CAB->setText ( QApplication::translate ( "Page", "Ca&ncel", 0, QApplication::UnicodeUTF8 ) );
	OKB->setText ( QApplication::translate ( "Page", "&OK", 0, QApplication::UnicodeUTF8 ) );
	label->setText ( QApplication::translate ( "Page", "&From:", 0, QApplication::UnicodeUTF8 ) );
	label_2->setText ( QApplication::translate ( "Page", "&To:", 0, QApplication::UnicodeUTF8 ) );
	label_3->setText ( QApplication::translate ( "Page", "&Rotation:", 0, QApplication::UnicodeUTF8 ) );
	all_combo->clear();
	all_combo->insertItems ( 0, QStringList()
	                         << QApplication::translate ( "Page", "None", 0, QApplication::UnicodeUTF8 )
	                         << QApplication::translate ( "Page", "North", 0, QApplication::UnicodeUTF8 )
	                         << QApplication::translate ( "Page", "East", 0, QApplication::UnicodeUTF8 )
	                         << QApplication::translate ( "Page", "South", 0, QApplication::UnicodeUTF8 )
	                         << QApplication::translate ( "Page", "West", 0, QApplication::UnicodeUTF8 )
	                         << QApplication::translate ( "Page", "Rotate +90", 0, QApplication::UnicodeUTF8 )
	                         << QApplication::translate ( "Page", "Rotate -90", 0, QApplication::UnicodeUTF8 )
	                         << QApplication::translate ( "Page", "Rotate 180", 0, QApplication::UnicodeUTF8 )
	                       );
	label_4->setText ( QApplication::translate ( "Page", "Qualifier:", 0, QApplication::UnicodeUTF8 ) );
	oddCheck->setText ( QApplication::translate ( "Page", "&Odd", 0, QApplication::UnicodeUTF8 ) );
	evenCheck->setText ( QApplication::translate ( "Page", "&Even", 0, QApplication::UnicodeUTF8 ) );
	upfTool->setIcon(QIcon(qApp->style()->standardIcon(QStyle::SP_ArrowUp)));
	upfTool->setToolTip(tr("Last page"));
	downfTool->setIcon(QIcon(qApp->style()->standardIcon(QStyle::SP_ArrowDown)));
	downfTool->setToolTip(tr("First page"));
	uptTool->setIcon(QIcon(qApp->style()->standardIcon(QStyle::SP_ArrowUp)));
	uptTool->setToolTip(tr("Last page"));
	downtTool->setIcon(QIcon(qApp->style()->standardIcon(QStyle::SP_ArrowDown)));
	downtTool->setToolTip(tr("First page"));

	connect ( CAB, SIGNAL ( clicked() ), this, SLOT ( reject() ) );
	connect ( OKB, SIGNAL ( clicked() ), this, SLOT ( onOK() ) );

	connect ( upfTool, SIGNAL (clicked()), this, SLOT(onUpF()));
	connect ( downfTool, SIGNAL (clicked()), this, SLOT(onDownF()));
	connect ( uptTool, SIGNAL (clicked()), this, SLOT(onUpT()));
	connect ( downtTool, SIGNAL (clicked()), this, SLOT(onDownT()));

	if ( !bg.isEmpty() ) {setStyleSheet ( tr ( "QDialog{background: url(%1);}" ).arg ( bg ) );}
	fSpin->setRange ( 1, pages );
	if(_from > 0 && _from <=pages) fSpin->setValue(_from);
	tSpin->setRange ( 1, pages );
	if(_to > 0 && _to <=pages) tSpin->setValue(_to);
	fSpin->selectAll();
}
void Page::onUpF()
{
	fSpin->setValue(fSpin->maximum());
	fSpin->setFocus();
	fSpin->selectAll();
}
void Page::onDownF()
{
	fSpin->setValue(1);
	fSpin->setFocus();
	fSpin->selectAll();
}
void Page::onUpT()
{
	tSpin->setValue(tSpin->maximum());
	tSpin->setFocus();
	tSpin->selectAll();
}
void Page::onDownT()
{
	tSpin->setValue(1);
	tSpin->setFocus();
	tSpin->selectAll();
}
void Page::onOK()
{
	pageF = fSpin->value();
	pageT = tSpin->value();
	if ( oddCheck->isChecked() && evenCheck->isChecked() ) {even = odd = true;}
	if ( oddCheck->isChecked() && !evenCheck->isChecked() ) {even = false;odd = true;}
	if ( !oddCheck->isChecked() && evenCheck->isChecked() ) {even = true;odd = false;}
	if ( !oddCheck->isChecked() && !evenCheck->isChecked() ) {even = odd = true;}
	if ( all_combo->currentIndex() == 0 ) {rotation = "";}
	if ( all_combo->currentIndex() == 1 ) {rotation = "N";}
	if ( all_combo->currentIndex() == 2 ) {rotation = "E";}
	if ( all_combo->currentIndex() == 3 ) {rotation = "S";}
	if ( all_combo->currentIndex() == 4 ) {rotation = "W";}
	if ( all_combo->currentIndex() == 5 ) {rotation = "R";}
	if ( all_combo->currentIndex() == 6 ) {rotation = "L";}
	if ( all_combo->currentIndex() == 7 ) {rotation = "D";}
	accept();
}
Page::~Page() {destroy();}
