/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef PREFSDLG_H
#define PREFSDLG_H

#include "Preview.h"

#include <QtGui/QFontComboBox>
#include <QtGui/QListWidget>
#include <QtGui/QSpacerItem>
#include <QtGui/QVBoxLayout>
#include <QtGui/QToolButton>
/////////////////////////////////
#include <QClipboard>
#include <QFile>
#include <QDir>
#include <QMessageBox>
#include <QTextStream>
#include <QFileInfo>
#include <QFileDialog>
#include <QColorDialog>
#include <QCloseEvent>
#include <QSettings>
#include "BackSel.h"

class PrefsDlg : public QDialog
{
		Q_OBJECT
	public:
		PrefsDlg ( QWidget* parent = 0, Qt::WindowFlags f = Qt::Dialog, QString ver = "0" );
		~PrefsDlg();
	protected:
		void closeEvent ( QCloseEvent *event );
	private slots:
		void onViewerCombo( int );
		void onPdfTkEdit ( QString str );
		void onOK();
		void onCancel();
		void on_searchTK();
		void on_searchViewer();
		void onTextC();
		void onBackC();
		void onAdd();
		void onRemove();
		void onSaveDB();
		void onSaveCss();
		void onColR ( bool checked );
		void onImgR ( bool checked );
		void onImgC ( QString text );
		void onCssCheck ( bool checked );
		void onCssButton();
		void onPreview();
		void onGetColor();
		void onCopyAvailable ( bool yes );
		void onUndoAvailable ( bool yes );
		void onRedoAvailable ( bool yes );
		void onPasteAvailable();
		void onCssChange();
		void onFavScriptNum ( int i);
		void onLangCombo(int i);
	private:
		QFile *rcfile;
		void readSettings();
		int *index;
		QClipboard *clipb;
		QStringList bgPath, backListText;
		QString vers, backColor, textColor, cssFile, locFile;
		bool tkok, vok, custom, cssChanged, askdir;
		QStringList scriptNames, favScriptNames;
		int scriptNum, favNum;
		////////////////////////////////////////
		QTabWidget *tabWidget;
		QWidget *intSE;
		QGroupBox *groupBox_2;
		QWidget *layoutWidget;
		QHBoxLayout *horizontalLayout_7;
		QListWidget *backList;
		QVBoxLayout *verticalLayout;
		QPushButton *addButton;
		QPushButton *remButton;
		QPushButton *saveButton;
		QGroupBox *textGroupBox;
		QWidget *layoutWidget1;
		QGridLayout *gridLayout_2;
		QLabel *textLabel;
		QHBoxLayout *horizontalLayout_6;
		QLineEdit *colorEdit;
		QPushButton *colorButton;
		QLabel *label_3;
		QFontComboBox *fontCombo;
		QLabel *label_4;
		QHBoxLayout *horizontalLayout_2;
		QSpinBox *fontSpin;
		QSpacerItem *horizontalSpacer;
		QGroupBox *groupBox;
		QWidget *layoutWidget2;
		QGridLayout *gridLayout_3;
		QLabel *bgSelect;
		QHBoxLayout *horizontalLayout_4;
		QRadioButton *colRadio;
		QRadioButton *imgRadio;
		QLabel *bgLabel;
		QHBoxLayout *horizontalLayout_3;
		QLineEdit *backEdit;
		QPushButton *backButton;
		QWidget *extSE;
		QTextEdit *cssEdit;
		QWidget *layoutWidget3;
		QHBoxLayout *horizontalLayout_8;
		QToolButton *copyTool;
		QToolButton *pasteTool;
		QToolButton *cutTool;
		QToolButton *undoTool;
		QToolButton *redoTool;
		QSpacerItem *horizontalSpacer_2;
		QPushButton *previewButton;
		QPushButton *testColor;
		QPushButton *saveCSSButton;
		QWidget *layoutWidget4;
		QVBoxLayout *verticalLayout_2;
		QGridLayout *gridLayout;
		QComboBox *viewerEdit;
		QLabel *label, *label_2;
		QLineEdit *pdftkEdit;
		QLabel *pdftkTick;
		QToolButton *searchViewer;
		QToolButton *searchTK;
		QHBoxLayout *horizontalLayout_5;
		QLabel *lfLabel;
		QComboBox *StyleCombo;
		QHBoxLayout *horizontalLayout;
		QCheckBox *cssCheckBox;
		QPushButton *cssButton;
		QGroupBox *langGroup;
		QComboBox *langCombo;
		QWidget *layoutWidget5;
		QHBoxLayout *horizontalLayout_9;
		QPushButton *CAB;
		QPushButton *OKB;
		/////////////////////////////
		QWidget *printerSet;
		QWidget *layoutWidget6;
		QGridLayout *gridLayout_5;
		QLabel *orientLabel;
		QComboBox *orientCombo;
		QLabel *resolLabel;
		QSpinBox *resolSpin;
		QLabel *colorMLabel;
		QComboBox *colorMCombo;
		QLabel *orderLabel;
		QComboBox *orderCombo;
		/////////////////////////////
		QComboBox *imgCombo;
		/////////////////////////////
		QWidget *scriptTab;
		QCheckBox *askdirBox;
		QVBoxLayout *verticalLayout_10;
		QHBoxLayout *horizontalLayout_10;
		QLabel *label_10;
		QSpinBox *favSpin;
		QGroupBox *favScriptBox;
		QVBoxLayout *verticalLayout_11;
		QGridLayout *gridLayout_10;
		QComboBox **favCombos;
		QLabel **favLabels;
		/////////////////////////////
		QString vBin;
};

#endif

