/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "PrefsDlg.h"
#include "ImportTheme.cpp"

void PrefsDlg::readSettings()
{
	QFile *scrf = new QFile ( "./scripts.rc" );
	if ( !scrf->exists() ) scrf = new QFile ( QDir().homePath() +"/.suslictk/scripts.rc" );
	if ( scrf->exists() )
	{
		if ( !scrf->open ( QFile::ReadOnly | QFile::Text ) )
		{
			QMessageBox::warning ( this, tr ( "PdfTk-QGUI" ),tr ( "Cannot open file %1:\n%2." ).arg ( scrf->fileName() ).arg ( scrf->errorString() ) );
		}
		else
		{
			QTextStream in ( scrf );
			QString all = in.readAll();
			scriptNames.clear();
			QStringList tmpl = all.split ( "[SCRIPTNAME]", QString::SkipEmptyParts );
			scriptNum = 0;
			for ( int i=0;i<tmpl.count();i++ )
			{
				QStringList tmpl2 = tmpl[i].split ( "[SCRIPTBODY]", QString::SkipEmptyParts );
				if ( tmpl2.count() != 2 ) qDebug() <<"invalid script "<<i;
				else
				{
					if ( tmpl2[0].startsWith ( "\n" ) )	tmpl2[0].remove ( 0,1 );
					if ( tmpl2[0].endsWith ( "\n" ) )	tmpl2[0].chop ( 1 );
					scriptNames<<tmpl2[0];
					scriptNum++;
				}
			}
			scrf->close();
		}
	}
	qDebug() <<"scriptNames.count() = "<<scriptNames.count();
	if(scriptNames.count() == 0)	scriptTab->setEnabled(false);
	QSettings set;
	favNum =set.value ( "FavScriptNum", 0 ).toInt();
	favNum = scriptNames.count() > favNum ? favNum : scriptNames.count();
	askdir = set.value("AskChDir", true).toBool();
	askdirBox->setChecked(askdir);
	for ( int i=0;i<6;i++ ) {index[i] = -1;}
	rcfile = new QFile ( "./suslictk.rc" );
	if ( !rcfile->exists() )
	{
		rcfile = new QFile ( QDir().homePath() +"/.suslictk/suslictk.rc" );
		extSE->setEnabled ( false );
	}
	if ( rcfile->exists() )
	{
		if ( !rcfile->open ( QFile::ReadOnly | QFile::Text ) )
		{
			QMessageBox::warning ( this, tr ( "PdfTk-QGUI" ),tr ( "Cannot open file %1:\n%2." ).arg ( rcfile->fileName() ).arg ( rcfile->errorString() ) );
		}
		else
		{
			int s = 0;
			QTextStream in ( rcfile );
			QString all = in.readAll();
			QStringList opts1 = all.split ( "\n", QString::SkipEmptyParts );
			if ( opts1.indexOf ( "[version]" ) >=0 )
			{
				QString RCver = opts1[opts1.indexOf ( "[version]" ) +1];
				if ( RCver != vers )
				{
					QMessageBox::warning ( this->parentWidget(), tr ( "Attention" ),tr ( "Version mismatch for configuration file!<br>Will try to read settings<br>In case of any problems, delete old configuration file." ) );
				}
			}
			else{QMessageBox::warning ( this->parentWidget(), tr ( "Attention" ),tr ( "Version mismatch for configuration file!<br>Will try to read settings<br>In case of any problems, delete old configuration file." ) );}
			int i = opts1.indexOf ( "[pdftkbinary]" );
			if ( i >=0 && opts1.count() > ( i+1 ) )
				{pdftkEdit->setText ( opts1[i+1] );onPdfTkEdit ( opts1[i+1] );}
			else s=1;
			i = opts1.indexOf ( "[font-family]" );
			if ( i >=0 && opts1.count() > ( i+1 ) )
			{
				QFont f ( opts1[i +1] );
				qDebug() <<"Font: "<<f.toString() ;
				fontCombo->setCurrentFont ( f );
			}
			else {s=1;}
			i = opts1.indexOf ( "[font-size]" );
			if ( i >=0 && opts1.count() > ( i+1 ) )
			{
				if ( opts1[i +1].toInt() > 0 ) fontSpin->setValue ( opts1[i +1].toInt() );
				else fontSpin->setValue ( 12 );
			}
			else {s=1;}
			i = opts1.indexOf ( "[background_main]" );
			if ( i >=0 && opts1.count() > ( i+1 ) )
			{
				QString backColor = opts1[i+1];
				if ( backColor.count ( QRegExp ( "^#(\\d|[A-F]|[a-f]){6,6}$" ) ) == 1 )
					{backEdit->setText ( backColor );}
				else{backEdit->setText ( "#000000" );s=1;}
			}
			else s=1;
			i = opts1.indexOf ( "[textcolor_main]" );
			if ( i >=0 && opts1.count() > ( i+1 ) )
			{
				QString backColor = opts1[i+1];
				if ( backColor.count ( QRegExp ( "^#(\\d|[A-F]|[a-f]){6,6}$" ) ) == 1 )
					{colorEdit->setText ( backColor );}
				else{colorEdit->setText ( "#ffffff" );s=1;}
			}
			else s=1;
			i = opts1.indexOf ( "[lookandfeel]" );
			if ( i >=0 && opts1.count() > ( i+1 ) )
			{
				if ( opts1[i+1] == "Cleanlooks" )
				{
					StyleCombo->setCurrentIndex ( 0 );
				}
				if ( opts1[i+1] == "Motif" )
				{
					StyleCombo->setCurrentIndex ( 2 );
				}
				if ( opts1[i+1] == "Plastique" )
				{
					StyleCombo->setCurrentIndex ( 1 );
				}
#if QT_VERSION >= 0x040500
				if ( opts1[i+1] == "GTK" )
				{
					StyleCombo->setCurrentIndex ( 3 );
				}
#endif
			}
			i = opts1.indexOf ( "[fav-scripts]" );
			if ( i >=0 && opts1.count() > ( i+1 ) )
				favScriptNames = opts1[i+1].split ( ";", QString::SkipEmptyParts );
			i = opts1.indexOf ( "[viewer]" );
			if ( i >=0 && opts1.count() > ( i+1 ) )
			{
				if(opts1[i +1] != "@native")	viewerEdit->setCurrentIndex(1);
				else viewerEdit->setCurrentIndex(0);
				vBin = opts1[i +1];
			}
			i = opts1.indexOf ( "[ext-css]" );
			if ( i >=0 && opts1.count() > ( i+1 ) )
			{
				cssFile = opts1[i +1];
				cssCheckBox->setChecked ( true );onCssCheck ( true );
				cssButton->setText ( cssFile.split ( "/", QString::SkipEmptyParts ).last() );
			}
			else
			{
				cssFile = "";
				cssButton->setText ( "none" );
				cssCheckBox->setChecked ( false );onCssCheck ( false );
			}
			int ss = 0;
			i = opts1.indexOf ( "[background-cat]" );
			if ( i >=0 && opts1.count() > ( i+1 ) )
			{
				bool ok;
				int j = opts1[i+1].toInt ( &ok, 10 );
				if ( ok ) {imgRadio->setChecked ( true );onImgR ( true );index[0] = j;ss = 1;}
			}
			i = opts1.indexOf ( "[background-bur]" );
			if ( i >=0 && opts1.count() > ( i+1 ) )
			{
				bool ok;
				int j = opts1[i+1].toInt ( &ok, 10 );
				if ( ok ) {imgRadio->setChecked ( true );onImgR ( true );index[1] = j;ss = 1;}
			}
			i = opts1.indexOf ( "[background-att]" );
			if ( i >=0 && opts1.count() > ( i+1 ) )
			{
				bool ok;
				int j = opts1[i+1].toInt ( &ok, 10 );
				if ( ok ) {imgRadio->setChecked ( true );onImgR ( true );index[2] = j;ss = 1;}
			}
			i = opts1.indexOf ( "[background-encr]" );
			if ( i >=0 && opts1.count() > ( i+1 ) )
			{
				bool ok;
				int j = opts1[i+1].toInt ( &ok, 10 );
				if ( ok ) {imgRadio->setChecked ( true );onImgR ( true );index[3] = j;ss = 1;}
			}
			i = opts1.indexOf ( "[background-report]" );
			if ( i >=0 && opts1.count() > ( i+1 ) )
			{
				bool ok;
				int j = opts1[i+1].toInt ( &ok, 10 );
				if ( ok ) {imgRadio->setChecked ( true );onImgR ( true );index[4] = j;ss = 1;}
			}
			i = opts1.indexOf ( "[background-common]" );
			if ( i >=0 && opts1.count() > ( i+1 ) )
			{
				bool ok;
				int j = opts1[i+1].toInt ( &ok, 10 );
				if ( ok ) {imgRadio->setChecked ( true );onImgR ( true );index[5] = j;ss = 1;}
			}
			i = opts1.indexOf ( "[printer]" );
			if ( i >=0 && opts1.count() > ( i+1 ) )
			{
				bool ok;
				QStringList printerList = opts1[i+1].split ( ";" );
				if ( printerList.count() <4 )
				{
					qDebug() <<"error reading printer settings";
				}
				else
				{
					int j = printerList[0].toInt ( &ok, 10 );
					if ( ok && j == 1 ) orientCombo->setCurrentIndex ( 1 );
					j = printerList[1].toInt ( &ok, 10 );
					if ( ok ) resolSpin->setValue ( j );
					j = printerList[2].toInt ( &ok, 10 );
					if ( ok && j == 1 ) colorMCombo->setCurrentIndex ( 1 );
					j = printerList[3].toInt ( &ok, 10 );
					if ( ok && j == 1 ) orderCombo->setCurrentIndex ( 1 );
				}
			}
			if ( ss == 0 ) {index[5] = 0;}
			if ( s == 0 ) {qDebug() <<"Successfully read settings!";}
			if ( s== 1 ) {QMessageBox::critical ( this, tr ( "Error!" ), tr ( "<br>Error reading configuration file" ) );}
			rcfile->close();
		}
	}
	if ( ImportTheme ( QDir().homePath() +"/.suslictk/bgimg.rc", &bgPath ) )
	{

		backList->addItems ( bgPath );
		for ( int i=0;i<bgPath.count(); i++ )
			{bgPath[i] = bgPath[i].split ( "/", QString::SkipEmptyParts ).last();}

		bgPath<<"Custom";
		imgCombo->insertItems ( 0, bgPath );
		if ( index[5]>=0 && index[5] < imgCombo->count()-1 ) {imgCombo->setCurrentIndex ( index[5] );}
		if ( index[0]>=0 || index[1]>=0 || index[2]>=0 || index[3]>=0 || index[4]>=0 ) {imgCombo->setCurrentIndex ( imgCombo->count()-1 );}
	}
	langCombo->insertItems ( 0, QStringList()
	                         << QApplication::translate ( "PrefsDlg", "English", 0, QApplication::UnicodeUTF8 )
	                         << QLocale::languageToString ( QLocale::system().language() )
				 << QApplication::translate ( "PrefsDlg", "Select", 0, QApplication::UnicodeUTF8 )
	                       );
	QString lang = set.value ( "Language", QString ( "en" ) ).toString();
	locFile = set.value ( "LanguageFile", QString ( "" ) ).toString();
	if ( lang == "loc" ) langCombo->setCurrentIndex ( 1 );
	else if(lang == "custom")
	{
		if(QFile(locFile).exists())
		{
			langCombo->setCurrentIndex ( 2 );
			langCombo->setToolTip(locFile);
		}
		else
		{
			set.setValue("LanguageFile", QString ( "" ));
			set.setValue("Language", QString ( "en" ));
			QMessageBox::warning(this, "Translation", tr("Translation file %1 does not exist!").arg(locFile));
			locFile = "";
		}
		
	}
	if ( favNum == 0 ) favScriptBox->setEnabled ( false );
	favSpin->setValue ( favNum > 5 ? 5 : favNum );
	for ( int i=0;i<5;i++ )
	{
		favCombos[i]->insertItems ( 0,scriptNames );
		if ( i >= favNum )
		{
			qDebug() <<"hide "<<i;
			favLabels[i]->setVisible ( false );
			favCombos[i]->setVisible ( false );
		}
		else
		{
			favLabels[i]->setVisible ( true );
			favCombos[i]->setVisible ( true );
		}
	}

	int tmpi = favScriptNames.count();
	for ( int i=0;i< ( tmpi <5 ? tmpi : 5 );i++ )
	{
		int tmpindex = scriptNames.indexOf ( favScriptNames[i] );
		if ( tmpindex>0 ) favCombos[i]->setCurrentIndex ( tmpindex );
	}
	qDebug() <<"favNum="<<favNum;
}
