/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "Preview.h"

Preview::Preview ( QWidget *parent, Qt::WindowFlags f, QString stylesheet )
{
	if ( parent != NULL ) {setParent ( parent );}
	if ( f != NULL ) {setWindowFlags ( f );}
	this->setObjectName ( QString::fromUtf8 ( "Preview" ) );
	this->resize ( 439, 199 );
	progressBar = new QProgressBar ( this );
	progressBar->setObjectName ( QString::fromUtf8 ( "progressBar" ) );
	progressBar->setGeometry ( QRect ( 0, 160, 251, 23 ) );
	progressBar->setValue ( 24 );
	pushButton = new QPushButton ( this );
	pushButton->setObjectName ( QString::fromUtf8 ( "pushButton" ) );
	pushButton->setGeometry ( QRect ( 340, 160, 86, 29 ) );
	groupBox = new QGroupBox ( this );
	groupBox->setObjectName ( QString::fromUtf8 ( "groupBox" ) );
	groupBox->setGeometry ( QRect ( 0, 0, 131, 151 ) );
	radioButton = new QRadioButton ( groupBox );
	radioButton->setObjectName ( QString::fromUtf8 ( "radioButton" ) );
	radioButton->setGeometry ( QRect ( 10, 20, 106, 25 ) );
	checkBox = new QCheckBox ( groupBox );
	checkBox->setObjectName ( QString::fromUtf8 ( "checkBox" ) );
	checkBox->setGeometry ( QRect ( 10, 50, 90, 24 ) );
	label = new QLabel ( groupBox );
	label->setObjectName ( QString::fromUtf8 ( "label" ) );
	label->setGeometry ( QRect ( 20, 80, 65, 20 ) );
	spinBox = new QSpinBox ( groupBox );
	spinBox->setObjectName ( QString::fromUtf8 ( "spinBox" ) );
	spinBox->setGeometry ( QRect ( 70, 110, 54, 25 ) );
	spinBox->setButtonSymbols ( QAbstractSpinBox::UpDownArrows );
	label_2 = new QLabel ( groupBox );
	label_2->setObjectName ( QString::fromUtf8 ( "label_2" ) );
	label_2->setGeometry ( QRect ( 0, 110, 65, 20 ) );
	groupBox_2 = new QGroupBox ( this );
	groupBox_2->setObjectName ( QString::fromUtf8 ( "groupBox_2" ) );
	groupBox_2->setGeometry ( QRect ( 260, 10, 171, 141 ) );
	tabWidget = new QTabWidget ( groupBox_2 );
	tabWidget->setObjectName ( QString::fromUtf8 ( "tabWidget" ) );
	tabWidget->setGeometry ( QRect ( 10, 20, 151, 111 ) );
	tab = new QWidget();
	tab->setObjectName ( QString::fromUtf8 ( "tab" ) );
	lineEdit = new QLineEdit ( tab );
	lineEdit->setObjectName ( QString::fromUtf8 ( "lineEdit" ) );
	lineEdit->setGeometry ( QRect ( 20, 0, 113, 25 ) );
	lineEdit->setReadOnly ( true );
	comboBox = new QComboBox ( tab );
	comboBox->setObjectName ( QString::fromUtf8 ( "comboBox" ) );
	comboBox->setGeometry ( QRect ( 20, 50, 111, 23 ) );
	tabWidget->addTab ( tab, QString() );
	tab_2 = new QWidget();
	tab_2->setObjectName ( QString::fromUtf8 ( "tab_2" ) );
	tabWidget->addTab ( tab_2, QString() );
	textEdit = new QTextEdit ( this );
	textEdit->setObjectName ( QString::fromUtf8 ( "textEdit" ) );
	textEdit->setGeometry ( QRect ( 140, 10, 111, 141 ) );
	textEdit->setReadOnly ( true );
	this->setWindowTitle ( QApplication::translate ( "Preview", "Preview", 0, QApplication::UnicodeUTF8 ) );
	progressBar->setFormat ( QApplication::translate ( "Preview", "Progress Bar: %p%", 0, QApplication::UnicodeUTF8 ) );
	pushButton->setText ( QApplication::translate ( "Preview", "Close", 0, QApplication::UnicodeUTF8 ) );
	groupBox->setTitle ( QApplication::translate ( "Preview", "GroupBox", 0, QApplication::UnicodeUTF8 ) );
	radioButton->setText ( QApplication::translate ( "Preview", "RadioButton", 0, QApplication::UnicodeUTF8 ) );
	checkBox->setText ( QApplication::translate ( "Preview", "CheckBox", 0, QApplication::UnicodeUTF8 ) );
	label->setText ( QApplication::translate ( "Preview", "TextLabel", 0, QApplication::UnicodeUTF8 ) );
	spinBox->setSuffix ( QString() );
	label_2->setText ( QApplication::translate ( "Preview", "SpinBox:", 0, QApplication::UnicodeUTF8 ) );
	groupBox_2->setTitle ( QApplication::translate ( "Preview", "TabWidget:", 0, QApplication::UnicodeUTF8 ) );
	lineEdit->setText ( QApplication::translate ( "Preview", "lineEdit", 0, QApplication::UnicodeUTF8 ) );
	comboBox->clear();
	comboBox->insertItems ( 0, QStringList()
	                        << QApplication::translate ( "Preview", "ComboBox", 0, QApplication::UnicodeUTF8 )
	                      );
	tabWidget->setTabText ( tabWidget->indexOf ( tab ), QApplication::translate ( "Preview", "Tab 1", 0, QApplication::UnicodeUTF8 ) );
	tabWidget->setTabText ( tabWidget->indexOf ( tab_2 ), QApplication::translate ( "Preview", "Tab 2", 0, QApplication::UnicodeUTF8 ) );
	textEdit->setText ( QApplication::translate ( "Preview", "Text Edit", 0, QApplication::UnicodeUTF8 ) );
	connect ( pushButton, SIGNAL ( clicked() ), this, SLOT ( accept() ) );
	QRegExp rx1 ( "(\\/)(\\*)(.*)(\\*)(\\/)" );
	rx1.setMinimal ( true );
	stylesheet = stylesheet.replace ( rx1, QString ( "" ) );
	setStyleSheet ( stylesheet );
	setToolTip ( "ToolTip" );
}
Preview::~Preview() {destroy();}
