/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "suslictk.h"

void SuslicTk::readRC()
{
	QFile *scrf = new QFile ( "./scripts.rc" );
	if ( !scrf->exists() ) scrf = new QFile ( homePDF->absolutePath() +"/scripts.rc" );
	if ( scrf->exists() )
	{
		if ( !scrf->open ( QFile::ReadOnly | QFile::Text ) )
		{
			QMessageBox::warning ( this, tr ( "PdfTk-QGUI" ),tr ( "Cannot open file %1:\n%2." ).arg ( scrf->fileName() ).arg ( scrf->errorString() ) );
		}
		else
		{
			QTextStream in ( scrf );
			QString all = in.readAll();
			scriptNameL.clear();
			scriptTextL.clear();
			QStringList tmpl = all.split("[SCRIPTNAME]", QString::SkipEmptyParts);
			for(int i=0;i<tmpl.count();i++)
			{
				QStringList tmpl2 = tmpl[i].split("[SCRIPTBODY]", QString::SkipEmptyParts);
				if(tmpl2.count() != 2) qDebug()<<"invalid script "<<i;
				else
				{
					if(tmpl2[0].startsWith("\n"))	tmpl2[0].remove(0,1);
					if(tmpl2[0].endsWith("\n"))	tmpl2[0].chop(1);
					scriptNameL<<tmpl2[0];
					qDebug()<<tmpl2[0];

					if(tmpl2[1].startsWith("\n"))	tmpl2[1].remove(0,1);
					if(tmpl2[1].endsWith("\n"))	tmpl2[1].chop(1);
					scriptTextL<<tmpl2[1];
					qDebug()<<tmpl2[1];
				}
			}
			scrf->close();
		}
	}
	askdir = set.value("AskChDir", true).toBool();
	setf = new QFile ( "./suslictk.rc" );
	if ( !setf->exists() ) setf = new QFile ( homePDF->absolutePath() +"/suslictk.rc" );
	if ( setf->exists() )
	{
		if ( !setf->open ( QFile::ReadOnly | QFile::Text ) )
		{
			QMessageBox::warning ( this, tr ( "PdfTk-QGUI" ),tr ( "Cannot open file %1:\n%2." ).arg ( setf->fileName() ).arg ( setf->errorString() ) );
		}
		else
		{
			int s = 0;
			for ( int i=0;i<6;i++ ) {index[i] = -1;}
			QTextStream in ( setf );
			QString all = in.readAll();
			QStringList opts1 = all.split ( "\n", QString::SkipEmptyParts );
			if ( opts1.indexOf ( "[version]" ) >=0 )
			{
				QString RCver = opts1[opts1.indexOf ( "[version]" ) +1];
				if ( RCver != version )
				{
					TE->setText ( TE->toHtml() +tr ( "<br>Version mismatch for configuration file!<br>Will try to read settings<br>Please run Edit->Preferences to update your configuration file<br>In case of any problems, try to delete old configuration file." ) );
				}
				else
				{
					TE->setText ( TE->toHtml() +tr ( "<br>Found configuration file of appropriate version (version %1)" ).arg ( RCver ) );
				}
			}
			else{TE->setText ( TE->toHtml() +tr ( "<br>Version mismatch for configuration file!<br>Will try to read settings<br>Please run Edit->Preferences to update your configuration file<br>In case of any problems, try to delete old configuration file." ) );}
			int i = opts1.indexOf ( "[pdftkbinary]" );
			if ( i >=0  && opts1.count() > ( i+1 ) )
			{
				pdftkBin = opts1[i+1];
				if ( !QFileInfo ( pdftkBin ).exists() || !QFileInfo ( pdftkBin ).isExecutable() )
				{
					tkPresent=false;s=1;
				}
			}
			else
			{
				tkPresent=false;s=1;
			}
			i = opts1.indexOf ( "[background_main]" );
			if ( i >=0 && opts1.count() > ( i+1 ) )
			{
				backColor = opts1[i+1];
				qDebug() <<"bg match num = "<<backColor.count ( QRegExp ( "^#(\\d|[A-F]|[a-f]){6,6}$" ) ) ;
				if ( backColor.count ( QRegExp ( "^#(\\d|[A-F]|[a-f]){6,6}$" ) ) == 1 )
					{}
				else{backColor = "#000000";s=1;}
			}
			else {backColor = "#000000";s=1;}
			i = opts1.indexOf ( "[textcolor_main]" );
			if ( i >=0 && opts1.count() > ( i+1 ) )
			{
				textColor = opts1[i+1];
				qDebug() <<"text match num = "<<textColor.count ( QRegExp ( "^#(\\d|[A-F]|[a-f]){6,6}$" ) ) ;
				if ( textColor.count ( QRegExp ( "^#(\\d|[A-F]|[a-f]){6,6}$" ) ) == 1 )
					{}
				else{textColor = "#ffffff";s=1;}
			}
			else {textColor = "#ffffff";s=1;}
			i = opts1.indexOf ( "[lookandfeel]" );
			if ( i >=0 && opts1.count() > ( i+1 ) )
			{
				if ( opts1[i +1] == "Cleanlooks" )
				{
					QApplication::setStyle ( new QCleanlooksStyle );
				}
				if ( opts1[i +1] == "Motif" )
				{
					QApplication::setStyle ( new QMotifStyle );
				}
				if ( opts1[i +1] == "Plastique" )
				{
					QApplication::setStyle ( new QPlastiqueStyle );
				}
#if QT_VERSION >= 0x040500
				if ( opts1[i+1] == "GTK" )
				{
//					QApplication::setStyle ( new QGtkStyle );
				}
#endif
			}
			else {QApplication::setStyle ( new QCleanlooksStyle );}
			i = opts1.indexOf ( "[fav-scripts]" );
			favScriptNum =set.value ( "FavScriptNum", 0).toInt();
			if ( i >=0 && opts1.count() > ( i+1 ) )
			{
				favScriptList = opts1[i+1].split(";", QString::SkipEmptyParts);
				int favNum = favScriptList.count()>favScriptNum ? favScriptNum : favScriptList.count();
				qDebug()<<"main read settings: favNum = "<<favNum;
				for(int i=0;i<5;i++)
				{
					if(i < favNum)
					{
						actionFavScripts[i]->setText(favScriptList[i]);
						actionFavScripts[i]->setVisible(true);
					}
					else	actionFavScripts[i]->setVisible(false);
				}
			}
			else
			{
				qDebug()<<"no fav scripts";
				for(int i=0;i<5;i++)	actionFavScripts[i]->setVisible(false);
			}
			if(recScriptList.isEmpty())
			{
				QString rS1 = set.value("RecScript1", QString()).toString();
				if(!rS1.isEmpty())	recScriptList<<rS1;
				rS1 = set.value("RecScript2", QString()).toString();
				if(!rS1.isEmpty())	recScriptList<<rS1;
				onRecScriptListChanged();
			}
			i = opts1.indexOf ( "[font-size]" );
			if ( i >=0 && opts1.count() > ( i+1 ) ) fontSize = opts1[i +1];
			else {fontSize = "10";}
			i = opts1.indexOf ( "[font-family]" );
			if ( i >=0 && opts1.count() > ( i+1 ) ) fontType = opts1[i +1];
			else {fontType = "";}
			i = opts1.indexOf ( "[viewer]" );
			if ( i >=0 && opts1.count() > ( i+1 ) ) viewerBin = opts1[i +1];
			else {s=1;viewerBin = "@native";}
			i = opts1.indexOf ( "[ext-css]" );
			if ( i >=0 )
			{
				if ( opts1.count() > ( i+1 ) ) {cssF = opts1[i+1];}
			}
			else
			{
				cssF = "";
				i = opts1.indexOf ( "[background-cat]" );
				if ( i >=0 && opts1.count() > ( i+1 ) )
				{
					bool ok;
					int j = opts1[i+1].toInt ( &ok, 10 );
					if ( ok ) {index[0] = j;}
				}
				i = opts1.indexOf ( "[background-bur]" );
				if ( i >=0 && opts1.count() > ( i+1 ) )
				{
					bool ok;
					int j = opts1[i+1].toInt ( &ok, 10 );
					if ( ok ) {index[1] = j;}
				}
				i = opts1.indexOf ( "[background-att]" );
				if ( i >=0 && opts1.count() > ( i+1 ) )
				{
					bool ok;
					int j = opts1[i+1].toInt ( &ok, 10 );
					if ( ok ) {index[2] = j;}
				}
				i = opts1.indexOf ( "[background-encr]" );
				if ( i >=0 && opts1.count() > ( i+1 ) )
				{
					bool ok;
					int j = opts1[i+1].toInt ( &ok, 10 );
					if ( ok ) {index[3] = j;}
				}
				i = opts1.indexOf ( "[background-report]" );
				if ( i >=0 && opts1.count() > ( i+1 ) )
				{
					bool ok;
					int j = opts1[i+1].toInt ( &ok, 10 );
					if ( ok ) {index[4] = j;}
				}
				i = opts1.indexOf ( "[background-common]" );
				if ( i >=0 && opts1.count() > ( i+1 ) )
				{
					bool ok;
					int j = opts1[i+1].toInt ( &ok, 10 );
					if ( ok ) {index[5] = j;}
				}
			}
			i = opts1.indexOf ( "[printer]" );
			//qDebug()<<"index of printer = "<<i;
			if ( i >=0 && opts1.count() > ( i+1 ) )
			{
				bool ok;
				QStringList printerList = opts1[i+1].split ( ";" );
				if ( printerList.count() <4 )
				{
					qDebug() <<"error reading printer settings";
				}
				else
				{
					int j = printerList[0].toInt ( &ok, 10 );
					if ( ok && j == 1 ) orient=1; else orient = 0;
					//qDebug()<<"orient = "<<orient;
					j = printerList[1].toInt ( &ok, 10 );
					if ( ok ) resol=j; else resol = 100;
					//qDebug()<<"resol = "<<resol;
					j = printerList[2].toInt ( &ok, 10 );
					if ( ok && j == 1 ) colorM=1; else colorM = 0;
					//qDebug()<<"colorM = "<<colorM;
					j = printerList[3].toInt ( &ok, 10 );
					if ( ok && j == 1 ) order=1; else order = 0;
					//qDebug()<<"order = "<<order;
				}
			}
			else {orient = 0;resol = 100; colorM = 0; order = 0;}
			if ( s==0 ) {TE->setText ( TE->toHtml() +tr ( "<br>PdfTk binary: %1<br>Viewer binary: %2<br>Successfully read configuration file!" ).arg ( pdftkBin ).arg ( viewerBin ) );}
			else{TE->setText ( TE->toHtml() +tr ( "<br>Error reading configuration file<br>Please run Edit->Preferences to repair your configuration file" ) );}
			if ( index[0]>=0 || index[1]>=0 || index[2]>=0 || index[3]>=0 || index[4]>=0 || index[5] >=0 )
			{
				QFile *tfile = new QFile ( homePDF->absolutePath() +"/bgimg.rc" );
				if ( tfile->exists() )
				{
					if ( !tfile->open ( QFile::ReadOnly | QFile::Text ) )
					{
						QMessageBox::warning ( this,  tr ( "PdfTk-QGUI" ),tr ( "Cannot open file" ) );
						for ( int i=0;i<6;i++ ) {index[i] = -1;}
						TE->setText ( TE->toHtml() +tr ( "<br>Failed to import backgrounds" ) );
					}
					else
					{
						QTextStream in ( tfile );
						imgDB = in.readAll().split ( "\n", QString::SkipEmptyParts );
						tfile->close();
					}
				}
				else{for ( int i=0;i<6;i++ ) {index[i] = -1;}TE->setText ( TE->toHtml() +tr ( "<br>Failed to import backgrounds. File bgimg.rc does not exist!" ) );}
			}
			if ( index[0]<0 && index[1]<0 && index[2]<0 && index[3]<0 && index[4]<0 && index[5]<0 )
			{
				if ( cssF == "" )
				{
					TE->setText ( TE->toHtml() +tr ( "<br>No backgrounds to import" ) );
					setStyleSheet ( tr ( "QTextEdit#TE{background: %1; color: %2;}" ).arg ( backColor ).arg ( textColor ) );
				}
			}
			if ( index[4]>=0 && imgDB.count() >index[4] )
			{
				setStyleSheet ( tr ( "QTextEdit#TE{background: url(%1); color: %2;}" ).arg ( imgDB[index[4]] ).arg ( textColor ) );
			}
			if ( index[5]>=0 && imgDB.count() >index[5] )
			{
				setStyleSheet ( tr ( "QTextEdit#TE{background: url(%1); color: %2;}" ).arg ( imgDB[index[5]] ).arg ( textColor ) );
				qDebug() <<"bgName5 = "<<imgDB[index[5]] ;
				index[0] = index[1] = index[2] = index[3] = index[4] = index[5];
			}
			if ( index[4]<0 && index[5]<0 && cssF == "" )
				{setStyleSheet ( tr ( "QTextEdit#TE{background: %1; color: %2;}" ).arg ( backColor ).arg ( textColor ) );}
			QString te = TE->toHtml();
			QRegExp rx ( "font-family:'*';" );
			rx.setPatternSyntax ( QRegExp::Wildcard );
			rx.setMinimal ( true );
			te = te.replace ( rx, QString ( "" ) );
			TE->setText ( te );
			if ( cssF == "" )
			{
				TE->setFont ( QFont ( fontType ) );
				if ( fontSize.toInt() > 0 ) TE->setFontPointSize ( fontSize.toInt() );
			}
			else
			{
				qDebug() <<"importing css";
				QFile *tfile = new QFile ( cssF );
				if ( tfile->exists() )
				{
					if ( !tfile->open ( QFile::ReadOnly | QFile::Text ) )
					{
						QMessageBox::warning ( this, tr ( "PdfTk-QGUI" ),tr ( "Cannot open file" ) );
						TE->setText ( TE->toHtml() +tr ( "Failed to import css file" ) );
					}
					else
					{
						QTextStream in ( tfile );
						QString cssStr = in.readAll();
						QRegExp rx1 ( "(\\/)(\\*)(.*)(\\*)(\\/)" );
						rx1.setMinimal ( true );
						cssStr = cssStr.replace ( rx1, QString ( "" ) );
						QString repstr = QFileInfo ( cssF ).canonicalPath() +"/";
						QStringList repL = repstr.split ( "/", QString::SkipEmptyParts );
						repL.removeLast();
						QString repLstr = "/"+repL.join ( "/" ) +"/";
						cssStr = cssStr.replace ( "../", repLstr );
						cssStr = cssStr.replace ( "./", repstr );
						//qDebug()<<cssStr;
						setStyleSheet ( cssStr );
						tfile->close();
					}
				}
				else{TE->setText ( TE->toHtml() +tr ( "<br>Failed to import css file. File does not exist!" ) );}
			}
			setf->close();
		}

	}
	else
	{
		pdftkBin = "pdftk";
		viewerBin = "@native";
		TE->setText ( TE->toHtml() +tr ( "<br>No configuration file<br>Please run Edit->Preferences to create configuration file" ) );
		backColor = "#000000";
		textColor = "#ffffff";
		QApplication::setStyle ( new QCleanlooksStyle );
		fontSize = "10";
		orient = 0;resol = 100; colorM = 0; order = 0;
	}

	if ( orient == 1 ) HTMLprinter->setOrientation ( QPrinter::Landscape );
	if ( colorM == 1 ) HTMLprinter->setColorMode ( QPrinter::GrayScale );
	if ( order == 1 ) HTMLprinter->setPageOrder ( QPrinter::LastPageFirst );
	HTMLprinter->setResolution ( resol );
}
