/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "suslictk.h"

void SuslicTk::onREPAIR(QString ifile)
{
	if ( !tkPresent )
	{
		QMessageBox::warning ( this, tr ( "Error" ), tr ( "This action cannot be performed without pdftk binary! Please, install pdftk and specify it's location in Preferences." ) );
		return;
	}
	QString IFILE;
	if(ifile.isEmpty()) IFILE = QFileDialog::getOpenFileName ( this, tr ( "File to repair" ), lastdir, tr ( "PDF files (*.pdf)" ) );
	else IFILE = ifile;
	if ( IFILE.isEmpty()) return;
	onSetDir ( getDirFromFile ( IFILE ) );
	IFILE = checkPath ( IFILE, "repair" );
	QString EFILE = QFileDialog::getSaveFileName ( this, tr ( "Save result as:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
	if ( EFILE.isEmpty() ) return;
	onSetDir ( getDirFromFile ( EFILE ) );
	if ( !EFILE.endsWith ( ".pdf", Qt::CaseInsensitive ) ) EFILE+=".pdf";
	if(onRepairCore ( IFILE, EFILE ))
	{
	addTextTE(tr ( "<br>&raquo;Done!<br>&raquo;Output file successfully generated and saved to<br> <b>%1</b>" ).arg ( EFILE ) );
	onView ( EFILE, true );
	}
	else	addTextTE(tr("Error"));
}
bool SuslicTk::onRepairCore ( QString ifile, QString ofile )
{
	QString ofile_1 = checkSaveFile ( ofile );
	proc = new QProcess ( this );
	proc->start ( pdftkBin+" \""+ifile+"\" output \""+ofile_1+"\"" );
	addTextPEc ( pdftkBin+" \""+ifile+"\" output \""+ofile_1+"\"" );
	if ( !proc->waitForStarted() ) {qDebug() <<"Couldn't start";return false;}
	if ( !proc->waitForFinished () ) {qDebug() <<"Not finished!";return false;}
	qDebug() <<"Exit  Code: "<<proc->exitCode() ;
	qDebug() <<"Exit Status "<<proc->exitStatus() ;
	QString sErr = proc->readAllStandardError();
	addTextPE ( proc->readAllStandardOutput() + "<br>" + sErr );
	if ( !sErr.isEmpty() )
	{
		bool cont = false;
		passcorr = false;
		if ( sErr.contains ( "OWNER PASSWORD" ) )
		{
			while ( !cont )
			{
				QMessageBox::warning ( this, tr ( "Attention" ), tr ( "Owner password required for <br>%1<br>No/incorrect password given" ).arg ( ifile ) );
				if ( QMessageBox::question ( this, tr ( "Input password" ), tr ( "Do you want to input password?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes )
				{
					QString paStr = QInputDialog::getText ( this, tr ( "Password" ), tr ( "Input password" ), QLineEdit::Password, "" );
					if ( paStr.isEmpty() ) {cont = true;passcorr = false;}
					else
					{
						proc = new QProcess ( this );
						proc->start ( pdftkBin+" \""+ifile+"\" input_pw \""+paStr+"\" output \""+ofile_1+"\"" );
						addTextPEc ( pdftkBin+" \""+ifile+"\" input_pw \""+paStr+"\" output \""+ofile_1+"\"" );
						if ( !proc->waitForStarted() ) {qDebug() <<"Could not start";return false;}
						if ( !proc->waitForFinished() ) {qDebug() <<"Could not finish";return false;}
						sErr = proc->readAllStandardError();
						addTextPE ( proc->readAllStandardOutput() +"<br>"+sErr );
						if ( sErr.isEmpty() )
						{
							cont = true;passcorr = true;
						}
						else if ( sErr.contains ( "OWNER PASSWORD" ) ) {}
						else {cont = true;passcorr = false;}
					}
				}
				else{cont = true;passcorr = false;}
			}
		}
		else{passcorr = false;}
		if(passcorr)
		{
			if(ofile_1 != ofile)	return copyEFILE(ofile_1, ofile);
			else return true;
		}
		else return false;
	}
	else
	{
		if(ofile_1 != ofile)	return copyEFILE(ofile_1, ofile);
		else return true;
	}
}
void SuslicTk::onREBUILD(QString ifile)
{
	if ( !tkPresent )
	{
		QMessageBox::warning ( this, tr ( "Error" ), tr ( "This action cannot be performed without pdftk binary! Please, install pdftk and specify it's location in Preferences." ) );
		return;
	}
	Rebuild *reb;
	if ( index[0] >= 0 && index[0] < imgDB.count() ) {reb = new Rebuild ( this, Qt::Dialog , ifile, pdftkBin,viewerBin,  imgDB[index[0]], lastdir );}
	else{reb = new Rebuild ( this, Qt::Dialog , ifile, pdftkBin, viewerBin,"", lastdir );}
	connect ( reb, SIGNAL ( _addPEc ( QString ) ), this, SLOT ( addTextPEc ( QString ) ) );
	connect ( reb, SIGNAL ( _addPE ( QString ) ), this, SLOT ( addTextPE ( QString ) ) );
	int res = reb->exec();
	if ( res == 1 ) onSetDir ( reb->ladir );
	QStringList remL = homePDF->entryList ( QStringList() <<"tmp_reb"<<"*.pdf",QDir::Files, QDir::Name );
	if ( !remL.isEmpty() )
	{
		for ( int i=0;i<remL.count();i++ )
		{
			if ( QMessageBox::question ( this, tr ( "Clearing..." ), tr ( "Remove tmp. file:<br>%1" ).arg ( remL[i] ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes )
			{
				QFile *tmpf = new QFile ( homePDF->absolutePath() +"/"+remL[i] );
				if ( !tmpf->remove() ) {TE->setText ( TE->toHtml() +tr ( "<br>Failed to delete<br>" ) +remL[i] );}
				else{TE->setText ( TE->toHtml() +tr ( "<br>%1<br>successfully deleted" ).arg ( remL[i] ) );}
			}
		}
	}
	disconnect ( reb, SIGNAL ( _addPEc ( QString ) ), this, SLOT ( addTextPEc ( QString ) ) );
	disconnect ( reb, SIGNAL ( _addPE ( QString ) ), this, SLOT ( addTextPE ( QString ) ) );
	delete reb;
}
