/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "ScriptDlg.h"

ScriptDlg::ScriptDlg ( QWidget *parent, Qt::WindowFlags f,  QStringList *scriptNames, QStringList *scriptTexts )  : QDialog ( parent, f )
{
	scriptNameL = scriptNames;
	scriptTextL = scriptTexts;

	if ( scriptTextL->count() < scriptNameL->count() )
	{
		for ( int i=scriptTextL->count();i<scriptNameL->count();i++ ) ( *scriptTextL ) <<QString ( "" );
	}
	setObjectName ( QString::fromUtf8 ( "ScriptDlg" ) );
	this->setBaseSize ( 391, 297 );
	horizontalLayout_3 = new QHBoxLayout ( this );
	horizontalLayout_3->setObjectName ( QString::fromUtf8 ( "horizontalLayout_3" ) );
	verticalLayout_3 = new QVBoxLayout();
	verticalLayout_3->setObjectName ( QString::fromUtf8 ( "verticalLayout_3" ) );
	horizontalLayout = new QHBoxLayout();
	horizontalLayout->setObjectName ( QString::fromUtf8 ( "horizontalLayout" ) );
	label = new QLabel ( this );
	label->setObjectName ( QString::fromUtf8 ( "label" ) );

	horizontalLayout->addWidget ( label );

	comboBox = new QComboBox ( this );
	comboBox->setObjectName ( QString::fromUtf8 ( "comboBox" ) );

	horizontalLayout->addWidget ( comboBox );


	verticalLayout_3->addLayout ( horizontalLayout );

	groupBox = new QGroupBox ( this );
	groupBox->setObjectName ( QString::fromUtf8 ( "groupBox" ) );
	verticalLayout = new QVBoxLayout ( groupBox );
	verticalLayout->setObjectName ( QString::fromUtf8 ( "verticalLayout" ) );
	textEdit = new QTextEdit ( groupBox );
	textEdit->setObjectName ( QString::fromUtf8 ( "textEdit" ) );

	verticalLayout->addWidget ( textEdit );

	horizontalLayout_2 = new QHBoxLayout();
	horizontalLayout_2->setObjectName ( QString::fromUtf8 ( "horizontalLayout_2" ) );
	undoTool = new QToolButton ( groupBox );
	undoTool->setObjectName ( QString::fromUtf8 ( "undoTool" ) );

	horizontalLayout_2->addWidget ( undoTool );

	redoTool = new QToolButton ( groupBox );
	redoTool->setObjectName ( QString::fromUtf8 ( "redoTool" ) );

	horizontalLayout_2->addWidget ( redoTool );

	saveTool = new QToolButton ( groupBox );
	saveTool->setObjectName ( QString::fromUtf8 ( "saveTool" ) );

	horizontalLayout_2->addWidget ( saveTool );

	helpTool = new QToolButton ( groupBox );
	helpTool->setObjectName ( QString::fromUtf8 ( "helpTool" ) );

	horizontalLayout_2->addWidget ( helpTool );


	verticalLayout->addLayout ( horizontalLayout_2 );


	verticalLayout_3->addWidget ( groupBox );


	horizontalLayout_3->addLayout ( verticalLayout_3 );

	verticalLayout_2 = new QVBoxLayout();
	verticalLayout_2->setObjectName ( QString::fromUtf8 ( "verticalLayout_2" ) );

	newButton = new QPushButton ( this );
	newButton->setObjectName ( QString::fromUtf8 ( "newButton" ) );

	verticalLayout_2->addWidget ( newButton );

	renameButton = new QPushButton ( this );
	renameButton->setObjectName ( QString::fromUtf8 ( "renameButton" ) );

	verticalLayout_2->addWidget ( renameButton );

	execButton = new QPushButton ( this );
	execButton->setObjectName ( QString::fromUtf8 ( "execButton" ) );

	verticalLayout_2->addWidget ( execButton );

	delButton = new QPushButton ( this );
	delButton->setObjectName ( QString::fromUtf8 ( "delButton" ) );

	verticalLayout_2->addWidget ( delButton );

	encrButton = new QPushButton ( this );
	encrButton->setObjectName ( QString::fromUtf8 ( "encrButton" ) );

	verticalLayout_2->addWidget ( encrButton );

	CAB = new QPushButton ( this );
	CAB->setObjectName ( QString::fromUtf8 ( "CAB" ) );

	verticalLayout_2->addWidget ( CAB );

	verticalSpacer = new QSpacerItem ( 20, 40, QSizePolicy::Minimum, QSizePolicy::Expanding );

	verticalLayout_2->addItem ( verticalSpacer );


	horizontalLayout_3->addLayout ( verticalLayout_2 );

////////////////////////////////////////
	comboBox->clear();
	if ( scriptNameL->count() > 0 )
	{
		comboBox->insertItems ( 0, ( *scriptNameL ) );
		textEdit->setText ( scriptTextL->at ( 0 ) );
	}
	else execButton->setEnabled ( false );
	textChanged = false;
	curIndex = 0;
	saveTool->setEnabled ( false );
	redoTool->setEnabled ( false );
	undoTool->setEnabled ( false );
///////////////////////////////////////

	retranslateUi();

	connect ( CAB, SIGNAL ( clicked() ), this, SLOT ( onClose() ) );
	connect ( execButton, SIGNAL ( clicked() ), this, SLOT ( onOK() ) );
	connect ( delButton, SIGNAL ( clicked() ), this, SLOT ( onDelScript() ) );
	connect ( encrButton, SIGNAL ( clicked() ), this, SLOT ( onEncryptHelp() ) );
	connect ( newButton, SIGNAL ( clicked() ), this, SLOT ( onNew() ) );
	connect ( renameButton, SIGNAL ( clicked() ), this, SLOT ( onRename() ) );
	connect ( undoTool, SIGNAL ( clicked() ), textEdit, SLOT ( undo() ) );
	connect ( redoTool, SIGNAL ( clicked() ), textEdit, SLOT ( redo() ) );
	connect ( saveTool, SIGNAL ( clicked() ), this, SLOT ( save() ) );
	connect ( helpTool, SIGNAL ( clicked() ), this, SLOT ( help() ) );
	connect ( textEdit, SIGNAL ( undoAvailable ( bool ) ), this, SLOT ( onUndoAval ( bool ) ) );
	connect ( textEdit, SIGNAL ( redoAvailable ( bool ) ), this, SLOT ( onRedoAval ( bool ) ) );
	connect ( textEdit, SIGNAL ( textChanged() ), this, SLOT ( onTextChanged() ) );
	connect ( comboBox, SIGNAL ( activated ( int ) ), this, SLOT ( onComboIndex ( int ) ) );
	
	textChanged = false;

	if((*scriptNameL).isEmpty())
	{
		groupBox->setEnabled(false);
		renameButton->setEnabled(false);
		execButton->setEnabled(false);
		delButton->setEnabled(false);
		encrButton->setEnabled(false);

	}
}
void ScriptDlg::closeEvent(QCloseEvent *e)
{
	//e->ignore();
	onClose();
}
void ScriptDlg::onClose()
{
	if ( textChanged )
	{
		if ( QMessageBox::question ( this, tr ( "ScriptDlg" ), tr ( "Save Changes?" ), QMessageBox::No|QMessageBox::Yes ) == QMessageBox::Yes )
		{
			( *scriptTextL ) [curIndex] = textEdit->toPlainText();
		}
	}

	done ( 0 );
}
void ScriptDlg::onDelScript()
{
	if ( curIndex >= 0 && curIndex < ( *scriptNameL ).count() )
	{
		if ( QMessageBox::question ( this, "ScriptDlg", tr ( "Delete script \"%1\"?" ).arg ( ( *scriptNameL ) [curIndex] ) ) == QMessageBox::Yes )
		{
			( *scriptNameL ).removeAt ( curIndex );
			( *scriptTextL ).removeAt ( curIndex );
			comboBox->removeItem ( curIndex );
			if ( curIndex == comboBox->count() ) curIndex--;
			comboBox->setCurrentIndex ( curIndex );
			onComboIndex ( curIndex );
		}
	}
	else
	{
		qDebug() <<"invalid curIndex";
		curIndex = 0;
		if ( comboBox->count() > 0 ) comboBox->setCurrentIndex ( curIndex );
	}
}
void ScriptDlg::onComboIndex ( int index )
{
	qDebug() <<"onComboIndex "<<index;
	//if ( curIndex  == index ) return;
	qDebug()<<"textChanged="<<textChanged;
	if ( textChanged )
	{
		if ( QMessageBox::question ( this, tr ( "ScriptDlg" ), tr ( "Save Changes?" ), QMessageBox::No|QMessageBox::Yes ) == QMessageBox::Yes )
		{
			( *scriptTextL ) [curIndex] = textEdit->toPlainText();
		}
	}
	textChanged = false;
	textEdit->setText ( scriptTextL->at ( index ) );
	curIndex = index;
	onTextChanged ( false );
	redoTool->setEnabled ( false );
	undoTool->setEnabled ( false );
}
void ScriptDlg::onOK()
{
	if ( textChanged )
	{
		if ( QMessageBox::question ( this, tr ( "ScriptDlg" ), tr ( "Save Changes?" ), QMessageBox::No|QMessageBox::Yes ) == QMessageBox::Yes )
		{
			( *scriptTextL ) [curIndex] = textEdit->toPlainText();
		}
		else
		{
			textEdit->setText ( scriptTextL->at ( curIndex ) );
		}
		textChanged = false;
		onTextChanged ( false );
	}
	emit _onScript ( scriptTextL->at ( curIndex ), scriptNameL->at ( curIndex ) );
	qDebug() <<"emitted _onScript";
}
void ScriptDlg::onRedoAval ( bool yes )
{
	redoTool->setEnabled ( yes );
}
void ScriptDlg::onUndoAval ( bool yes )
{
	undoTool->setEnabled ( yes );
}
void ScriptDlg::onTextChanged ( bool changed )
{
	qDebug()<<"textChanged!";
	saveTool->setEnabled ( changed );
	if(changed) textChanged = true;
	qDebug()<<"changed="<<changed<<"\ttextChanged="<<textChanged;
	if ( !changed || !textChanged )
	{
		groupBox->setTitle ( QApplication::translate ( "ScriptDlg", "View/Edit script:", 0, QApplication::UnicodeUTF8 ) );
		textChanged = false;
		return;
	}
	groupBox->setTitle ( QApplication::translate ( "ScriptDlg", "View/Edit* script:", 0, QApplication::UnicodeUTF8 ) );
	QString newText = textEdit->toPlainText();
	if ( !newText.startsWith ( "txt2pdf " ) && !newText.startsWith ( "burst " ) && !newText.startsWith ( "encrypt " ) && !newText.startsWith("/*") )
	{
		textEdit->setTextColor ( Qt::red );
	}
	else textEdit->setTextColor ( Qt::black );
}
void ScriptDlg::save()
{
	( *scriptTextL ) [curIndex] = textEdit->toPlainText();
	textChanged = false;
	onTextChanged ( false );
}
void ScriptDlg::help()
{
QMessageBox::information(this, tr("Brief help"), tr("This version of PdfTk-QGUI supports three kinds of scripts: txt2pdf, burst, encrypt. Examples:\n <b>txt2pdf * * 1</b> - for all txt files in active directory: convert to pdf document with the same name using system encoding (see QTextCodec documentation for more details) (1 - system, 0 - non-system, ? - ask about each file)\n<b>burst * /*/burst 3 pass</b> - for all pdf files in active directory: split , put it in a subdirectory with file name and saves pages as burst_001.pdf, burst_002.pdf etc. All output files are encrypted with password \"pass\".\nTo make an encrypt script, write: \"encrypt\", then space separated input files and output files patterns, then <b>one more space</b> and then press \"Encrypt wizard\"."));
}
void ScriptDlg::onEncryptHelp()
{
	Encrypt *encr = new Encrypt ( this, Qt::Dialog , "" );
	if ( encr->exec() == 1 )
	{
		textEdit->setText(textEdit->toPlainText()+" "+encr->result);
	}
}
void ScriptDlg::onNew()
{
	bool cont = false;
	QString newName;
	while ( !cont )
	{
		newName = QInputDialog::getText ( this, tr ( "ScriptDlg" ), tr ( "New script's name:" ) );
		if ( newName.isEmpty() ) return;
		if ( scriptNameL->contains ( newName ) )
			QMessageBox::warning ( this, tr ( "ScriptDlg" ), tr ( "Unfortunately, a script with the same name already exists. Please, insert another name." ) );
		else if ( newName.contains ( ";" ) )
			QMessageBox::warning ( this, tr ( "ScriptDlg" ), tr ( "Script name should not contain symbol \";\". Please, insert another name." ) );
		else cont = true;
	}
	if(!newName.isEmpty())
	{
	( *scriptNameL ) <<newName;
	( *scriptTextL ) << ( "/*script "+newName+"*/\n" );
	groupBox->setEnabled(true);
	comboBox->insertItem ( comboBox->count(), newName );
	comboBox->setCurrentIndex ( comboBox->count()-1 );
	onComboIndex ( comboBox->count()-1 );
	renameButton->setEnabled(true);
	execButton->setEnabled(true);
	delButton->setEnabled(true);
	encrButton->setEnabled(true);
	}
}
void ScriptDlg::onRename()
{
	bool cont = false;
	QString newName;
	while ( !cont )
	{
		newName = QInputDialog::getText ( this, tr ( "ScriptDlg" ), tr ( "Script's new name:" ) );
		if ( newName.isEmpty() ) return;
		if ( scriptNameL->contains ( newName ) )
			QMessageBox::warning ( this, tr ( "ScriptDlg" ), tr ( "Unfortunately, a script with the same name already exists. Please, insert another name." ) );
		else if ( newName.contains ( ";" ) )
			QMessageBox::warning ( this, tr ( "ScriptDlg" ), tr ( "Script name should not contain symbol \";\". Please, insert another name." ) );
		else cont = true;
	}
	if(!newName.isEmpty())
	{
		(*scriptNameL)[curIndex] = newName;
		comboBox->removeItem(curIndex);
		comboBox->insertItem(curIndex, newName);
		comboBox->setCurrentIndex ( curIndex );
	}
}

void ScriptDlg::retranslateUi()
{
	setWindowTitle ( QApplication::translate ( "ScriptDlg", "ScriptDlg", 0, QApplication::UnicodeUTF8 ) );
	setWindowIcon ( QIcon ( ":/script" ) );
	label->setText ( QApplication::translate ( "ScriptDlg", "Select script:", 0, QApplication::UnicodeUTF8 ) );
	groupBox->setTitle ( QApplication::translate ( "ScriptDlg", "View/Edit script:", 0, QApplication::UnicodeUTF8 ) );
	undoTool->setIcon ( QIcon ( ":/undo" ) );
	redoTool->setIcon ( QIcon ( ":/redo" ) );
	saveTool->setIcon ( QIcon ( qApp->style()->standardIcon(QStyle::SP_DialogSaveButton) ) );
	helpTool->setIcon ( QIcon ( qApp->style()->standardIcon(QStyle::SP_DialogHelpButton) ) );
	execButton->setText ( QApplication::translate ( "ScriptDlg", "&Execute", 0, QApplication::UnicodeUTF8 ) );
	delButton->setText ( QApplication::translate ( "ScriptDlg", "&Delete", 0, QApplication::UnicodeUTF8 ) );
	encrButton->setText ( QApplication::translate ( "ScriptDlg", "&Encrypt wizard", 0, QApplication::UnicodeUTF8 ) );
	newButton->setText ( QApplication::translate ( "ScriptDlg", "&New", 0, QApplication::UnicodeUTF8 ) );
	renameButton->setText ( QApplication::translate ( "ScriptDlg", "&Rename", 0, QApplication::UnicodeUTF8 ) );
	CAB->setText ( QApplication::translate ( "ScriptDlg", "&Close", 0, QApplication::UnicodeUTF8 ) );
}
ScriptDlg::~ScriptDlg()
{
	destroy();
}
