/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef SCRIPT_H
#define SCRIPT_H

#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QComboBox>
#include <QtGui/QDialog>
#include <QtGui/QGroupBox>
#include <QtGui/QHBoxLayout>
#include <QtGui/QHeaderView>
#include <QtGui/QLabel>
#include <QtGui/QPushButton>
#include <QtGui/QCheckBox>
#include <QtGui/QSpacerItem>
#include <QtGui/QTextEdit>
#include <QtGui/QToolButton>
#include <QtGui/QVBoxLayout>
#include <QMessageBox>
#include <QInputDialog>
#include <QDebug>
#include <QCloseEvent>

#include "Encrypt.h"
class ScriptDlg : public QDialog
{
		Q_OBJECT
	public:
		ScriptDlg ( QWidget *parent, Qt::WindowFlags f, QStringList *scriptNames, QStringList *scriptTexts );
		~ScriptDlg();
		void retranslateUi();
	signals:
		void _onScript ( QString script, QString name );
	protected:
		void closeEvent(QCloseEvent *e);
	private slots:
		void onComboIndex ( int index );
		void onOK();
		void onNew();
		void onRename();
		void onRedoAval ( bool yes );
		void onUndoAval ( bool yes );
		void onTextChanged ( bool changed = true );
		void save();
		void help();
		void onClose();
		void onDelScript();
		void onEncryptHelp();
	private:
		bool textChanged;
		int curIndex;
		QStringList *scriptNameL, *scriptTextL;
		QHBoxLayout *horizontalLayout_3;
		QVBoxLayout *verticalLayout_3;
		QHBoxLayout *horizontalLayout;
		QLabel *label;
		QComboBox *comboBox;
		QGroupBox *groupBox;
		QVBoxLayout *verticalLayout;
		QTextEdit *textEdit;
		QHBoxLayout *horizontalLayout_2;
		QToolButton *undoTool;
		QToolButton *redoTool;
		QToolButton *saveTool;
		QToolButton *helpTool;
		QVBoxLayout *verticalLayout_2;
		QPushButton *newButton;
		QPushButton *renameButton;
		QPushButton *execButton;
		QPushButton *delButton;
		QPushButton *encrButton;
		QPushButton *CAB;
		QSpacerItem *verticalSpacer;
};

#endif
