/***************************************************************************
 * Any complaints or wishes please mail to suslic-2012@rambler.ru *
 * *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or *
 * (at your option) any later version. *
 * *
 * This program is distributed in the hope that it will be useful, *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the *
 * GNU General Public License for more details. *
 * *
 * You should have received a copy of the GNU General Public License *
 * along with this program; if not, write to the *
 * Free Software Foundation, Inc., *
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. *
 ***************************************************************************/
#include "SelRange.h"

SelRange::SelRange ( QWidget *parent, Qt::WindowFlags f, int numpages, QString bg )
{
	setParent ( parent );
	setWindowFlags ( f );
	setObjectName ( QString::fromUtf8 ( "SelRange" ) );
	this->resize ( 247, 103 );
	verticalLayout = new QVBoxLayout ( this );
	verticalLayout->setObjectName ( QString::fromUtf8 ( "verticalLayout" ) );
	horizontalLayout = new QHBoxLayout();
	horizontalLayout->setObjectName ( QString::fromUtf8 ( "horizontalLayout" ) );
	label = new QLabel ( this );
	label->setObjectName ( QString::fromUtf8 ( "label" ) );

	horizontalLayout->addWidget ( label );

	comboBox = new QComboBox ( this );
	comboBox->setObjectName ( QString::fromUtf8 ( "comboBox" ) );

	horizontalLayout->addWidget ( comboBox );

	label_2 = new QLabel ( this );
	label_2->setObjectName ( QString::fromUtf8 ( "label_2" ) );

	horizontalLayout->addWidget ( label_2 );

	comboBox_2 = new QComboBox ( this );
	comboBox_2->setObjectName ( QString::fromUtf8 ( "comboBox_2" ) );

	horizontalLayout->addWidget ( comboBox_2 );


	verticalLayout->addLayout ( horizontalLayout );

	label_h = new QLabel ( this );
	setObjectName ( QString::fromUtf8 ( "label_h" ) );
	verticalLayout->addWidget ( label_h );

	buttonBox = new QDialogButtonBox ( this );
	buttonBox->setObjectName ( QString::fromUtf8 ( "buttonBox" ) );
	buttonBox->setOrientation ( Qt::Horizontal );
	buttonBox->setStandardButtons ( QDialogButtonBox::Cancel|QDialogButtonBox::Ok );

	verticalLayout->addWidget ( buttonBox );


	connect ( buttonBox, SIGNAL ( accepted() ), this, SLOT ( accept() ) );
	connect ( buttonBox, SIGNAL ( rejected() ), this, SLOT ( reject() ) );

	qDebug() <<bg;
	if ( !bg.isEmpty() ) {setStyleSheet ( tr ( "QDialog{background: url(%1);}" ).arg ( bg ) );}

	setWindowTitle ( QApplication::translate ( "SelRange", "SelRange", 0, QApplication::UnicodeUTF8 ) );
	label->setText ( QApplication::translate ( "SelRange", "From:", 0, QApplication::UnicodeUTF8 ) );
	label_2->setText ( QApplication::translate ( "SelRange", "To:", 0, QApplication::UnicodeUTF8 ) );
	label_h->setText ( QApplication::translate ( "SelRange", "<b>If the number of the page to begin from<br>is greater then that of the page to end with,<br>pages will be added in reverse order</b>", 0, QApplication::UnicodeUTF8 ) );
	QStringList numbs;numbs.clear();
	for ( int i=1;i<=numpages;i++ ) numbs<<tr ( "%1" ).arg ( i );
	comboBox->insertItems ( 0, numbs );
	comboBox_2->insertItems ( 0, numbs );
	Q_UNUSED ( this );

	connect ( comboBox, SIGNAL ( currentIndexChanged ( int ) ) , this, SLOT ( onFrom ( int ) ) );
	connect ( comboBox_2, SIGNAL ( currentIndexChanged ( int ) ) , this, SLOT ( onTo ( int ) ) );
	from=1;to=1;
	adjustSize();
}
void SelRange::onFrom ( int i ) {from = i+1;}
void SelRange::onTo ( int i ) {to = i+1;}
SelRange::~SelRange() {destroy();}
