/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "SelectFiles.h"

SelectFiles::SelectFiles ( QWidget* parent, Qt::WindowFlags f, QStringList *list )
{
	if ( parent != NULL ) {setParent ( parent );}
	if ( f != NULL ) {setWindowFlags ( f );}
	list_cp = list;
	setObjectName ( QString::fromUtf8 ( "SelectFiles" ) );
	verticalLayout = new QVBoxLayout ( this );
	verticalLayout->setObjectName ( QString::fromUtf8 ( "verticalLayout" ) );
	//verticalLayout->setContentsMargins ( 0, 0, 0, 0 );
	label = new QLabel ( this );
	label->setObjectName ( QString::fromUtf8 ( "label" ) );

	verticalLayout->addWidget ( label );

	comboBox = new QComboBox(this);
	comboBox->setObjectName(QString::fromUtf8 ( "comboBox" ));
	
	verticalLayout->addWidget ( comboBox );
	
	scrollArea = new QScrollArea ( this );
	scrollArea->setBaseSize ( 400, 300 );
	scrollArea->setObjectName ( QString::fromUtf8 ( "scrollArea" ) );
	scrollWidget = new QWidget ( this );
	scrollLayout = new QVBoxLayout ( scrollWidget );
	scrollLayout->setObjectName ( QString::fromUtf8 ( "scrollLayout" ) );
	//scrollLayout->setContentsMargins ( 0, 0, 0, 0 );

	//qDebug() <<"created scrollLayout";

		checkBoxes = new QCheckBox*[list_cp->count() ];
		for ( int i=0;i<list_cp->count();i++ )
		{
			checkBoxes[i] = new QCheckBox ( scrollWidget );
			checkBoxes[i]->setObjectName ( tr ( "checkBox%1" ).arg ( i ) );
			checkBoxes[i]->setText ( list_cp->at ( i ) );
			scrollLayout->addWidget ( checkBoxes[i] );
		}
		//qDebug()<<"created checkBoxes";

		scrollArea->setWidget(scrollWidget);
		verticalLayout->addWidget ( scrollArea );

		layoutWidget2 = new QWidget ( this );
		layoutWidget2->setObjectName ( QString::fromUtf8 ( "layoutWidget2" ) );
		horizontalLayout2 = new QHBoxLayout ( layoutWidget2 );
		horizontalLayout2->setObjectName ( QString::fromUtf8 ( "horizontalLayout2" ) );
		//horizontalLayout2->setContentsMargins ( 0, 0, 0, 0 );

		//qDebug()<<"created horLayout";

		allB = new QPushButton ( layoutWidget2 );
		allB->setObjectName ( QString::fromUtf8 ( "allB" ) );
		connect ( allB, SIGNAL ( clicked() ), this, SLOT ( onAll() ) );

		horizontalLayout2->addWidget ( allB );

		horizontalSpacer_2 = new QSpacerItem ( 40, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
		horizontalLayout2->addItem(horizontalSpacer_2);
		//qDebug() <<"created allB";

		noneB = new QPushButton ( layoutWidget2 );
		noneB->setObjectName ( QString::fromUtf8 ( "noneB" ) );
		connect ( noneB, SIGNAL ( clicked() ), this, SLOT ( onNone() ) );

		horizontalLayout2->addWidget ( noneB );

		//qDebug() <<"created noneB";

	layoutWidget = new QWidget ( this );
	layoutWidget->setObjectName ( QString::fromUtf8 ( "layoutWidget" ) );
	//layoutWidget->setGeometry ( QRect ( 80, 260, 162, 31 ) );
	horizontalLayout = new QHBoxLayout ( layoutWidget );
	horizontalLayout->setObjectName ( QString::fromUtf8 ( "horizontalLayout" ) );

	horizontalSpacer = new QSpacerItem ( 40, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
	horizontalLayout->addItem(horizontalSpacer);

	CAB = new QPushButton ( layoutWidget );
	CAB->setObjectName ( QString::fromUtf8 ( "CAB" ) );

	horizontalLayout->addWidget ( CAB );

	OKB = new QPushButton ( layoutWidget );
	OKB->setObjectName ( QString::fromUtf8 ( "OKB" ) );

	horizontalLayout->addWidget ( OKB );

	verticalLayout->addWidget ( layoutWidget2 );
	verticalLayout->addWidget ( layoutWidget );
	adjustSize();

	connect ( CAB, SIGNAL ( clicked() ), this, SLOT ( reject() ) );
	connect ( OKB, SIGNAL ( clicked() ), this, SLOT ( onOk() ) );

	retranslateUi();
	onAll();
	adjustSize();
};
void SelectFiles::retranslateUi()
{
	setWindowTitle ( QApplication::translate ( "SelectFiles", "Select Files", 0, QApplication::UnicodeUTF8 ) );
	CAB->setText ( QApplication::translate ( "SelectFiles", "Cancel", 0, QApplication::UnicodeUTF8 ) );
	OKB->setText ( QApplication::translate ( "SelectFiles", "OK", 0, QApplication::UnicodeUTF8 ) );
	allB->setText ( QApplication::translate ( "SelectFiles", "&Select all", 0, QApplication::UnicodeUTF8 ) );
	noneB->setText ( QApplication::translate ( "SelectFiles", "&Deselect all", 0, QApplication::UnicodeUTF8 ) );
	label->setText ( QApplication::translate ( "SelectFiles", "Select action:", 0, QApplication::UnicodeUTF8 ) );
	comboBox->insertItems ( 0, QStringList()
	                         << QApplication::translate ( "SelectFiles", "None", 0, QApplication::UnicodeUTF8 )
							 << QApplication::translate ( "SelectFiles", "Attach files", 0, QApplication::UnicodeUTF8 )
							 << QApplication::translate ( "SelectFiles", "Unpack files", 0, QApplication::UnicodeUTF8 )
							 << QApplication::translate ( "SelectFiles", "Split into pages", 0, QApplication::UnicodeUTF8 )
							 << QApplication::translate ( "SelectFiles", "Catenate files", 0, QApplication::UnicodeUTF8 )
							 << QApplication::translate ( "SelectFiles", "Read statistics, metadata etc.", 0, QApplication::UnicodeUTF8 )
							 << QApplication::translate ( "SelectFiles", "Update statistics, metadata etc.", 0, QApplication::UnicodeUTF8 )
							 << QApplication::translate ( "SelectFiles", "Decrypt files", 0, QApplication::UnicodeUTF8 )
							 << QApplication::translate ( "SelectFiles", "Encrypt files", 0, QApplication::UnicodeUTF8 )
							 << QApplication::translate ( "SelectFiles", "Generate FDF", 0, QApplication::UnicodeUTF8 )
							 << QApplication::translate ( "SelectFiles", "Apply background", 0, QApplication::UnicodeUTF8 )
							 << QApplication::translate ( "SelectFiles", "Apply stamp", 0, QApplication::UnicodeUTF8 )
							 << QApplication::translate ( "SelectFiles", "Repair PDF", 0, QApplication::UnicodeUTF8 )
							 << QApplication::translate ( "SelectFiles", "Rebuild PDF", 0, QApplication::UnicodeUTF8 ));
}
void SelectFiles::onAll()
{
	for ( int i=0;i<list_cp->count();i++ )
	{
		checkBoxes[i]->setChecked ( true );
	}
}
void SelectFiles::onNone()
{
	for ( int i=0;i<list_cp->count();i++ )
	{
		checkBoxes[i]->setChecked ( false );
	}
}
void SelectFiles::onOk()
{
		QStringList tmpList;
		for ( int i = 0;i<list_cp->count();i++ )
		{

			if ( checkBoxes[i]->isChecked() )
			{
				tmpList<<list_cp->at ( i );
			}
		}
		list_cp->clear();*list_cp<<tmpList;
		comboIndex = comboBox->currentIndex();
	accept();
}
SelectFiles::~SelectFiles()
{
	destroy();
}
