/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "suslictk.h"

void SuslicTk::onUnpack(QString ifile)
{
	if(!tkPresent)
	{
		QMessageBox::warning(this, tr("Error"), tr("This action cannot be performed without pdftk binary! Please, install pdftk and specify it's location in Preferences."));
		return;
	}
	QString IFILE;
	if(ifile.isEmpty()) IFILE = QFileDialog::getOpenFileName ( this, tr ( "Select pdf document with attached files:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
	else IFILE = ifile;
	if ( IFILE.isEmpty()) return;
	onSetDir( getDirFromFile ( IFILE ));
	bool ifyes;
	IFILE = checkPath ( IFILE, "unpack", &ifyes );
	QString SaveDir;
	passcorr = true;
	QString UnP = pdftkBin+" \""+IFILE+"\"";
	proc = new QProcess();
	if ( QMessageBox::question ( this, tr ( "Unpack files" ), tr ( "Do you want to select directory?<br>If you click 'No', files will be unpacked into the file's directory" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes )
	{
		ifyes = true;
		bool ww = false;
		QRegExp rx ( "(\\.|\\_|\\-|\\+|\\/|\\s|[A-Z]|[a-z]|[0-9])+" );
		while ( !ww )
		{
			SaveDir = QFileDialog::getExistingDirectory ( this, tr ( "Choose Directory" ),lastdir,QFileDialog::ShowDirsOnly );
			ww = rx.exactMatch ( SaveDir );
			if ( !ww ) QMessageBox::warning ( this, "", tr ( "Directory name should contain only english characters, digits, spaces and \"_\" symbol. Please select directory so that full path matches this pattern" ) );
			if ( SaveDir.isEmpty() ) ww = true;
		}
		if ( SaveDir.isEmpty() ) {UnP+=" unpack_files output \""+lastdir+"\"";ifyes = false;}
		else{UnP+=" unpack_files output \""+SaveDir+"\"";lastdir = SaveDir;}
	}
	else {UnP+=" unpack_files output \""+lastdir+"\"";ifyes = false;}
	qDebug() <<UnP ;
	proc->start ( UnP );
	addTextPEc(UnP);
	if ( !proc->waitForStarted() ) {qDebug() <<"Couldn't start";return;}
	if ( !proc->waitForFinished () ) {qDebug() <<"Not finished!";return;}
	qDebug() <<"Exit  Code: "<<proc->exitCode() ;
	qDebug() <<"Exit Status "<<proc->exitStatus() ;
	QString sErr = proc->readAllStandardError();
	addTextPE(proc->readAllStandardOutput() + "<br>" + sErr);
	if ( !sErr.isEmpty() )
	{
		bool cont = false;
		passcorr = false;
		if ( sErr.contains ( "OWNER PASSWORD" ) )
		{
			while ( !cont )
			{
				QMessageBox::warning ( this, tr ( "Attention" ), tr ( "Owner password required!<br>No/incorrect password given" ) );
				if ( QMessageBox::question ( this, tr ( "Input password" ), tr ( "Do you want to input password?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes )
				{
					QString paStr = QInputDialog::getText ( this, tr ( "Password" ), tr ( "Input password" ), QLineEdit::Password, "" );
					if ( paStr.isEmpty() ) {cont = true;passcorr = false;}
					else
					{
						UnP = pdftkBin+" "+IFILE+" input_pw \""+paStr+"\"";
						proc = new QProcess ( this );
						if ( ifyes ) {UnP+=" unpack_files output \""+SaveDir+"\"";lastdir = SaveDir;}
						else UnP+=" unpack_files output \""+lastdir+"\"";
						proc->start ( UnP );
						addTextPEc(UnP);
						if ( !proc->waitForStarted() ) {qDebug() <<"Could not start";return;}
						if ( !proc->waitForFinished() ) {qDebug() <<"Could not finish";return;}
						sErr = proc->readAllStandardError();
						addTextPE(proc->readAllStandardOutput() + "<br>" + sErr);
						if ( !sErr.isEmpty() && sErr.contains ( "OWNER PASSWORD" ) ) {}
						if ( !sErr.isEmpty() && !sErr.contains ( "OWNER PASSWORD" ) ) {cont = true;passcorr = false;}
						if ( sErr.isEmpty() )
						{
							cont = true;passcorr = true;
						}
					}
				}
				else{cont = true;passcorr = false;}
			}
		}
		else{passcorr = false;}
	}
	if ( passcorr )
	{
		TE->setText ( TE->toHtml() +tr ( "<br>&raquo;Done!<br>&raquo;Files successfully unpacked to <b>%1</b>" ).arg ( lastdir ) );
	}
	else{TE->setText ( TE->toHtml() +tr ( "<br><font color=red>Error!</font><br>" ) +sErr );}
}
