/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "suslictk.h"

void SuslicTk::onUpdate(QString ifile)
{
	if ( !tkPresent )
	{
		QMessageBox::warning ( this, tr ( "Error" ), tr ( "This action cannot be performed without pdftk binary! Please, install pdftk and specify it's location in Preferences." ) );
		return;
	}
	passcorr = true;
	QString OIFILE;
	QString IFILE;
	if(ifile.isEmpty()) IFILE = QFileDialog::getOpenFileName ( this, tr ( "Select pdf file:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
	else IFILE = ifile;
	if ( IFILE.isEmpty() ) return;
	onSetDir ( getDirFromFile ( IFILE ) );
	OIFILE = IFILE;
	bool chan;
	IFILE = checkPath ( IFILE, "upd", &chan );
	qDebug()<<"OIFILE: "<<OIFILE<<"\nIFILE: "<<IFILE;
	proc = new QProcess ( this );
	proc->start ( pdftkBin+" \""+IFILE+"\" dump_data output -" );
	addTextPEc ( pdftkBin+" \""+IFILE+"\" dump_data output -" );
	if ( !proc->waitForStarted() ) {qDebug() <<"Couldn't start";return;}
	if ( !proc->waitForFinished () ) {qDebug() <<"Not finished!";return;}
	qDebug() <<"Exit  Code: "<<proc->exitCode() ;
	qDebug() <<"Exit Status "<<proc->exitStatus() ;
	QString sErr = proc->readAllStandardError();
	QString sOut = proc->readAllStandardOutput();
	addTextPE ( sOut + "<br>" + sErr );
	if ( !sErr.isEmpty() )
	{
		bool cont = false;
		passcorr = false;
		if ( sErr.contains ( "OWNER PASSWORD" ) )
		{
			while ( !cont )
			{
				QMessageBox::warning ( this, tr ( "Attention" ), tr ( "Owner password required!<br>No/incorrect password given" ) );
				if ( QMessageBox::question ( this, tr ( "Input password" ), tr ( "Do you want to input password?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes )
				{
					QString paStr = QInputDialog::getText ( this, tr ( "Password" ), tr ( "Input password" ), QLineEdit::Password, "" );
					if ( paStr.isEmpty() ) {cont = true;passcorr = false;}
					else
					{
						proc = new QProcess ( this );
						proc->start ( pdftkBin+" \""+IFILE+"\" input_pw \""+paStr+"\" dump_data output -" );
						addTextPEc ( pdftkBin+" \""+IFILE+"\" input_pw \""+paStr+"\" dump_data output -" );
						if ( !proc->waitForStarted() ) {qDebug() <<"Could not start";return;}
						if ( !proc->waitForFinished() ) {qDebug() <<"Could not finish";return;}
						sErr = proc->readAllStandardError();
						addTextPE ( proc->readAllStandardOutput() + "<br>" + sErr );
						if ( !sErr.isEmpty() && sErr.contains ( "OWNER PASSWORD" ) ) {}
						if ( !sErr.isEmpty() && !sErr.contains ( "OWNER PASSWORD" ) ) {cont = true;passcorr = false;}
						if ( sErr.isEmpty() )
						{
							cont = true;passcorr = true;
							sOut = proc->readAllStandardOutput();
							proc = new QProcess ( this );
							proc->start ( pdftkBin+" \""+IFILE+"\" input_pw \""+paStr+"\" output \""+homePDF->absolutePath() +"/tmp_update_"+QFileInfo ( IFILE ).baseName() +".pdf\"" );
							proc->waitForStarted();proc->waitForFinished();
							if ( !proc->readAllStandardOutput().isEmpty() ) passcorr = false;
							else IFILE = homePDF->absolutePath() +"/tmp_update_"+QFileInfo ( IFILE ).baseName() +".pdf";
						}
					}
				}
				else{cont = true;passcorr = false;}
			}
		}
		else{passcorr = false;}
	}
	if ( !passcorr ) {TE->setText ( TE->toHtml() +tr ( "<br><font color=red>Error!<br>%1</font>" ).arg ( sErr ) ); return;}

	bool IFupdate = true;
	QStringList sOutSplit = sOut.split ( "\n", QString::SkipEmptyParts );
	for ( int i=0;i<sOutSplit.count()-1;i++ )
	{
		//qDebug()<<sOutSplit[i] <<" "<<sOutSplit[i+1] ;
		if ( sOutSplit[i].contains ( "InfoKey" ) && sOutSplit[i+1].contains ( "InfoValue" ) )
		{
			bool ok;
			QString text = QInputDialog::getText ( this, tr ( "Change value" ), sOutSplit[i].split ( ":" ).last(), QLineEdit::Normal, sOutSplit[i+1].split ( ":" ).last(), &ok, Qt::Popup );
			if ( ok && !text.isEmpty() )
			{
				sOutSplit[i+1] = sOutSplit[i+1].split ( ":" ).first() +": "+text;
			}
			else{IFupdate = false;break;}
		}
	}
	if ( !IFupdate )
	{
		TE->setText ( TE->toHtml() + tr ( "<br>&nbsp;&nbsp;<font color = red><b>File info update canceled by user</b></font>" ) );
		 return;
	}

	sOut = sOutSplit.join ( "\n" );
	QString EFILE, EFILE_1;
	if ( QMessageBox::question ( this, "", tr ( "Do you want to save updated document as a new file?\nIf you select 'No', input file will be overwritten!" ), QMessageBox::Yes | QMessageBox::No ) == QMessageBox::No )
	{
		EFILE = OIFILE;
		if ( !QFile().copy ( IFILE, homePDF->absolutePath() +"/tmp_update_rescopy"+QFileInfo ( IFILE ).fileName() ) )
		{
			QMessageBox::warning ( this, "", tr ( "Failed to create temporary file\nYou will have to save encrypted file under a new name\nSorry..." ) );
			EFILE = QFileDialog::getSaveFileName ( this, tr ( "Save result as:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
			if ( EFILE.isEmpty() )
			{
				addTextTE ( tr ( "<br>&nbsp;&nbsp;<font color = red><b>File info update canceled by user</b></font>" ) );
				return;
			}
			if (!EFILE.endsWith ( ".pdf", Qt::CaseInsensitive ) ) EFILE+=".pdf";
			EFILE_1 = checkSaveFile ( EFILE );
			qDebug()<<"EFILE: "<<EFILE<<"\nEFILE_1: "<<EFILE_1;
		}
		else
		{
			IFILE = homePDF->absolutePath() +"/tmp_update_rescopy"+QFileInfo ( IFILE ).fileName();
			EFILE_1 = checkSaveFile ( EFILE );
			qDebug()<<"EFILE: "<<EFILE<<"\nEFILE_1: "<<EFILE_1;
		}
	}
	else
	{
		EFILE = QFileDialog::getSaveFileName ( this, tr ( "Save result as:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
		if ( EFILE.isEmpty() )
		{
			addTextTE ( tr ( "<br>&nbsp;&nbsp;<font color = red><b>File info update canceled by user</b></font>" ) );
			return;
		}
		if ( !EFILE.isEmpty() && !EFILE.endsWith ( ".pdf", Qt::CaseInsensitive ) ) EFILE+=".pdf";
		EFILE_1 = checkSaveFile ( EFILE );
		qDebug()<<"EFILE: "<<EFILE<<"\nEFILE_1: "<<EFILE_1;
	}

	onSetDir ( getDirFromFile ( EFILE ) );
	int hh = 0;
	while(QFile(homePDF->absolutePath() +"/tmp_update_"+tr("%1").arg(hh)+".info").exists())	hh++;
	QFile file ( homePDF->absolutePath() +"/tmp_update_"+tr("%1").arg(hh)+".info" );
	if ( !file.open ( QFile::WriteOnly | QFile::Text ) )
	{
		QMessageBox::critical ( this, tr ( "PdfTk-QGUI" ),tr ( "Error writing to file %1:\n%2." ).arg ( file.fileName() ).arg ( file.errorString() ) );
		TE->setText ( TE->toHtml() +"<br>"+tr ( "Error writing to file %1:\n%2." ).arg ( file.fileName() ).arg ( file.errorString() ) );
	}
	else
	{
		QTextStream out ( &file );
		out <<sOut;
		file.close();
		proc = new QProcess();
		proc->start ( pdftkBin+" \""+IFILE+"\" update_info \""+homePDF->absolutePath() +"/tmp_update_"+tr("%1").arg(hh)+".info\" output \""+EFILE_1+"\"" );
		addTextPEc ( pdftkBin+" \""+IFILE+"\" update_info \""+homePDF->absolutePath() +"/tmp_update_"+tr("%1").arg(hh)+".info\" output \""+EFILE_1+"\"" );
		if ( !proc->waitForStarted() ) {qDebug() <<"Couldn't start";return;}
		if ( !proc->waitForFinished () ) {qDebug() <<"Not finished!";return;}
		qDebug() <<"Exit  Code: "<<proc->exitCode() ;
		qDebug() <<"Exit Status "<<proc->exitStatus() ;
		QString sErr1 = proc->readAllStandardError();
		addTextPE ( proc->readAllStandardOutput() + "<br>" + sErr1 );
		if ( sErr1.isEmpty() )
		{
			if ( EFILE_1 != EFILE )
			{
				qDebug() <<"update copy "<<copyEFILE ( EFILE_1, EFILE );
			}
			TE->setText ( TE->toHtml() +tr ( "<br>&raquo;Done!<br>&raquo;Updated file successfully saved to<br>&nbsp;&nbsp;" ) +EFILE );
			if ( QMessageBox::question ( this, tr ( "Clear" ), tr ( "Delete temporary info file(s)?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes )
			{
				QStringList remL = homePDF->entryList ( QStringList() <<"tmp_update_*" );
				//qDebug()<<"remL.count "<<remL.count();
				for ( int i=0;i<remL.count();i++ )
				{
					remL[i] = homePDF->absolutePath() +"/"+remL[i];
					//qDebug()<<remL[i];
					if ( !QFile ( remL[i] ).remove() )
					{
						TE->setText ( TE->toHtml() +tr ( "<br>Error removing temporary file" ) );
					}
					else
					{
						TE->setText ( TE->toHtml() +tr ( "<br>Temporary file %1 successfully removed" ).arg ( remL[i] ) );

					}
				}
			}
			if ( OIFILE != EFILE && QMessageBox::question ( this, tr ( "Clear" ), tr ( "Delete old pdf file?<br>File to delete<br><b>%1</b>" ).arg ( OIFILE ), QMessageBox::Yes | QMessageBox::No ) == QMessageBox::Yes )
			{
				QFile fileO ( OIFILE );
				if ( !fileO.remove() )
				{
					TE->setText ( TE->toHtml() +tr ( "<br>Error removing old pdf file" ) );
				}
				else
				{
					TE->setText ( TE->toHtml() +tr ( "<br>Old pdf file successfully removed" ) );
				}
			}
		}
		else
		{
			TE->setText ( TE->toHtml() +tr ( "<br><font color=red><b>Error!</b></font><br>" ) +sErr1 );
			QMessageBox::critical ( this, tr ( "Error!" ), tr ( "Unknown error occurred!<br>Output of the process:<br>%1" ).arg ( sErr1 ) );
		}
	}
}
