/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "suslictk.h"

void SuslicTk::onGenerate ( QString ifile )
{
	if ( !tkPresent )
	{
		QMessageBox::warning ( this, tr ( "Error" ), tr ( "This action cannot be performed without pdftk binary! Please, install pdftk and specify it's location in Preferences." ) );
		return;
	}
	passcorr = true;
	QString IFILE;
	if ( ifile.isEmpty() ) IFILE = QFileDialog::getOpenFileName ( this, tr ( "Select pdf file to generate FDF from:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
	else IFILE = ifile;
	if ( IFILE.isEmpty() ) return;
	onSetDir ( getDirFromFile ( IFILE ) );
	IFILE = checkPath ( IFILE, "genfdf" );
	QString EFILE, EFILE_1;
	EFILE = QFileDialog::getSaveFileName ( this, tr ( "Save result as:" ), lastdir+"/"+QFileInfo ( IFILE ).baseName() +".fdf", tr ( "FDF file (*.fdf)" ) );
	if ( !EFILE.isEmpty() && !EFILE.endsWith ( ".fdf", Qt::CaseInsensitive ) ) EFILE+=".fdf";
	EFILE_1 = checkSaveFile ( EFILE );
	if ( EFILE.isEmpty() ) return;
	onSetDir ( getDirFromFile ( EFILE ) );
	proc = new QProcess ( this );
	proc->start ( pdftkBin+" \""+IFILE+"\" generate_fdf output \""+EFILE_1+"\"" );
	addTextPEc ( pdftkBin+" \""+IFILE+"\" generate_fdf output \""+EFILE_1+"\"" );
	if ( !proc->waitForStarted() ) {qDebug() <<"Couldn't start";return;}
	if ( !proc->waitForFinished () ) {qDebug() <<"Not finished!";return;}
	qDebug() <<"Exit  Code: "<<proc->exitCode() ;
	qDebug() <<"Exit Status "<<proc->exitStatus() ;
	QString sErr = proc->readAllStandardError();
	addTextPE ( proc->readAllStandardOutput() + "<br>" + sErr );
	if ( !sErr.isEmpty() )
	{
		bool cont = false;
		passcorr = false;
		if ( sErr.contains ( "OWNER PASSWORD" ) )
		{
			while ( !cont )
			{
				QMessageBox::warning ( this, tr ( "Attention" ), tr ( "Owner password required!<br>No/incorrect password given" ) );
				if ( QMessageBox::question ( this, tr ( "Input password" ), tr ( "Do you want to input password?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes )
				{
					QString paStr = QInputDialog::getText ( this, tr ( "Password" ), tr ( "Input password" ), QLineEdit::Password, "" );
					if ( paStr.isEmpty() ) {cont = true;passcorr = false;}
					else
					{
						proc = new QProcess ( this );
						proc->start ( pdftkBin+" \""+IFILE+"\" input_pw \""+paStr+"\" generate_fdf output \""+EFILE_1+"\"" );
						addTextPE ( "<b>"+pdftkBin+" \""+IFILE+"\" input_pw \""+paStr+"\" generate_fdf output \""+EFILE_1+"\""+"</b>" );
						if ( !proc->waitForStarted() ) {qDebug() <<"Could not start";return;}
						if ( !proc->waitForFinished() ) {qDebug() <<"Could not finish";return;}
						sErr = proc->readAllStandardError();
						addTextPE ( proc->readAllStandardOutput() +"<br>"+sErr );
						if ( !sErr.isEmpty() && sErr.contains ( "OWNER PASSWORD" ) ) {}
						if ( !sErr.isEmpty() && !sErr.contains ( "OWNER PASSWORD" ) ) {cont = true;passcorr = false;}
						if ( sErr.isEmpty() )
						{
							cont = true;passcorr = true;
						}
					}
				}
				else{cont = true;passcorr = false;}
			}
		}
		else{passcorr = false;}
	}
	if ( passcorr )
	{
		if ( EFILE_1 != EFILE )	copyEFILE ( EFILE_1, EFILE );
		TE->setText ( TE->toHtml() +tr ( "<br>&raquo;Done!<br>&raquo;FDF file successfully generated and saved to<br> <b>%1</b>" ).arg ( EFILE ) );
	}
	else{TE->setText ( TE->toHtml() +tr ( "<br><font color=red>Error!</font>" ) );}
}

