/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "suslictk.h"

void SuslicTk::onCheckUpdate()
{
	ifupdate = 1;
	onSendRequest ( "http://suslic-2012.narod.ru/files/info_new2.txt" );
}
void SuslicTk::onSendRequestSRC()
{
	if(!adressSRC.isEmpty()) onSendRequest(adressSRC);
}
void SuslicTk::onSendRequestBIN()
{
	if(!adressBIN.isEmpty()) onSendRequest(adressBIN);
}
void SuslicTk::onSendRequest ( QString url )
{
	/////////////INIT//////////////////////
	http = new QHttp ( this );
	connect ( http, SIGNAL ( stateChanged ( int ) ), this, SLOT ( httpStateChanged ( int ) ) );
	connect ( http, SIGNAL ( requestFinished ( int, bool ) ), this, SLOT ( httpRequestFinished ( int, bool ) ) );
	connect ( http, SIGNAL ( dataReadProgress ( int, int ) ), this, SLOT ( httpDataReadProgress ( int, int ) ) );
	connect ( http, SIGNAL ( responseHeaderReceived ( const QHttpResponseHeader & ) ),this, SLOT ( httpResponseHR ( const QHttpResponseHeader & ) ) );
	////////////////////////////////////////
	qDebug() <<"created http object";
	if ( ifupdate != 2 )
	{
		if ( tmphtmlfile->isOpen() ) tmphtmlfile->close();

		if ( !tmphtmlfile->open ( QFile::WriteOnly ) )
		{
			QMessageBox::critical ( this, "", tr ( "Cannot write to file %1" ).arg ( tmphtmlfile->fileName() ) );
			request = false;
			if ( ifupdate  > 0 ) {hprint = false;}
			return;

		}
	}
	checkurl = new QUrl ( url );
	if ( !checkurl->isValid() )
	{
		qDebug() <<"Invalid url!";
		request = false;
		if ( ifupdate > 0 ) {hprint = false;}
		return;
	}
	qDebug() <<"url checked";
	http->setHost ( checkurl->host(), QHttp::ConnectionModeHttp, checkurl->port() == -1 ? 0 : checkurl->port() );
	QByteArray path = QUrl::toPercentEncoding ( checkurl->path(), "!$&'()*+,;=:@/" );
	qDebug() <<"path: "<<path;
	if ( path.isEmpty() ) path = "/";
	qDebug() <<"Sending request";
	if ( ifupdate < 2 ) httpGetId = http->get ( path, tmphtmlfile );
	else
	{
		qDebug() <<"path: "<<path;
		if ( !updatefile->isOpen() ) { qDebug() <<"update file not opened!"; return;}
		httpGetId = http->get ( path, updatefile );
		qDebug() <<"httpGetId "<<httpGetId;
	}
	prDlg->show();
	request = true;
}
void SuslicTk::httpStateChanged ( int state )
{
	qDebug() <<"HTTP state changed";
	if ( state == 1 ) {prDlg->setLabelText ( tr ( "Looking up for host name" ) );}
	if ( state == 2 ) {prDlg->setLabelText ( tr ( "Connecting to %1" ).arg ( checkurl->host() ) );}
	if ( state == 3 ) {prDlg->setLabelText ( tr ( "Sending request to the server" ) );}
	if ( state == 4 ) {prDlg->setLabelText ( tr ( "Reading server's response" ) );}
	if ( state == 5 ) {prDlg->setLabelText ( tr ( "Connected to %1" ).arg ( checkurl->host() ) );}
	if ( state == 6 ) {prDlg->setLabelText ( tr ( "Closing connection" ) );}

}
void SuslicTk::httpRequestFinished ( int id, bool error )
{
	qDebug() <<"Request finished";
	if ( id != httpGetId ) {qDebug() <<"false id";return;}
	if ( !request )
	{
		qDebug() <<"Not request";
		prDlg->hide();
		if ( tmphtmlfile->isOpen() ) tmphtmlfile->close();
		return;
	}
	request = false;
	prDlg->hide();
	if ( ifupdate < 2 && tmphtmlfile->isOpen() ) tmphtmlfile->close();
	if ( error )
	{
		qDebug() <<"Request error";
		QMessageBox::critical ( this, tr ( "HTTP Request" ), tr ( "Request failed!<br>Error: %1." ).arg ( http->errorString() ) );
		if ( ifupdate == 0 ) {HTMLloadFinished ( false );}
		return;
	}
	///////////////CLEAN UP////////////////////
	http->clearPendingRequests();
	http->close();
	disconnect ( http, SIGNAL ( stateChanged ( int ) ), this, SLOT ( httpStateChanged ( int ) ) );
	disconnect ( http, SIGNAL ( requestFinished ( int, bool ) ), this, SLOT ( httpRequestFinished ( int, bool ) ) );
	disconnect ( http, SIGNAL ( dataReadProgress ( int, int ) ), this, SLOT ( httpDataReadProgress ( int, int ) ) );
	disconnect ( http, SIGNAL ( responseHeaderReceived ( const QHttpResponseHeader & ) ),this, SLOT ( httpResponseHR ( const QHttpResponseHeader & ) ) );
	//delete http;
	///////////////////////////////////////////
	if ( ifupdate == 2 )
	{
		QMessageBox::information ( this, tr ( "Update" ), tr ( "Update successfully downloaded!" ) );
		if ( updatefile->isOpen() ) updatefile->close();
		qDebug() <<"Success!";
		return;
	}
	if ( ifupdate == 1 )
	{
		qDebug() <<"update";
		QTimer::singleShot(100, this, SLOT(compareVersions()));
		qDebug() <<"gotUpInfo emitted";
		return;
	}
	if ( ifupdate == 0 )
	{
		qDebug() <<"html_print";
		HTMLloadFinished ( true );
		qDebug() <<"Success!";
		return;
	}
}
void SuslicTk::httpDataReadProgress ( int done, int total )
{
	qDebug() <<"Data read "<<done<<" of "<<total;
	if ( !request ) {qDebug() <<"Data read, not requested ";return;}
	prDlg->setMaximum ( total );
	//prDlg->setLabelText(tr("Downloaded %1 of %2 bytes").arg(done).arg(total));
	prDlg->setValue ( done );
	qDebug() <<"Data read "<<done<<" of "<<total;

}
void SuslicTk::httpResponseHR ( const QHttpResponseHeader &resp )
{
	qDebug() <<"status code: "<<resp.statusCode() ;
}
void SuslicTk::progressCancelled()
{
	qDebug() <<"Progress canceled";
	http->abort();
	prDlg->hide();
	tmphtmlfile->close();
	request = false;
	if ( !ifupdate ) {HTMLloadFinished ( false );}
}
void SuslicTk::compareVersions()
{
	if ( !tmphtmlfile->open ( QFile::ReadOnly|QFile::Text ) )
	{
		QMessageBox::warning ( this, tr ( "PdfTk-QGUI" ),tr ( "Cannot open file %1:\n%2." ).arg ( tmphtmlfile->fileName() ).arg ( tmphtmlfile->errorString() ) );
		return;
	}
	else
	{
		QTextStream in ( tmphtmlfile );
		httpDataStr = in.readAll();
		tmphtmlfile->close();
	}
	//qDebug()<<httpDataStr;
	QStringList l = httpDataStr.split ( "\n", QString::SkipEmptyParts );
	QString upver = l.first();
	qDebug() <<upver ;
	adressSRC = "";
	adressBIN = "";
	commentBIN = "";
	if ( l.count() >1 )
	{
		adressSRC = l[1];
		qDebug() <<"adressSRC"<<adressSRC;
		/*if(QMessageBox::question(this, tr("Update"), tr("Download update?"), QMessageBox::No|QMessageBox::Yes) == QMessageBox::Yes)
		{
			QString selectT = QInputDialog::getItem(this, tr("Update download"), tr("Select type:"), )
			onSendRequest(adress);
		}*/
	}
	if ( l.count() > 2 )
	{
		adressBIN = l[2];
		commentBIN = ( adressBIN.split ( ";" ).count() >1 ? adressBIN.split ( ";" ).last() : "" );
		adressBIN = adressBIN.split ( ";" ).first();
		if ( !QUrl ( adressBIN ).isValid() )
		{
			qDebug() <<"invalid bin adress: "<<adressBIN;
			adressBIN = "";
		}
		qDebug() <<"adressBIN="<<adressBIN;
	}
	QString message = "";
	if ( l.count() > 3 )
	{
		l.removeAt ( 0 );
		l.removeAt ( 0 );
		l.removeAt ( 0 );
		message = l.join ( "\n" );
	}
	int cc = QString::localeAwareCompare ( upver, version );
	qDebug() <<upver<<version<<cc;
	if ( cc == 0 ) QMessageBox::information ( this, tr ( "Update" ), tr ( "You have the latest version!" ) );
	if ( cc < 0 ) QMessageBox::information ( this, tr ( "Update" ), tr ( "Your version is higher than the one from official site!<br>If you are not a developer, then you have ascertained a bug.<br>Please send a report to <a href=\"mailto:suslic-2012@rambler.ru\">suslic-2012@rambler.ru</a>" ) );
	if ( cc > 0 )
	{
		if ( adressSRC.isEmpty() && adressBIN.isEmpty() )
		{
			QMessageBox::information ( this, tr ( "Update" ), tr ( "An update is available <br>Visit <a href=\"http://suslic-2012.narod.ru\">suslic-2012.narod.ru</a> to download latest version!" ) );
			if ( !message.isEmpty() ) {QMessageBox::information ( this, tr ( "Update" ), message );}
		}
		else
		{
			if ( QMessageBox::question ( this, tr ( "Update" ), tr ( "An update is available <br>Do you want to download it now?" ), QMessageBox::No|QMessageBox::Yes ) == QMessageBox::Yes )
			{
				if ( !message.isEmpty() ) {QMessageBox::information ( this, tr ( "Update" ), message );}
				if ( !adressSRC.isEmpty() && !adressBIN.isEmpty() )
				{
					bool ok;
					QString selectT = QInputDialog::getItem ( this, tr ( "Update download" ), tr ( "Select type:" ), QStringList() <<"source"<< ( "binary for "+commentBIN ), 0, false, &ok );
					if ( !ok ){qDebug()<<"canceled selection"; return;}
					QString saveUpdate = QFileDialog::getSaveFileName ( this, tr ( "Save as" ), QDir().homePath() +"/"+ ( selectT == "source" ? adressSRC : adressBIN ).split ( "/", QString::SkipEmptyParts ).last() );
					if ( saveUpdate.isEmpty() ) {qDebug()<<"canceled file name selection"; return;}
					updatefile = new QFile ( saveUpdate );
					if ( !updatefile->open ( QIODevice::WriteOnly ) )
					{
						QMessageBox::critical ( this, tr ( "Error" ), tr ( "Can not write to file %1" ).arg ( saveUpdate ) );
					}
					else
					{
						ifupdate = 2;
						if(selectT == "source")	QTimer::singleShot(100, this, SLOT(onSendRequestSRC()));
						else QTimer::singleShot(100, this, SLOT(onSendRequestBIN()));
					}
				}
				else
				{
					if ( !adressSRC.isEmpty() )
					{
						QString saveUpdate = QFileDialog::getSaveFileName ( this, tr ( "Save as" ), QDir().homePath() +"/"+adressSRC.split ( "/", QString::SkipEmptyParts ).last() );
						if ( saveUpdate.isEmpty() ) {qDebug()<<"canceled file name selection"; return;}
						updatefile = new QFile ( saveUpdate );
						if ( !updatefile->open ( QIODevice::WriteOnly ) )
						{
							QMessageBox::critical ( this, tr ( "Error" ), tr ( "Can not write to file %1" ).arg ( saveUpdate ) );
						}
						else
						{
							ifupdate = 2;
							QTimer::singleShot(100, this, SLOT(onSendRequestSRC()));
						}
					}
					else
					{
						QString saveUpdate = QFileDialog::getSaveFileName ( this, tr ( "Save as" ), QDir().homePath() +"/"+adressBIN.split ( "/", QString::SkipEmptyParts ).last() );
						if ( saveUpdate.isEmpty() ) {qDebug()<<"canceled file name selection"; return;}
						updatefile = new QFile ( saveUpdate );
						if ( !updatefile->open ( QIODevice::WriteOnly ) )
						{
							QMessageBox::critical ( this, tr ( "Error" ), tr ( "Can not write to file %1" ).arg ( saveUpdate ) );
						}
						else
						{
							ifupdate = 2;
							QTimer::singleShot(100, this, SLOT(onSendRequestBIN()));
						}
					}
				}
			}
		}
	}
}



