/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include <QApplication>
#include "suslictk.h"
SuslicTk *mw;
void myMessageOutput ( QtMsgType type, const char *msg )
{
	mw->DebugOutput ( type, msg );
}
int main ( int argc, char *argv[] )
{
	Q_INIT_RESOURCE ( application );
	QApplication app ( argc, argv );
	QCoreApplication::setOrganizationName ( "SuslicSoft" );
	QCoreApplication::setApplicationName ( "PdfTk-QGUI" );
	QSplashScreen *splash = new QSplashScreen ( QPixmap ( ":/backA" ) );
	splash->show();
	splash->showMessage ( qApp->translate ( "Main", "Looking for translation file" ), Qt::AlignCenter );
	QSettings set;
	QString lang = set.value ( "Language", QString ( "en" ) ).toString();
	QString locFile = set.value ( "LanguageFile", QString ( "" ) ).toString();
	QTranslator translator;
	if ( lang != "en" )
	{
		if ( lang == "custom" )
		{
			if ( QFile ( locFile ).exists() )
			{
				translator.load ( locFile );
				app.installTranslator ( &translator );
			}
			else
			{
				if ( QMessageBox::question ( splash, "Translation", "File "+locFile+" does not exist!<br>Would you like to specify another translation file?", QMessageBox::No|QMessageBox::Yes ) == QMessageBox::Yes )
				{
					locFile = QFileDialog::getOpenFileName ( splash, "Translation File", QDir().homePath(), "*.qm" );
					if ( !locFile.isEmpty() )
					{
						translator.load ( locFile );
						app.installTranslator ( &translator );
						set.setValue ( "LanguageFile", locFile );
					}
					else set.setValue ( "Language", QString ( "en" ) );
				}
				else
				{
					set.setValue ( "Language", QString ( "en" ) );
					set.setValue ( "LanguageFile", QString() );
				}
			}
		}
		else
		{
			QString locale = QLocale::system().name().split ( "_" ).first();
			qDebug() <<"lang: "<<locale;
			if ( !locale.startsWith ( "en" ) )
			{
				if ( QFile ( QDir().homePath() +"/.suslictk/suslictk_"+locale+".qm" ).exists() && translator.load (  QDir().homePath() +"/.suslictk/suslictk_"+locale+".qm" ) )
				{
					app.installTranslator ( &translator );
				}
				else
				{
					if ( !QFile ( locFile ).exists() )
					{
						qDebug() <<"No translation for "<<locale;
						if ( QMessageBox::question ( splash, "Translation", "Unfortunately, there is no built-in translation file for your locale.<br>If you would like to translate PdfTk-QGUI to your language, please send translated *.ts file to <a href=\"mailto:suslic-2012@rambler.ru\">suslic-2012@rambler.ru</a><br>If you have a translation file for your locale, you can specify it's location and use it. Do it?", QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes )
						{
							locFile = QFileDialog::getOpenFileName ( splash, "Translation File", QDir().homePath(), "*.qm" );
							if ( !locFile.isEmpty() )
							{
								translator.load ( locFile );
								app.installTranslator ( &translator );
								set.setValue ( "LanguageFile", locFile );
								set.setValue ( "Language", QString ( "custom" ) );
							}
							else set.setValue ( "Language", QString ( "en" ) );
						}
						else	set.setValue ( "Language", QString ( "en" ) );
					}
					else
					{
						QMessageBox::warning ( splash, "Translation", "No built-in translation file for locale " + locale+" . Translation file "+locFile+" will be used. You can fall back to english using Preferences dialog" );
						translator.load ( locFile );
						app.installTranslator ( &translator );
						set.setValue ( "Language", QString ( "custom" ) );
					}
				}
			}
		}
	}

	splash->showMessage ( qApp->translate ( "Main", "Looking for ~/.suslictk directory" ), Qt::AlignCenter );
	QDir *homePDF = new QDir ( QDir().homePath() + "/.suslictk" );
	if ( !homePDF->exists() )
	{
		if ( !homePDF->mkdir ( homePDF->absolutePath() ) )
			{QMessageBox::critical ( 0, QApplication::translate ( "SuslicTk", "ERROR", 0, QApplication::UnicodeUTF8 ), QApplication::translate ( "SuslicTk","Error occurred while creating directory<br>%1<br>Check rights! Will now exit", 0, QApplication::UnicodeUTF8 ).arg ( homePDF->absolutePath() ) );return 2;}
	}
	QDir *tempPDF = new QDir ( QDir().homePath() + "/.suslictk/temp" );
	if ( !tempPDF->exists() )
	{
		if ( !tempPDF->mkdir ( tempPDF->absolutePath() ) )
			{QMessageBox::critical ( 0, QApplication::translate ( "SuslicTk", "ERROR", 0, QApplication::UnicodeUTF8 ), QApplication::translate ( "SuslicTk","Error occurred while creating directory<br>%1<br>Check rights! Will now exit", 0, QApplication::UnicodeUTF8 ).arg ( tempPDF->absolutePath() ) );return 2;}
	}
	splash->showMessage ( QApplication::translate ( "SuslicTk", "Reading settings...", 0, QApplication::UnicodeUTF8 ), Qt::AlignCenter );
	QStringList argss = app.arguments();
	mw = new SuslicTk ( argss );
	qInstallMsgHandler ( myMessageOutput );
	mw->readRC();
	if ( mw->pdftkBin == app.applicationFilePath() || mw->pdftkBin == QFileInfo ( app.applicationFilePath() ).fileName() || mw->pdftkBin.contains("pdftk-qgui") )
	{
		qDebug() <<"pdftkbin=this. Error!!";
		mw->pdftkBin = "pdftk";
	}
	splash->showMessage ( QApplication::translate ( "SuslicTk", "Checking pdftk path", 0, QApplication::UnicodeUTF8 ), Qt::AlignCenter );
	QProcess *proc = new QProcess();
	proc->start ( mw->pdftkBin+" --help" );
	if ( !proc->waitForStarted() )
	{
		QMessageBox::critical ( splash, QApplication::translate ( "SuslicTk", "Error", 0, QApplication::UnicodeUTF8 ), QApplication::translate ( "SuslicTk", "An unknown error occurred!<br>Perhaps you don't have pdftk installed<br>You will now have opportunity to set path to pdftk, if it's installed in non-standard location", 0, QApplication::UnicodeUTF8 ) );
		QMessageBox::StandardButton stBut = QMessageBox::question ( splash, QApplication::translate ( "SuslicTk", "What to do...", 0, QApplication::UnicodeUTF8 ), QApplication::translate ( "SuslicTk", "Do you want to set pdftk path? If you want to search for it, press Apply", 0, QApplication::UnicodeUTF8 ), QMessageBox::Yes | QMessageBox::Apply | QMessageBox::No );
		if ( stBut == QMessageBox::Yes )
		{
			PrefsDlg *dlg = new PrefsDlg ( splash, Qt::Tool, version );
			if ( dlg->exec() == 1 )
			{
				mw->readRC();
				if ( mw->pdftkBin == app.applicationFilePath() || mw->pdftkBin == QFileInfo ( app.applicationFilePath() ).fileName() )
				{
					qDebug() <<"pdftkbin=this. Error!!";
					mw->pdftkBin = "pdftk";
				}
				proc->start ( mw->pdftkBin+" --help" );
				if ( !proc->waitForStarted() ) mw->tkPresent = false;
				else	mw->tkPresent = true;
			}
			else	mw->tkPresent = true;
		}
		if ( stBut == QMessageBox::Apply )
		{
			QMessageBox::warning ( splash, QApplication::translate ( "SuslicTk", "Attention!", 0, QApplication::UnicodeUTF8 ), QApplication::translate ( "SuslicTk", "This operation might be <b>very slow</b><br>Application will not be responding while searching for pdftk binary", 0, QApplication::UnicodeUTF8 ) );
			if ( QMessageBox::question ( splash, "", QApplication::translate ( "SuslicTk", "Continue with automatic search?", 0, QApplication::UnicodeUTF8 ), QMessageBox::Yes | QMessageBox::No ) == QMessageBox::Yes )
			{
				mw->AutoFind();
			}
			else
			{
				PrefsDlg *dlg = new PrefsDlg ( splash, Qt::Tool, version );
				if ( dlg->exec() == 1 )
				{
					mw->readRC();
					proc->start ( mw->pdftkBin+" --help" );
					if ( !proc->waitForStarted() ) mw->tkPresent = false;
					else	mw->tkPresent = true;
				}
				else	mw->tkPresent = true;
			}
		}
		if ( stBut == QMessageBox::No ) mw->tkPresent = false;
	}
	else mw->tkPresent = true;
	if ( !proc->waitForFinished () ) {}
	mw->pHelp = proc->readAllStandardOutput();
	mw->show();
	splash->finish ( mw );
	int res1 = mw->processArguments();
	if ( res1 == 1 )
	{
		mw->argAct->setVisible ( false );
		qDebug() <<"actions hidden";
	}
	else if ( res1 > 1 ) return 0;
	else {/*do nothing))*/}
	return app.exec();
}

