/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include <QtGui>
#include "Attach_impl.h"
#include "Burst_impl.h"
#include "Cat_impl.h"
#include "Decrypt_impl.h"
#include "Dump_impl.h"
#include "Encrypt_impl.h"
#include "Update_impl.h"
#include "Unpack_impl.h"
#include "Decor_impl.h"
#include "ReadRC_impl.h"
#include "CP_impl.h"
#include "EFILE_impl.h"
#include "http_impl.h"
#include "generate_impl.h"
#include "Repair_impl.h"
#include "RemTemp_impl.h"
#include "Scripts_impl.h"
#include "Converters_impl.h"

////
#include "suslictk_autof.h"
#include "suslictk_init.h"
////

#include <QFile>
#include <QTextEdit>
#include <QTextStream>
#include <QCloseEvent>
#include <QFileDialog>
#include <QMessageBox>
#include <iostream>
//#include "ImportTheme.cpp"
using namespace std;


SuslicTk::SuslicTk ( QStringList args )
{
	showEFmes = true;
	arguments = args;
	prDlg = new QProgressDialog ( this );prDlg->hide();
	prDlgBar = new QProgressBar ( prDlg );
	prDlgBar->setFormat ( tr ( "Downloaded %v of %m (%p%)" ) );
	prDlg->setBar ( prDlgBar );

	urlclip = QApplication::clipboard();

	autof = new QProcess ( this );
	AF = new AutoF ( this, Qt::Tool );

	HTMLprinter = new QPrinter ( QPrinter::HighResolution );
	HTMLprinter->setOutputFormat ( QPrinter::PdfFormat );

	initCentral();
	setCentralWidget ( centralWidget );
	print = new PrintThread;
	connect ( print, SIGNAL ( finished() ), this, SLOT ( onPFinish() ) );
	printing = false;hprint = false;

	lastdir = set.value ( "Directory", QDir().homePath() ).toString();

	qDebug() <<"LastDir = "<<lastdir ;
	if ( !QFileInfo ( lastdir ).isDir() ) {lastdir = QDir().homePath();}
	qDebug() <<"LastDir = "<<lastdir ;
	createActions();
	createMenus();
	createToolBars();
	createStatusBar();
	setWindowTitle ( "PdfTk-QGUI" );
	readSettings();
	homePDF = new QDir ( QDir().homePath() + "/.suslictk" );

	if ( QFile::exists ( homePDF->absolutePath() + "/tmp_download.html" ) ) QFile::remove ( homePDF->absolutePath() + "/tmp_download.html" );
	tmphtmlfile = new QFile ( homePDF->absolutePath() + "/tmp_download.html" );

	QStringList filters;
	filters<<"*.pdf";
	homePDF->setNameFilters ( filters );
	addTextTE(tr ( "<br><i>Welcome to PdfTk-QGUI!<br>To start, click Tools and select desired action</i><br><b>ATTENTION!</b> Do not store your files in \"~/.suslictk\" and \"~/.suslictk/temp\" directories! All files from this directories, that are not used by this program, will be <b>deleted</b>!<br>Attention! PdfTk-QGUI assumes, that the full path to your home directory does not contain non-english characters! (This will be fixed in future versions)" ) );
	onRemTemp ( true );
}
int SuslicTk::processArguments()
{
	qDebug() <<"pdftkbin "<<pdftkBin;
	qDebug() <<"arg.count() = "<<arguments.count() <<"\n"<<arguments;
	if(arguments[0] == "--help" || arguments[0] == "-h" || (arguments.count() > 1 && (arguments[1] == "--help" || arguments[1] == "-h")))
	{
		cout<<"This is PdfTk-QGUI version "<<version.toStdString()<<endl<<"Help is located here: http://suslic-2012.narod.ru/docs/index.html."<<endl;
		return 2;
	}
	if(arguments[0] == "--version" || arguments[0] == "-v" || (arguments.count() > 1 && (arguments[1] == "--version" || arguments[1] == "-v")))
	{
		cout<<"PdfTk-QGUI version "<<version.toStdString()<<endl;
		return 3;
	}
	QRegExp rx ( ".*.pdf$", Qt::CaseInsensitive );
	QStringList pdfFiles = arguments.filter ( rx );
	qDebug() <<"arg.count() = "<<arguments.count();
	bool cont = true;
	qDebug() <<"pdfFiles.count = "<<pdfFiles.count() <<"\n"<<pdfFiles;
	if ( !pdfFiles.isEmpty() )
	{
		while ( cont )
		{
			QStringList tmpFiles = pdfFiles;
			SelectFiles* self = new SelectFiles ( this, Qt::Dialog, &tmpFiles );
			if ( self->exec() != 1 || self->comboIndex == 0 || tmpFiles.count() == 0 )	cont = false;
			else
			{
				switch ( self->comboIndex )
				{
					case 1:
						for ( int i = 0;i<tmpFiles.count();i++ )
						{
							if ( QMessageBox::question ( this, "PdfTk-QGUI", tr ( "File to be processed:<br><b>%1</b><br>Continue?" ).arg ( tmpFiles[i] ), QMessageBox::No|QMessageBox::Yes ) == QMessageBox::Yes )
								onAttach ( tmpFiles[i] );
							else break;
						}
						break;
					case 2:
						for ( int i = 0;i<tmpFiles.count();i++ )
						{
							if ( QMessageBox::question ( this, "PdfTk-QGUI", tr ( "File to be processed:<br><b>%1</b><br>Continue?" ).arg ( tmpFiles[i] ), QMessageBox::No|QMessageBox::Yes ) == QMessageBox::Yes )
								onUnpack ( tmpFiles[i] );
							else break;
						}
						break;
					case 3:
						for ( int i = 0;i<tmpFiles.count();i++ )
						{
							if ( QMessageBox::question ( this, "PdfTk-QGUI", tr ( "File to be processed:<br><b>%1</b><br>Continue?" ).arg ( tmpFiles[i] ), QMessageBox::No|QMessageBox::Yes ) == QMessageBox::Yes )
								onBurst ( tmpFiles[i] );
							else break;
						}
						break;
					case 4:
						onCat ( tmpFiles );
						break;
					case 5:
						for ( int i = 0;i<tmpFiles.count();i++ )
						{
							if ( QMessageBox::question ( this, "PdfTk-QGUI", tr ( "File to be processed:<br><b>%1</b><br>Continue?" ).arg ( tmpFiles[i] ), QMessageBox::No|QMessageBox::Yes ) == QMessageBox::Yes )
								onDump ( tmpFiles[i] );
							else break;
						}
						break;
					case 6:
						for ( int i = 0;i<tmpFiles.count();i++ )
						{
							if ( QMessageBox::question ( this, "PdfTk-QGUI", tr ( "File to be processed:<br><b>%1</b><br>Continue?" ).arg ( tmpFiles[i] ), QMessageBox::No|QMessageBox::Yes ) == QMessageBox::Yes )
								onUpdate ( tmpFiles[i] );
							else break;
						}
						break;
					case 7:
						for ( int i = 0;i<tmpFiles.count();i++ )
						{
							if ( QMessageBox::question ( this, "PdfTk-QGUI", tr ( "File to be processed:<br><b>%1</b><br>Continue?" ).arg ( tmpFiles[i] ), QMessageBox::No|QMessageBox::Yes ) == QMessageBox::Yes )
								onDecrypt ( tmpFiles[i] );
							else break;
						}
						break;
					case 8:
						for ( int i = 0;i<tmpFiles.count();i++ )
						{
							if ( QMessageBox::question ( this, "PdfTk-QGUI", tr ( "File to be processed:<br><b>%1</b><br>Continue?" ).arg ( tmpFiles[i] ), QMessageBox::No|QMessageBox::Yes ) == QMessageBox::Yes )
								onEncrypt ( tmpFiles[i] );
							else break;
						}
						break;
					case 9:
						for ( int i = 0;i<tmpFiles.count();i++ )
						{
							if ( QMessageBox::question ( this, "PdfTk-QGUI", tr ( "File to be processed:<br><b>%1</b><br>Continue?" ).arg ( tmpFiles[i] ), QMessageBox::No|QMessageBox::Yes ) == QMessageBox::Yes )
								onGenerate ( tmpFiles[i] );
							else break;
						}
						break;
					case 10:
						for ( int i = 0;i<tmpFiles.count();i++ )
						{
							if ( QMessageBox::question ( this, "PdfTk-QGUI", tr ( "File to be processed:<br><b>%1</b><br>Continue?" ).arg ( tmpFiles[i] ), QMessageBox::No|QMessageBox::Yes ) == QMessageBox::Yes )
								onBack ( tmpFiles[i] );
							else break;
						}
						break;
					case 11:
						for ( int i = 0;i<tmpFiles.count();i++ )
						{
							if ( QMessageBox::question ( this, "PdfTk-QGUI", tr ( "File to be processed:<br><b>%1</b><br>Continue?" ).arg ( tmpFiles[i] ), QMessageBox::No|QMessageBox::Yes ) == QMessageBox::Yes )
								onStamp ( tmpFiles[i] );
							else break;
						}
						break;
					case 12:
						for ( int i = 0;i<tmpFiles.count();i++ )
						{
							if ( QMessageBox::question ( this, "PdfTk-QGUI", tr ( "File to be processed:<br><b>%1</b><br>Continue?" ).arg ( tmpFiles[i] ), QMessageBox::No|QMessageBox::Yes ) == QMessageBox::Yes )
								onREPAIR ( tmpFiles[i] );
							else break;
						}
						break;
					case 13:
						for ( int i = 0;i<tmpFiles.count();i++ )
						{
							if ( QMessageBox::question ( this, "PdfTk-QGUI", tr ( "File to be processed:<br><b>%1</b><br>Continue?" ).arg ( tmpFiles[i] ), QMessageBox::No|QMessageBox::Yes ) == QMessageBox::Yes )
								onREBUILD ( tmpFiles[i] );
							else break;
						}
						break;
					default:
						cont=false;
						break;
				}
			}
		}
	}
	QStringList txtFiles = arguments.filter ( QRegExp ( ".*.txt$", Qt::CaseInsensitive ) );
	if ( !txtFiles.isEmpty() )
	{
		cont = true;
		while ( cont )
		{
			bool ok;
			QString action = QInputDialog::getItem ( this, "PdfTk-QGUI", tr ( "Select action for files:<br>%1" ).arg ( txtFiles.join ( "\n" ) ), QStringList() <<QApplication::translate ( "PdfTk-QGUI", "Convert to pdf", 0, QApplication::UnicodeUTF8 ) <<QApplication::translate ( "PdfTk-QGUI", "Detect encoding", 0, QApplication::UnicodeUTF8 ), 0, false, &ok );
			if ( !ok ) cont = false;
			else
			{
				if ( action == QApplication::translate ( "PdfTk-QGUI", "Convert to pdf", 0, QApplication::UnicodeUTF8 ) )
				{
					for ( int i = 0;i<txtFiles.count();i++ )
					{
						if ( QMessageBox::question ( this, "PdfTk-QGUI", tr ( "File to be processed:<br><b>%1</b><br>Continue?" ).arg ( txtFiles[i] ), QMessageBox::No|QMessageBox::Yes ) == QMessageBox::Yes )
							onTxt2PdfCore ( txtFiles[i], "", "?" );
						else break;
					}
				}
				else
				{
					for ( int i = 0;i<txtFiles.count();i++ )
					{
						if ( QMessageBox::question ( this, "PdfTk-QGUI", tr ( "File to be processed:<br><b>%1</b><br>Continue?" ).arg ( txtFiles[i] ), QMessageBox::No|QMessageBox::Yes ) == QMessageBox::Yes )
							onTXTConvert ( txtFiles[i] );
						else break;
					}
				}
			}
		}
	}
	if(pdfFiles.isEmpty() && txtFiles.isEmpty()) return 1;
	return 0;
}
void SuslicTk::DebugOutput ( QtMsgType type, const char *msg )
{
	switch ( type )
	{
		case QtDebugMsg:
			fprintf ( stderr, "Debug: %s\n", msg );
			addTextDE ( tr ( "<font color=green>Debug:</font> %1" ).arg ( QApplication::translate ( "PdfTk-QGUI", msg, 0, QApplication::UnicodeUTF8 ) ) );
			break;
		case QtWarningMsg:
			fprintf ( stderr, "Warning: %s\n", msg );
			addTextDE ( tr ( "<font color=yellow>Warning:</font> %1" ).arg ( QApplication::translate ( "PdfTk-QGUI", msg, 0, QApplication::UnicodeUTF8 ) ) );
			break;
		case QtCriticalMsg:
			fprintf ( stderr, "Critical: %s\n", msg );
			addTextDE ( tr ( "<font color=red>Critical:</font> %1" ).arg ( QApplication::translate ( "PdfTk-QGUI", msg, 0, QApplication::UnicodeUTF8 ) ) );
			break;
		case QtFatalMsg:
			fprintf ( stderr, "Fatal: %s\n", msg );
			addTextDE ( tr ( "<font color=red>Fatal:</font> %1" ).arg ( QApplication::translate ( "PdfTk-QGUI", msg, 0, QApplication::UnicodeUTF8 ) ) );
			QMessageBox::critical ( this, "Fatal Error", "Fatal error occurred! Program will be terminated. Debug output will be saved as HOME_DIR/.suslictk/fatal.log" );
			onSaveCrash();
			abort();
	}
}
void SuslicTk::onSaveCrash()
{
	QFile sfile ( QDir::homePath() +"/.suslictk/fatal.log" );
	if ( sfile.open ( QFile::WriteOnly|QFile::Text ) ) QMessageBox::critical ( this, "", "Failed to save log!" );
	else
	{
		QTextStream out ( &sfile );
		out<<DE->toPlainText();
		sfile.close();
	}
}
void SuslicTk::onChDir()
{
	QString new_dir = QFileDialog::getExistingDirectory ( this, tr ( "Select directory" ), !QDir ( lastdir ).exists() ? QDir::homePath() : lastdir );
	if ( !new_dir.isEmpty() )	onSetDir ( new_dir );
}
void SuslicTk::onSelDir ( int i )
{
	lastdir = recDirList[i];
}
void SuslicTk::onSetDir ( QString dir )
{
	qDebug() <<"onSetDir list count"<<recDirList.count();
	if ( !QDir ( dir ).exists() )	lastdir = QDir::homePath();
	else	lastdir = dir;

	if ( recDirList.count() >=10 )	recDirList[0] = lastdir;
	else	recDirList.prepend ( lastdir );
//	recDirList.removeDuplicates();
	recDirList.removeAll ( "" );
	qDebug() <<"onSetDir list count"<<recDirList.count();
	dirEdit->clear();
	dirEdit->insertItems ( 0, recDirList );
	dirEdit->setToolTip ( lastdir );
}
void SuslicTk::onOpenDir()
{
	QString tt = dirEdit->currentText();
	if ( tt != lastdir )	onSetDir ( tt );
	QDesktopServices::openUrl ( QUrl::fromLocalFile ( tt ) );
}
void SuslicTk::addTextTE ( QString text )
{
	TE->setText ( TE->toHtml() + text.replace ( "\n", "<br>" ) );
}
void SuslicTk::addTextPE ( QString text )
{
	PE->setText ( PE->toHtml() + text.replace ( "\n", "<br>" ) +"<br>-----------------------" );
}
void SuslicTk::addTextPEc ( QString text )
{
	PE->setText ( PE->toHtml() + "<b>"+text.replace ( "\n", "<br>" ) +"</b>" );
}
void SuslicTk::addTextDE ( QString text )
{
	DE->setText ( DE->toHtml() + text.replace ( "\n", "<br>" ) );
}

void SuslicTk::keyPressEvent ( QKeyEvent *event )
{
	if ( event->key() == Qt::Key_B ) {onBurst();}
	if ( event->key() == Qt::Key_A ) {onAttach();}
	if ( event->key() == Qt::Key_C ) {onCat();}
	if ( event->key() == Qt::Key_G ) {onDump();}
	if ( event->key() == Qt::Key_D ) {onDecrypt();}
	if ( event->key() == Qt::Key_E ) {onEncrypt();}
	if ( event->key() == Qt::Key_H ) {onHelp();}
	if ( event->key() == Qt::Key_P ) {onPrefs();}
	if ( event->key() == Qt::Key_V ) {onView();}
	if ( event->key() == Qt::Key_U ) {onUnpack();}
	if ( event->key() == Qt::Key_R ) {onREBUILD();}
	if ( event->key() == Qt::Key_S ) {onScriptDlg();}
}

void SuslicTk::onPFinish()
{
	printing = false;
	if ( print->result == 0 )
	{
		TE->setText ( TE->toHtml() +tr ( "<br>Printing finished" ) );
		QMessageBox::information ( this, "", tr ( "Printing finished" ) );
		onView ( print->EFILE, true );
	}
	else
	{
		TE->setText ( TE->toHtml() +tr ( "<br>Printing failed" ) );
	}
}
QString SuslicTk::getDirFromFile ( QString file )
{
	return QFileInfo ( file ).canonicalPath();
}
bool SuslicTk::saveAs ( int i )
{
	QDir *dir = new QDir ( homePDF->absolutePath() +"/logs" );
	if ( !dir->exists() ) {if ( !dir->mkdir ( dir->absolutePath() ) ) {dir = new QDir ( homePDF->homePath() );}}
	bool success = true;
	if ( i == -1 )
	{
		QStringList clearL;
		clearL<<tr ( "Report" ) <<tr ( "pdftk output" ) <<tr ( "Debug" ) <<tr ( "All" );
		bool ok;
		QString cl = QInputDialog::getItem ( this,tr ( "PdfTk-QGUI" ), tr ( "Select field to save:" ),clearL,0,false, &ok );
		if ( !ok ) return false;
		i = clearL.indexOf ( cl );
	}
	////////////////////////////////////////////////////////////////
	if ( i == 0 || i == 3 )
	{
		QString fileName = QFileDialog::getSaveFileName ( this, tr ( "Save as..." ), dir->absolutePath(), "(*.rlog)" );
		if ( !fileName.isEmpty() )
		{
			if ( !fileName.endsWith ( "rlog" ) ) {fileName+=".rlog";}
			if ( !saveFile ( fileName, 0 ) ) success = false;
		}
	}
	if ( i == 1 || i == 3 )
	{
		QString fileName = QFileDialog::getSaveFileName ( this, tr ( "Save as..." ), dir->absolutePath(), "(*.plog)" );
		if ( !fileName.isEmpty() )
		{
			if ( !fileName.endsWith ( "rlog" ) ) {fileName+=".plog";}
			if ( !saveFile ( fileName, 1 ) ) success = false;
		}
	}
	if ( i == 2 || i == 3 )
	{
		QString fileName = QFileDialog::getSaveFileName ( this, tr ( "Save as..." ), dir->absolutePath(), "(*.dlog)" );
		if ( !fileName.isEmpty() )
		{
			if ( !fileName.endsWith ( "dlog" ) ) {fileName+=".dlog";}
			if ( !saveFile ( fileName, 2 ) ) success = false;
		}
	}
	return success;
}
void SuslicTk::onLoadLog()
{
	QDir *dir = new QDir ( homePDF->absolutePath() +"/logs" );
	if ( !dir->exists() ) {dir = new QDir ( homePDF->homePath() );}
	QString fileName = QFileDialog::getOpenFileName ( this, tr ( "Select log file:" ), dir->absolutePath(), "Report (*.rlog);;pdftk (*.plog);;Debug (*.dlog);;All files(*.*)" );
	if ( !fileName.isEmpty() )
	{
		QFile *logf = new QFile ( fileName );
		if ( !logf->open ( QFile::ReadOnly | QFile::Text ) )
		{
			addTextTE ( tr ( "Cannot open file %1:\n%2." ).arg ( fileName ).arg ( logf->errorString() ) );
			qDebug() <<tr ( "Cannot open file %1:\n%2." ).arg ( fileName ).arg ( logf->errorString() );
		}
		else
		{
			QTextStream in ( logf );
			QString ALL = in.readAll();
			if ( fileName.endsWith ( "rlog" ) ) addTextTE ( tr ( "<br>- - - File:%1 - - -<br>%2" ).arg ( fileName ).arg ( ALL ) );
			else if ( fileName.endsWith ( "plog" ) ) addTextPE ( tr ( "<br>- - - File:%1 - - -<br>%2" ).arg ( fileName ).arg ( ALL ) );
			else if ( fileName.endsWith ( "dlog" ) ) addTextDE ( tr ( "<br>- - - File:%1 - - -<br>%2" ).arg ( fileName ).arg ( ALL ) );
			else addTextTE ( tr ( "<br>- - - File:%1 (unknown log) - - -<br>%2" ).arg ( fileName ).arg ( ALL ) );
			logf->close();
		}
	}
}
void SuslicTk::onView ( QString file, bool ask )
{
	bool show = false;
	if ( !ask ) {show = true;}
	if ( ask )
	{

		if ( QMessageBox::question ( this, tr ( "View" ), tr ( "File %1<br>successfully created<br>Do you want to view it in external viewer?" ).arg ( file ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes ) {show = true;}
	}
	if ( file == "" )
	{
		file = QFileDialog::getOpenFileName ( this, tr ( "Select pdf file to view:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
		if ( file.isEmpty() ) return;
		onSetDir ( getDirFromFile ( file ) );
	}
	if ( show )
	{
		if ( viewerBin.isEmpty() )
		{
					QMessageBox::warning ( this ,tr ( "Viewer error" ), tr ( "You have not specified viewer's binary path<br>Please go to Edit->Preferences." ) );
			if ( QMessageBox::question ( this, tr ( "Set viewer path" ), tr ( "Do you want to do it now?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes )
			{
				onPrefs();
			}
		}
		else if (viewerBin == "@native")
		{
			QDesktopServices::openUrl(file);
		}
		else
		{
			ViewerThread *view = new ViewerThread;
			view->FILE = file;
			view->viewer = viewerBin;
			view->start();
		}
	}
}
void SuslicTk::about()
{
	AboutDlg *a = new AboutDlg ( version, this, Qt::SplashScreen );
	a->exec();
}
void SuslicTk::onHelp()
{
	if ( QMessageBox::question ( this, "", tr ( "Do you want to use online help?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes )
	{
		Help* help = new Help ( this, Qt::Window|Qt::WindowSystemMenuHint|Qt::WindowMinMaxButtonsHint, "http" );
		help->show();
	}
	else
	{
		Help* help = new Help ( this, Qt::Window|Qt::WindowSystemMenuHint|Qt::WindowMinMaxButtonsHint, "qrc" );
		help->show();
	}
}
void SuslicTk::onHelpTk()
{
	ht = new HelpTk ( this, Qt::Tool, pHelp, "" );
	ht->show();
}
void SuslicTk::onPrefs()
{
	pdlg = new PrefsDlg ( this, Qt::Tool, version );
	if ( pdlg->exec() == 1 )
	{
		TE->setText ( TE->toHtml() +tr ( "<br>Successfully updated/created configuration file" ) );
		readRC();
	}
	else{TE->setText ( TE->toHtml() +tr ( "<br>No configuration file created!" ) );}
}

void SuslicTk::onPdfList()
{
	QStringList ifiles = QDir ( lastdir ).entryList ( QStringList() <<"*.pdf"<<"*.PDF", QDir::Files|QDir::NoDotAndDotDot, QDir::Name );
	if ( ifiles.count() > 0 )	addTextTE ( tr ( "<br><ul><uh>Pdf files in <b>%1</b></uh><li>%2</ul>" ).arg ( lastdir ).arg ( ifiles.join ( "<li>" ) ) );
	else addTextTE ( tr ( "There are no pdf files in selected directory" ) );
}
void SuslicTk::onClear()
{
	QStringList clearL;
	clearL<<tr ( "Report" ) <<tr ( "pdftk output" ) <<tr ( "Debug" ) <<tr ( "All" );
	bool ok;
	QString cl = QInputDialog::getItem ( this,tr ( "PdfTk-QGUI" ), tr ( "Select field to clear:" ),clearL,0,false, &ok );
	if ( !ok ) return;
	switch ( clearL.indexOf ( cl ) )
	{
		case 0:
			if ( !TE->toPlainText().isEmpty() && QMessageBox::question ( this, tr ( "Save?" ), tr ( "Do you want to save report before clearing?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes )
			{
				bool ok = saveAs ( 0 );
				if ( !ok ) {QMessageBox::critical ( this, tr ( "Error!" ), tr ( "<font color=red>Failed to save!</font>" ) );}
				else TE->setText ( "" );
			}
			else TE->setText ( "" );
			break;
		case 1:
			if ( !PE->toPlainText().isEmpty() && QMessageBox::question ( this, tr ( "Save?" ), tr ( "Do you want to save report before clearing?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes )
			{
				bool ok = saveAs ( 1 );
				if ( !ok ) {QMessageBox::critical ( this, tr ( "Error!" ), tr ( "<font color=red>Failed to save!</font>" ) );}
				else PE->setText ( "" );
			}
			else PE->setText ( "" );
			break;
		case 2:
			if ( !DE->toPlainText().isEmpty() && QMessageBox::question ( this, tr ( "Save?" ), tr ( "Do you want to save report before clearing?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes )
			{
				bool ok = saveAs ( 2 );
				if ( !ok ) {QMessageBox::critical ( this, tr ( "Error!" ), tr ( "<font color=red>Failed to save!</font>" ) );}
				else DE->setText ( "" );
			}
			else DE->setText ( "" );
			break;
		default:
			if ( !TE->toPlainText().isEmpty() && QMessageBox::question ( this, tr ( "Save?" ), tr ( "Do you want to save report before clearing?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes )
			{
				bool ok = saveAs ( 0 );
				if ( !ok ) {QMessageBox::critical ( this, tr ( "Error!" ), tr ( "<font color=red>Failed to save!</font>" ) );}
				else TE->setText ( "" );
			}
			else TE->setText ( "" );
			if ( !PE->toPlainText().isEmpty() && QMessageBox::question ( this, tr ( "Save?" ), tr ( "Do you want to save report before clearing?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes )
			{
				bool ok = saveAs ( 1 );
				if ( !ok ) {QMessageBox::critical ( this, tr ( "Error!" ), tr ( "<font color=red>Failed to save!</font>" ) );}
				else PE->setText ( "" );
			}
			else PE->setText ( "" );
			if ( !DE->toPlainText().isEmpty() && QMessageBox::question ( this, tr ( "Save?" ), tr ( "Do you want to save report before clearing?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes )
			{
				bool ok = saveAs ( 2 );
				if ( !ok ) {QMessageBox::critical ( this, tr ( "Error!" ), tr ( "<font color=red>Failed to save!</font>" ) );}
				else DE->setText ( "" );
			}
			else DE->setText ( "" );
			break;
	}
}
void SuslicTk::ondelRC()
{
	QFile file ( homePDF->absolutePath() +"/suslictk.rc" );
	if ( !file.remove() ) {TE->setText ( TE->toHtml() +tr ( "<br>Error removing configuration file:<br>Maybe not enough rights or already removed" ) );}
	else{TE->setText ( TE->toHtml() +tr ( "<br>Configuration file successfully removed" ) );}
}

void SuslicTk::readSettings()
{
	setMinimumSize ( 600, 500 );
	QSize size = set.value ( "MainSize", QSize ( 600, 500 ) ).toSize();
	QPoint movep = set.value ( "MainMove", QPoint ( 200, 200 ) ).toPoint();
	recDirList = set.value ( "Recent Directories", QStringList() ).toStringList();
	move ( movep );
	resize ( size );
	setWindowIcon ( QIcon ( ":/main" ) );
	index = new int[6];
	for ( int i=0;i<6;i++ ) {index[i] = -1;}
	onSetDir ( lastdir );
}
void SuslicTk::closeEvent ( QCloseEvent *event )
{
	qDebug() <<"LastDir = "<<lastdir ;
	set.setValue ( "Directory", lastdir );
	set.setValue ( "MainSize", size() );
	set.setValue ( "MainMove", pos() );
	set.setValue ( "AskChDir", askdir );
	set.setValue ( "Recent Directories", recDirList );
	QFile *scrf = new QFile ( homePDF->absolutePath() +"/scripts.rc" );
	if ( !scrf->open ( QFile::WriteOnly | QFile::Text ) )
	{
		QMessageBox::warning ( this, tr ( "PdfTk-QGUI" ),tr ( "Cannot open file %1:\n%2." ).arg ( scrf->fileName() ).arg ( scrf->errorString() ) );
	}
	else
	{
		QTextStream out ( scrf );
		for ( int i=0;i< ( scriptNameL.count() < scriptTextL.count() ? scriptNameL.count() : scriptTextL.count() );i++ )
		{
			out<<"[SCRIPTNAME]\n"<<scriptNameL[i]<<"\n[SCRIPTBODY]\n"<<scriptTextL[i]<<"\n";
		}
		scrf->close();
	}
	if ( !recScriptList.isEmpty() )
	{
//		recScriptList.removeDuplicates();
		if ( recScriptList.count() == 1 )	set.setValue ( "RecScript1", recScriptList[0] );
		if ( recScriptList.count() >= 2 )	set.setValue ( "RecScript2", recScriptList[1] );
	}
	event->accept();
}
bool SuslicTk::saveFile ( const QString &fileName, int browsernum )
{
	QFile file ( fileName );
	if ( !file.open ( QFile::WriteOnly | QFile::Text ) )
	{
		QMessageBox::warning ( this, tr ( "PdfTk-QGUI" ), tr ( "Cannot write to file %1:\n%2." ).arg ( fileName ).arg ( file.errorString() ) );
		return false;
	}

	QTextStream out ( &file );
	QApplication::setOverrideCursor ( Qt::WaitCursor );
	switch ( browsernum )
	{
		case 0: out << TE->toHtml(); break;
		case 1: out << PE->toHtml(); break;
		case 2: out << DE->toHtml(); break;
		default: break; //should never happen
	}
	QApplication::restoreOverrideCursor();

	statusBar()->showMessage ( tr ( "Report saved" ), 2000 );
	file.close();
	return true;
}
QMessageBox* SuslicTk::makeMessage ( QString title, QString text, QString inftext, QString detailedtext, QMessageBox::Icon icon, QMessageBox::StandardButtons buttons, QMessageBox::StandardButton defaultButton )
{
	QMessageBox *msgBox = new QMessageBox ( icon, title, text, buttons, this );
	msgBox->setDefaultButton ( defaultButton );
	if ( !inftext.isEmpty() ) msgBox->setInformativeText ( inftext );
	if ( !detailedtext.isEmpty() ) msgBox->setDetailedText ( detailedtext );
	return msgBox;
}
SuslicTk::~SuslicTk()
{
	destroy();
}
