/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef SUSLICTK_H
#define SUSLICTK_H
#include "About.h"
#include "Attach.h"
#include "Burst.h"
#include "Cat.h"
#include "HelpTk.h"
//#include "Encrypt.h"
#include "Encoding.h"
#include "SelectFiles.h"
#include "PrefsDlg.h"
#include "Select.h"
#include "Rebuild.h"
#include "Help.h"
#include "HTMLpreview.h"
#include "Dump.h"
#include "Rem.h"
#include "AutoF.h"
#include "ScriptDlg.h"

#include <QPainter>
#include <QThread>

#include <QDesktopServices>

#include <QCleanlooksStyle>
#include <QPlastiqueStyle>
#include <QMotifStyle>
#if QT_VERSION >= 0x040500
#include <QGtkStyle>
#endif

#include <QSettings>
#include <QMainWindow>
#include <QCloseEvent>
#include <QTextStream>
#include <QScrollArea>
#include <QSplashScreen>
#include <QTranslator>
#include <QtNetwork>
#include <QProgressDialog>
#include <QTimer>
//#include <QErrorMessage>

#include <stdio.h>
#include <stdlib.h>
class QAction;
class QMenu;
class QTextEdit;
static QString version = "0.1.9-2";
class PrintThread: public QThread
{
	public:
		QString EFILE, IFILE;
		int ori, res, colM, ord;
		int result;
		bool html;
		void run() {result = exec();};
		int exec()
		{
			QFile txtfile ( IFILE );
			if ( !txtfile.open ( QFile::ReadOnly|QFile::Text ) ) {qDebug() <<"Failed to open file";return 1;}
			QTextStream txtstr ( &txtfile );
			QString arr = txtstr.readAll();
			QPrinter PDFprinter;
			qDebug() <<"ori = "<<ori;
			if ( ori == 1 ) PDFprinter.setOrientation ( QPrinter::Landscape );
			if ( colM == 1 ) PDFprinter.setColorMode ( QPrinter::GrayScale );
			if ( ord == 1 ) PDFprinter.setPageOrder ( QPrinter::LastPageFirst );
			PDFprinter.setResolution ( res );
			PDFprinter.setOutputFormat ( QPrinter::PdfFormat );
			PDFprinter.setOutputFileName ( EFILE );
			//PDFprinter.setPaperSize(QPrinter::A4);
			QTextEdit tmpEdit;
			tmpEdit.setText ( arr );
			tmpEdit.print ( &PDFprinter );
			return 0;
		};
};
class ViewerThread: public QThread
{
	public:
		int result;
		QString FILE, viewer;
		void run() {result = exec();};
		int exec()
		{
			QProcess view;
			view.start ( viewer+" \""+FILE+"\"" );
			view.waitForStarted();
			view.waitForFinished ( -1 );
			return view.exitCode();
		};
};
class SuslicTk:public QMainWindow
{
		Q_OBJECT

	public:
		SuslicTk(QStringList args );
		~SuslicTk();
		QString pdftkBin, pHelp;
		void readRC();
		bool AutoFind();
		bool tkPresent;
		void DebugOutput ( QtMsgType type, const char *msg );
		QAction *argAct;
	public slots:
		int processArguments();
	protected:
		void closeEvent ( QCloseEvent *event );
		void keyPressEvent ( QKeyEvent *event );
		QProcess *proc;
		QDir *homePDF;
	private slots:
		void onPrefs();
		bool saveAs(int i = -1);
		void about();
		void onAttach(QString ifile = "");
		void onBurst(QString ifile = "");
		void onCat(QStringList ifiles = QStringList());
		void onDump(QString ifile = "");
		void onDecrypt(QString ifile = "");
		void onEncrypt(QString ifile = "");
		void onUnpack(QString ifile = "");
		void onUpdate(QString ifile = "");
		void onClear();
		void onGenerate(QString ifile = "");
		void onBack(QString ifile = "");
		void onStamp(QString ifile = "");
		void onHelp();
		void onHelpTk();
		void onCheckUpdate();
		void ondelRC();
		void onPdfList();

		void onScript(QString script, QString name);
		void onFavRecScripts();
		void onScriptDlg();
		void onScriptDlgClose(int i);

		void onView ( QString file = "", bool ask=false );
		void onREPAIR(QString ifile = "");
		void onREBUILD(QString ifile = "");
		void onRemTemp ( bool autom=false, QString id = "" );
		void onLoadLog();
		void onPFinish();
		void onTXT2PDF();
		void onTXTConvert(QString ifile = "");
		void onHTML2PDF();
		void httpStateChanged ( int state );
		void httpRequestFinished ( int id, bool error );
		void httpDataReadProgress ( int done, int total );
		void httpResponseHR ( const QHttpResponseHeader &resp );
		void progressCancelled();
		void compareVersions();
		void on_AutoF_finished ( int exitCode, QProcess::ExitStatus exitStatus );
		void on_AutoF_read();
		void onSendRequestSRC ( );
		void onSendRequestBIN ( );

		void onChDir();
		void onSelDir(int);
		void onOpenDir();
		void onSetDir(QString dir);
		void addTextTE(QString text);
		void addTextPE(QString text);
		void addTextPEc(QString text);
		void addTextDE(QString text);
	private:
		QSettings set;
		bool askdir, showEFmes;
		QString adressSRC, adressBIN, commentBIN;
		QStringList arguments;
		AutoF *AF;
		ScriptDlg *scdlg;
		QProcess *autof;
		QFile *tmphtmlfile, *updatefile;
		QClipboard *urlclip;
		QString tmphtm, tmp1;
		bool request, htmlloc;
		int ifupdate;
		QPrinter *HTMLprinter;
		QString lastdir;
		PrintThread *print;
		int httpGetId, orient, resol, colorM, order;
		QString httpDataStr;
		QProgressDialog *prog_com;
		QProgressDialog *prDlg;
		QProgressBar *prDlgBar;
		QUrl *checkurl;
		QHttp *http;
		QFile *setf;
		int *index;
		QString viewerBin, backColor, textColor, fontSize, fontType, cssF;
		int bgNum, favScriptNum;
		QStringList imgDB, scriptNameL, scriptTextL, favScriptList, recScriptList, recDirList;
		bool passcorr, printing, hprint;

		QWidget *centralWidget;
		QVBoxLayout *verticalLayout_4;
		QTabWidget *tabWidget;
		QWidget *tab;
		QVBoxLayout *verticalLayout;
		QTextBrowser *TE;
		QWidget *tab_2;
		QVBoxLayout *verticalLayout_2;
		QTextBrowser *PE;
		QWidget *tab_3;
		QVBoxLayout *verticalLayout_3;
		QTextBrowser *DE;
		QHBoxLayout *horizontalLayout;
		QLabel *label;
		QComboBox *dirEdit;
		QToolButton *chdirTool, *opdirTool;

		Attach *att;
		Burst *bur;
		Cat *catt;
		HelpTk *ht;
		PrefsDlg *pdlg;
		Encrypt *encr;
		QMenu *fileMenu;
		QMenu *toolsMenu;
		QMenu *scriptMenu;
		QMenu *helpMenu;
		QMenu *editMenu;
		QMenu *Privacy;
		QMenu *Decoration;
		QMenu *Data;
		QMenu *Pages;
		QMenu *Files;
		QMenu *Converter;
		QMenu *RecentScripts;
		QToolBar *fileToolBar, *toolsToolBar, *helpToolBar, *scriptToolBar;

		QAction *saveAsAct;
		QAction *loadLog;
		QAction *exitAct;
		QAction *aboutAct;
		QAction *helpAct;
		QAction *updateAct;
		QAction *helpTkAct;
		QAction *clearAct;
		QAction *prefsAct;
		QAction *delRCAct;
		QAction *delTmpAct;

		QAction *actionView;
		QAction *actionCAT;
		QAction *actionATTACH;
		QAction *actionUNPACK;
		QAction *actionBURST;
		QAction *actionFILL;
		QAction *actionBACKGROUND;
		QAction *actionSTAMP;
		QAction *actionDUMP;
		QAction *actionUPDATE;
		QAction *actionGENERATE;
		QAction *actionENCRYPT;
		QAction *actionDECRYPT;
		QAction *actionREPAIR;
		QAction *actionREBUILD;
		QAction *actionTXT2PDF;
		QAction *actionTXTConvert;
		QAction *actionHTML2PDF;

		QAction *actionList;

		QAction **actionFavScripts;
		QAction *actionRecScript1, *actionRecScript2;
		QAction *actionScriptDlg;

		void createActions();
		void createMenus();
		void createToolBars();
		void createStatusBar();
		void readSettings();
		void HTMLloadFinished ( bool ok );
		QString checkPath ( QString filePath, QString id, bool* change = 0 );
		QString checkSaveFile(QString file);
		bool copyEFILE ( QString tmpFile, QString EFILE );
		QString getDirFromFile ( QString filename );
		bool maybeSave();
		void onSendRequest ( QString url );
		bool saveFile ( const QString &fileName, int browsernum );
		void onRecScriptListChanged();
		void onSaveCrash();
		void onBurstCore ( QString filePDF, QString prefix, int zeros, QString pass );
		bool onEncryptCore(QString ifile, QString ofile, QString encr);
		bool onRepairCore(QString ifile, QString ofile);
		void onTxt2PdfCore(QString ifile, QString ofile, QString utf);

		QMessageBox* makeMessage(QString title, QString text, QString inftext, QString detailedtext, QMessageBox::Icon icon, QMessageBox::StandardButtons buttons, QMessageBox::StandardButton defaultButton);

		void onTxtScript(QString string);
		void onBurstScript(QString string);
		void onEncryptScript(QString string);

		void initCentral();
		void retranslateUi();
};

#endif
