/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "suslictk.h"

bool SuslicTk::AutoFind()
{
	QString find_util;
	if ( QMessageBox::question ( this, "Auto Find", tr ( "Use <b>locate</b> instead of <b>find</b>?<br>If not sure, select Yes" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes ) find_util = "locate";
	else find_util = "find / -executable -name";
	AF->show();
	connect ( AF, SIGNAL ( stop() ), autof, SLOT ( kill() ) );
	qDebug() <<"AutoF started: "<<QString ( find_util+" pdftk" );
	autof->start ( find_util+" pdftk" );
	if ( !autof->waitForStarted() )
	{
		TE->setText ( TE->toHtml() +tr ( "<br><font color=red><b>Auto search failed!</b></font>" ) );
		return false;
	}
	else
	{
		qDebug() <<"autof running";
	}
	connect ( autof, SIGNAL ( readyRead() ), this, SLOT ( on_AutoF_read() ) );
	connect ( autof, SIGNAL ( finished ( int , QProcess::ExitStatus ) ), this, SLOT ( on_AutoF_finished ( int , QProcess::ExitStatus ) ) );
	return true;
}
void SuslicTk::on_AutoF_finished ( int exitCode, QProcess::ExitStatus  exitStatus )
{
	qDebug() <<"Auto Find:\n\tExitCode: "<<exitCode<<"\n\tExitStatus: "<<exitStatus;
	AF->close();
	if ( exitStatus != QProcess::NormalExit )
	{
		TE->setText ( TE->toHtml() +tr ( "<br><font color=red><b>Auto search crashed or stopped! pdftk not found</b></font>" ) );
	}
	QString reS = autof->readAll();
	QStringList reSL = reS.split ( "\n", QString::SkipEmptyParts );
	reSL = reSL.filter ( "pdftk" );
	if ( reSL.count() <=0 )
	{
		TE->setText ( TE->toHtml() +tr ( "<br><font color=red><b>Auto search failed! pdftk not found</b></font>" ) );
		tkPresent = false;
		return;
	}
	else
	{
		SDlg *sel = new SDlg ( this, Qt::Tool, &reSL, "radio", tr ( "Select pdftk binary." ) );
		if ( sel->exec() == 1 )
		{
			pdftkBin = reSL[0];
			QFile *file = new QFile ( homePDF->absolutePath() +"/suslictk.rc" );
			if ( !file->open ( QFile::WriteOnly | QFile::Text ) )
			{
				QMessageBox::warning ( this, tr ( "PdfTk-QGUI" ),tr ( "Cannot write to file %1:\n%2." ).arg ( file->fileName() ).arg ( file->errorString() ) );
				tkPresent = false;
				return;
			}
			QTextStream out ( file );
			QApplication::setOverrideCursor ( Qt::WaitCursor );
			out << "[version]\n"+version+"\n[pdftkbinary]\n"+pdftkBin +"\n[viewer]\n"+viewerBin+"\n[lookandfeel]\nCleanlooks";
			file->close();
			tkPresent = true;
		}
		else
		{
			TE->setText ( TE->toHtml() +tr ( "<br>Auto search canceled" ) );
			tkPresent = false;
		}
	}
}
void SuslicTk::on_AutoF_read()
{
	QString read = autof->readLine();
	qDebug() <<"read="<<read;
	AF->writeOut ( read );
}
