/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "suslictk.h"

void SuslicTk::initCentral()
{
	centralWidget = new QWidget ( this );
	verticalLayout_4 = new QVBoxLayout ( centralWidget );
	verticalLayout_4->setObjectName ( QString::fromUtf8 ( "verticalLayout_4" ) );
	tabWidget = new QTabWidget ( centralWidget );
	tabWidget->setObjectName ( QString::fromUtf8 ( "tabWidget" ) );
	tabWidget->setLayoutDirection ( Qt::LeftToRight );
	tabWidget->setTabPosition ( QTabWidget::East );
	tabWidget->setTabShape ( QTabWidget::Rounded );
	tab = new QWidget();
	tab->setObjectName ( QString::fromUtf8 ( "tab" ) );
	verticalLayout = new QVBoxLayout ( tab );
	verticalLayout->setObjectName ( QString::fromUtf8 ( "verticalLayout" ) );
	TE = new QTextBrowser ( tab );
	TE->setObjectName ( QString::fromUtf8 ( "TE" ) );

	verticalLayout->addWidget ( TE );

	tabWidget->addTab ( tab, QString() );
	tab_2 = new QWidget();
	tab_2->setObjectName ( QString::fromUtf8 ( "tab_2" ) );
	verticalLayout_2 = new QVBoxLayout ( tab_2 );
	verticalLayout_2->setObjectName ( QString::fromUtf8 ( "verticalLayout_2" ) );
	PE = new QTextBrowser ( tab_2 );
	PE->setObjectName ( QString::fromUtf8 ( "PE" ) );

	verticalLayout_2->addWidget ( PE );

	tabWidget->addTab ( tab_2, QString() );
	tab_3 = new QWidget();
	tab_3->setObjectName ( QString::fromUtf8 ( "tab_3" ) );
	verticalLayout_3 = new QVBoxLayout ( tab_3 );
	verticalLayout_3->setObjectName ( QString::fromUtf8 ( "verticalLayout_3" ) );
	DE = new QTextBrowser ( tab_3 );
	DE->setObjectName ( QString::fromUtf8 ( "DE" ) );

	verticalLayout_3->addWidget ( DE );

	tabWidget->addTab ( tab_3, QString() );

	verticalLayout_4->addWidget ( tabWidget );

	horizontalLayout = new QHBoxLayout();
	horizontalLayout->setObjectName ( QString::fromUtf8 ( "horizontalLayout" ) );
	label = new QLabel ( centralWidget );
	label->setObjectName ( QString::fromUtf8 ( "label" ) );

	horizontalLayout->addWidget ( label );

	dirEdit = new QComboBox ( centralWidget );
	dirEdit->setObjectName ( QString::fromUtf8 ( "dirEdit" ) );
	dirEdit->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Preferred);
	connect(dirEdit, SIGNAL(activated(int)), this, SLOT(onSelDir(int)));
	horizontalLayout->addWidget ( dirEdit );

	chdirTool = new QToolButton ( centralWidget );
	chdirTool->setObjectName ( QString::fromUtf8 ( "chdirTool" ) );
	connect ( chdirTool, SIGNAL ( clicked() ), this, SLOT ( onChDir() ) );

	horizontalLayout->addWidget ( chdirTool );

	opdirTool = new QToolButton ( centralWidget );
	opdirTool->setObjectName ( QString::fromUtf8 ( "opdirTool" ) );
	connect ( opdirTool, SIGNAL ( clicked() ), this, SLOT ( onOpenDir() ) );

	horizontalLayout->addWidget ( opdirTool );

	verticalLayout_4->addLayout ( horizontalLayout );

	retranslateUi();
}

void SuslicTk::retranslateUi()
{
	tabWidget->setTabText ( tabWidget->indexOf ( tab ), QApplication::translate ( "SuslicTk", "Report", 0, QApplication::UnicodeUTF8 ) );
	tabWidget->setTabText ( tabWidget->indexOf ( tab_2 ), QApplication::translate ( "SuslicTk", "pdftk output", 0, QApplication::UnicodeUTF8 ) );
	tabWidget->setTabText ( tabWidget->indexOf ( tab_3 ), QApplication::translate ( "SuslicTk", "Debug", 0, QApplication::UnicodeUTF8 ) );
	label->setText ( QApplication::translate ( "SuslicTk", "Active directory:", 0, QApplication::UnicodeUTF8 ) );
	chdirTool->setIcon ( QIcon ( qApp->style()->standardIcon(QStyle::SP_DirOpenIcon) ) );
	chdirTool->setToolTip ( tr ( "Select folder" ) );
	opdirTool->setIcon ( QIcon ( ":/opfolder") );
	opdirTool->setToolTip ( tr ( "Open selected folder" ) );
}

void SuslicTk::createActions()
{
	saveAsAct = new QAction ( tr ( "&Save log" ), this );
	saveAsAct->setIcon ( QIcon ( qApp->style()->standardIcon(QStyle::SP_DialogSaveButton) ) );
	saveAsAct->setStatusTip ( tr ( "Save report" ) );
	connect ( saveAsAct, SIGNAL ( triggered() ), this, SLOT ( saveAs() ) );

	loadLog = new QAction ( tr ( "&Load log" ), this );
	loadLog->setIcon ( QIcon ( ":/load" ) );
	loadLog->setStatusTip ( tr ( "Load previously saved log file" ) );
	connect ( loadLog, SIGNAL ( triggered() ), this, SLOT ( onLoadLog() ) );

	argAct = new QAction ( tr ( "&Actions" ), this );
	argAct->setIcon ( QIcon ( ":/load1" ) );
	argAct->setStatusTip ( tr ( "Open dialog to select action" ) );
	connect ( argAct, SIGNAL ( triggered() ), this, SLOT ( processArguments() ) );

	actionView = new QAction ( tr ( "&View pdf" ), this );
	actionView->setIcon ( QIcon ( ":/addall" ) );
	actionView->setStatusTip ( tr ( "View selected pdf file in external viewer" ) );
	connect ( actionView, SIGNAL ( triggered() ), this, SLOT ( onView() ) );

	clearAct = new QAction ( tr ( "&Clear" ), this );
	clearAct->setIcon ( QIcon ( ":/brush" ) );
	clearAct->setStatusTip ( tr ( "Clear report field" ) );
	connect ( clearAct, SIGNAL ( triggered() ), this, SLOT ( onClear() ) );

	exitAct = new QAction ( tr ( "E&xit" ), this );
	exitAct->setIcon ( QIcon ( ":/exit" ) );
	exitAct->setShortcut ( tr ( "Ctrl+Q" ) );
	exitAct->setStatusTip ( tr ( "Exit the application" ) );
	connect ( exitAct, SIGNAL ( triggered() ), this, SLOT ( close() ) );

	aboutAct = new QAction ( tr ( "&About" ), this );
	aboutAct->setIcon ( QIcon ( ":/main" ) );
	aboutAct->setStatusTip ( tr ( "Show the application's About box" ) );
	connect ( aboutAct, SIGNAL ( triggered() ), this, SLOT ( about() ) );

	helpAct = new QAction ( tr ( "&Help" ), this );
	helpAct->setIcon ( QIcon ( qApp->style()->standardIcon(QStyle::SP_DialogHelpButton) ) );
	helpAct->setStatusTip ( tr ( "Show application's help" ) );
	connect ( helpAct, SIGNAL ( triggered() ), this, SLOT ( onHelp() ) );

	helpTkAct = new QAction ( tr ( "&PdfTk Help" ), this );
	helpTkAct->setIcon ( QIcon ( ":/helptk" ) );
	helpTkAct->setStatusTip ( tr ( "Show pdftk help" ) );
	connect ( helpTkAct, SIGNAL ( triggered() ), this, SLOT ( onHelpTk() ) );

	updateAct = new QAction ( tr ( "&Check for updates" ), this );
	updateAct->setIcon ( QIcon ( ":/updates" ) );
	updateAct->setStatusTip ( tr ( "Check for updates" ) );
	connect ( updateAct, SIGNAL ( triggered() ), this, SLOT ( onCheckUpdate() ) );

	prefsAct = new QAction ( tr ( "&Preferences" ), this );
	prefsAct->setIcon ( QIcon ( ":/prefs" ) );
	prefsAct->setStatusTip ( tr ( "Edit preferences" ) );
	connect ( prefsAct, SIGNAL ( triggered() ), this, SLOT ( onPrefs() ) );

	delRCAct = new QAction ( tr ( "&Delete RC" ), this );
	delRCAct->setIcon ( QIcon ( ":/trash" ) );
	delRCAct->setStatusTip ( tr ( "Delete configuration file" ) );
	connect ( delRCAct, SIGNAL ( triggered() ), this, SLOT ( ondelRC() ) );

	actionList = new QAction ( tr ( "&Get PDF List" ), this );
	actionList->setStatusTip ( tr ( "Adds list of pdf files to report field" ) );
	actionList->setIcon ( QIcon ( ":/pdf" ) );
	connect ( actionList, SIGNAL ( triggered() ), this, SLOT ( onPdfList() ) );

	actionTXT2PDF = new QAction ( tr ( "&TXT->PDF" ), this );
	//actionTXT2PDF->setIcon ( QIcon ( ":/convert" ) );
	actionTXT2PDF->setStatusTip ( tr ( "Make pdf from txt file" ) );
	connect ( actionTXT2PDF, SIGNAL ( triggered() ), this, SLOT ( onTXT2PDF() ) );

	actionTXTConvert = new QAction ( tr ( "&Encoding" ), this );
	//actionTXT2PDF->setIcon ( QIcon ( ":/convert" ) );
	actionTXTConvert->setStatusTip ( tr ( "Detect/Change text file's encoding" ) );
	connect ( actionTXTConvert, SIGNAL ( triggered() ), this, SLOT ( onTXTConvert() ) );

	actionHTML2PDF = new QAction ( tr ( "&HTML->PDF" ), this );
	//actionHTML2PDF->setIcon ( QIcon ( ":/convert" ) );
	actionHTML2PDF->setStatusTip ( tr ( "Make pdf from HTML document" ) );
	connect ( actionHTML2PDF, SIGNAL ( triggered() ), this, SLOT ( onHTML2PDF() ) );

	delTmpAct = new QAction ( tr ( "Delete &tmp" ), this );
	delTmpAct->setIcon ( QIcon ( ":/bintemp" ) );
	delTmpAct->setStatusTip ( tr ( "Delete temporary files" ) );
	connect ( delTmpAct, SIGNAL ( triggered() ), this, SLOT ( onRemTemp() ) );

	actionScriptDlg = new QAction ( tr ( "&Scripts Dialog" ), this );
	actionScriptDlg->setIcon ( QIcon ( ":/script" ) );
	actionScriptDlg->setStatusTip ( tr ( "Open dialog to manage scripts" ) );
	connect ( actionScriptDlg, SIGNAL ( triggered() ), this, SLOT ( onScriptDlg() ) );

	actionFavScripts = new QAction*[5];
	for ( int i=0;i<5;i++ )
	{
		actionFavScripts[i] = new QAction ( "FavScript", this );
		actionFavScripts[i]->setVisible ( false );
		connect ( actionFavScripts[i], SIGNAL ( triggered() ), this, SLOT ( onFavRecScripts() ) );
	}

	actionRecScript1 = new QAction ( tr ( "None" ), this );
	actionRecScript1->setVisible ( false );
	connect ( actionRecScript1, SIGNAL ( triggered() ), this, SLOT ( onFavRecScripts() ) );
	//qDebug()<<"actionRecScript created";

	actionRecScript2 = new QAction ( tr ( "None" ), this );
	actionRecScript2->setVisible ( false );
	connect ( actionRecScript2, SIGNAL ( triggered() ), this, SLOT ( onFavRecScripts() ) );

	actionCAT = new QAction ( tr ( "&Catenate documents" ), this );
	actionATTACH = new QAction ( tr ( "&Attach Files" ), this );
	actionUNPACK = new QAction ( tr ( "&Unpack Files" ), this );
	actionBURST = new QAction ( tr ( "Split into &pages" ), this );
	actionFILL = new QAction ( tr ( "&Fill Form" ), this );
	actionBACKGROUND = new QAction ( tr ( "Add &Background" ), this );
	actionSTAMP = new QAction ( tr ( "Add &Stamp" ), this );
	actionDUMP = new QAction ( tr ( "&Get File Info" ), this );
	actionUPDATE = new QAction ( tr ( "Update File &Info" ), this );
	actionGENERATE = new QAction ( tr ( "Ge&nerate FDF" ), this );
	actionENCRYPT = new QAction ( tr ( "&Encrypt PDF" ), this );
	actionDECRYPT = new QAction ( tr ( "&Decrypt PDF" ), this );
	actionREBUILD = new QAction ( tr ( "&Rebuild PDF" ), this );
	actionREPAIR = new QAction ( tr ( "&Repair PDF" ), this );
////////////////////////////
	actionCAT->setStatusTip ( tr ( "Catenates pages from input PDF's to create a new PDF" ) );
	actionCAT->setIcon ( QIcon ( ":/cat" ) );
	actionATTACH->setStatusTip ( tr ( "Packs arbitrary files into a PDF using PDF's file attachment features" ) );
	actionATTACH->setIcon ( QIcon ( ":/attach" ) );
	actionUNPACK->setStatusTip ( tr ( "Copies all of the attachments from the input PDF" ) );
	actionUNPACK->setIcon ( QIcon ( ":/unpack" ) );
	actionBURST->setStatusTip ( tr ( "Splits PDF document into individual pages" ) );
	actionBURST->setIcon ( QIcon ( ":/burst" ) );
	actionFILL->setStatusTip ( tr ( "Fills PDF's form fields with the data from an FDF file, XFDF file" ) );
	actionFILL->setIcon ( QIcon ( ":/fill" ) );
	actionBACKGROUND->setStatusTip ( tr ( "Applies a PDF watermark to the background of a single input PDF" ) );
	actionBACKGROUND->setIcon ( QIcon ( ":/pdfback" ) );
	actionSTAMP->setStatusTip ( tr ( "Like background, but it overlays the stamp PDF page on top of PDF's document pages" ) );
	actionSTAMP->setIcon ( QIcon ( ":/stamp" ) );
	actionDUMP->setStatusTip ( tr ( "Reads and reports various statistics, metadata etc. of input PDF" ) );
	actionDUMP->setIcon ( QIcon ( ":/info" ) );
	actionUPDATE->setStatusTip ( tr ( "Updates statistics, metadata etc. of input PDF from file or stdin" ) );
	actionUPDATE->setIcon ( QIcon ( ":/update" ) );
	actionGENERATE->setStatusTip ( tr ( "Generates FDF file from input PDF file" ) );
	actionGENERATE->setIcon ( QIcon ( ":/fdf" ) );
	actionENCRYPT->setStatusTip ( tr ( "Encrypt PDF" ) );
	actionENCRYPT->setIcon ( QIcon ( ":/encr" ) );
	actionDECRYPT->setStatusTip ( tr ( "Decrypt  input PDF" ) );
	actionDECRYPT->setIcon ( QIcon ( ":/decr" ) );
	actionREBUILD->setStatusTip ( tr ( "Rebuild pdf (change page order, page orientation, etc.)" ) );
	actionREBUILD->setIcon ( QIcon ( ":/rebuild" ) );
	actionREPAIR->setStatusTip ( tr ( "Try to repair broken pdf" ) );
	actionREPAIR->setIcon ( QIcon ( ":/repair" ) );
///////////////////////////////
	connect ( actionCAT, SIGNAL ( triggered() ), this, SLOT ( onCat() ) );
	connect ( actionATTACH, SIGNAL ( triggered() ), this, SLOT ( onAttach() ) );
	connect ( actionUNPACK , SIGNAL ( triggered() ), this, SLOT ( onUnpack() ) );
	connect ( actionBURST, SIGNAL ( triggered() ), this, SLOT ( onBurst() ) );
	//actionFILL;
	connect ( actionBACKGROUND, SIGNAL ( triggered() ), this, SLOT ( onBack() ) );
	connect ( actionSTAMP, SIGNAL ( triggered() ), this, SLOT ( onStamp() ) );
	connect ( actionDUMP, SIGNAL ( triggered() ), this, SLOT ( onDump() ) );
	connect ( actionUPDATE, SIGNAL ( triggered() ), this, SLOT ( onUpdate() ) );
	connect ( actionGENERATE, SIGNAL ( triggered() ), this, SLOT ( onGenerate() ) );
	connect ( actionENCRYPT, SIGNAL ( triggered() ), this, SLOT ( onEncrypt() ) );
	connect ( actionDECRYPT, SIGNAL ( triggered() ), this, SLOT ( onDecrypt() ) );
	connect ( actionREBUILD, SIGNAL ( triggered() ), this, SLOT ( onREBUILD() ) );
	connect ( actionREPAIR, SIGNAL ( triggered() ), this, SLOT ( onREPAIR() ) );
	//connect ( actionFill, SIGNAL ( triggered() ), this, SLOT ( onFill() ) );
/////////////////////////////////
	connect ( prDlg, SIGNAL ( canceled() ), this, SLOT ( progressCancelled() ) );
}
void SuslicTk::createMenus()
{
	fileMenu = menuBar()->addMenu ( tr ( "&File" ) );
	fileMenu->addAction ( argAct );
	fileMenu->addAction ( loadLog );
	fileMenu->addAction ( saveAsAct );
	fileMenu->addSeparator();
	fileMenu->addAction ( exitAct );

	editMenu = menuBar()->addMenu ( tr ( "&Edit" ) );
	editMenu->addAction ( prefsAct );
	editMenu->addAction ( delRCAct );
	editMenu->addAction ( delTmpAct );
	editMenu->addSeparator();
	editMenu->addAction ( clearAct );

	toolsMenu = menuBar()->addMenu ( tr ( "&Tools" ) );
	Pages = new QMenu ( tr ( "&Pages" ), toolsMenu );
	Pages->setIcon ( QIcon ( ":/pages" ) );
	Files = new QMenu ( tr ( "&Files" ), toolsMenu );
	Files->setIcon ( QIcon ( ":/files" ) );
	Data = new QMenu ( tr ( "&Data" ), toolsMenu );
	Data->setIcon ( QIcon ( ":/data" ) );
	Decoration = new QMenu ( tr ( "&Decoration" ), toolsMenu );
	Decoration->setIcon ( QIcon ( ":/decor" ) );
	Privacy = new QMenu ( tr ( "P&rivacy" ), toolsMenu );
	Privacy->setIcon ( QIcon ( ":/privacy" ) );
	Converter = new QMenu ( tr ( "&Converters" ), toolsMenu );
	Converter->setIcon ( QIcon ( ":/convert" ) );
	toolsMenu->addMenu ( Pages );
	toolsMenu->addMenu ( Files );
	toolsMenu->addMenu ( Data );
	toolsMenu->addMenu ( Decoration );
	toolsMenu->addMenu ( Privacy );
	toolsMenu->addMenu ( Converter );
	toolsMenu->addSeparator();
	toolsMenu->addAction ( actionView );
	toolsMenu->addAction ( actionREPAIR );

	Pages->addAction ( actionCAT );
	Pages->addAction ( actionBURST );
	Pages->addAction ( actionREBUILD );
	Files->addAction ( actionATTACH );
	Files->addAction ( actionUNPACK );
	Data->addAction ( actionList );
	Data->addAction ( actionDUMP );
	Data->addAction ( actionUPDATE );
	Data->addAction ( actionGENERATE );
	//Data->addAction ( actionFILL );
	Decoration->addAction ( actionBACKGROUND );
	Decoration->addAction ( actionSTAMP );
	Privacy->addAction ( actionENCRYPT );
	Privacy->addAction ( actionDECRYPT );
	Converter->addAction ( actionTXTConvert );
	Converter->addAction ( actionTXT2PDF );
	Converter->addAction ( actionHTML2PDF );

	scriptMenu = menuBar()->addMenu ( tr ( "&Scripts" ) );
	RecentScripts = new QMenu ( tr ( "Recent Scripts" ), scriptMenu );
	scriptMenu->addMenu ( RecentScripts );
	RecentScripts->addAction ( actionRecScript2 );
	RecentScripts->addAction ( actionRecScript1 );
	scriptMenu->addSeparator();
	scriptMenu->addAction ( actionScriptDlg );
	scriptMenu->addSeparator()->setText ( tr ( "Favorite Scripts:" ) );
	for ( int i=0;i<5;i++ ) scriptMenu->addAction ( actionFavScripts[i] );

	helpMenu = menuBar()->addMenu ( tr ( "&Help" ) );
	helpMenu->addAction ( helpAct );
	helpMenu->addAction ( helpTkAct );
	helpMenu->addAction ( updateAct );
	helpMenu->addSeparator();
	helpMenu->addAction ( aboutAct );
}

void SuslicTk::createToolBars()
{
	fileToolBar = addToolBar ( tr ( "File" ) );
	fileToolBar->addAction ( saveAsAct );
	fileToolBar->addAction ( prefsAct );
	fileToolBar->addAction ( clearAct );
	fileToolBar->addAction ( delTmpAct );

	toolsToolBar = addToolBar ( tr ( "Tools" ) );
	toolsToolBar->addAction ( actionCAT );
	toolsToolBar->addAction ( actionBURST );
	toolsToolBar->addAction ( actionREBUILD );
	toolsToolBar->addAction ( actionDUMP );
	toolsToolBar->addAction ( actionDECRYPT );
	toolsToolBar->addAction ( actionENCRYPT );

	scriptToolBar = addToolBar ( tr ( "Scripts" ) );
	scriptToolBar->addAction ( actionScriptDlg );

	helpToolBar = addToolBar ( tr ( "Help" ) );
	helpToolBar->addAction ( helpAct );
	helpToolBar->addAction ( updateAct );
}

void SuslicTk::createStatusBar()
{
	statusBar()->showMessage ( tr ( "Ready" ) );
}
